local rainbowcolors = { -- Rainbow Table, feel free to use yourself if you credit EeveeEuphoria/Ibly!
"35",
"34",
"56",
"55",
"54",
"53",
"52",
"51",
"50",
"74",
"73",
"188",
"96",
"112",
"122",
"255",
"123",
"124",
"134",
"135",
"136",
"137",
"150",
"151",
"152",
"167",
"166",
"165",
"184",
"183",
"182",
"181",
"202",
"203",
"204",
"210",
"211",
"212"
}

local function indexOfNumberThing(array, value)
    for i, v in ipairs(array) do
        if v.hudnumber == value then
            return i
        end
    end
    return nil
end

--customhud.SetupFont("KHFNT", 0, 3)
local Font1 = "KHFNT"
local Font2 = "KHMNT"

if VERSION < 2 then
    Font1 = "CHFNT"
    Font2 = "CHMNT"
end

Fontlib.setFontAttr(Font1, {spacewidth=2}) -- font i made :)
Fontlib.setFontAttr(Font2, {spacewidth=3}) -- the Nixdorf 8810 M15 font

local function khaos(v, player)
    if not player.khaos then v.storetable = nil return end
    if not player.khaoseffects then v.storetable = nil return end
    if not tkk_Enabled then v.storetable = nil return end
    local khaosoptions = {
        tkk_HUD_Position = player.khaosoptions.tkk_HUD_Position,
        tkk_HUD = player.khaosoptions.tkk_HUD,
        tkk_HUD_Text_Border = player.khaosoptions.tkk_HUD_Text_Border
    }

    if ((consoleplayer and consoleplayer.spectator) or replayplayback) and tonumber(CV_FindVar("tkk_HUD_Override").value) then
        --override settings with the consoleplayer's settings
        khaosoptions = {
            tkk_HUD_Position = tonumber(CV_FindVar("tkk_HUD_Position").value),
            tkk_HUD = tonumber(CV_FindVar("tkk_HUD").value),
            tkk_HUD_Text_Border = tonumber(CV_FindVar("tkk_HUD_Text_Border").value)
        }
    end

    local EXTRAFLAG = V_SNAPTOBOTTOM
    if khaosoptions.tkk_HUD_Position then
        EXTRAFLAG = V_SNAPTOTOP
    end

    local funnyindexer = 0

    -- khaos hud text --
    for key, value in pairs(player.khaostext) do
        funnyindexer = $ + 1
        local yoffset = 0
        local realy = 164-(12*(funnyindexer-1))
        if khaosoptions.tkk_HUD_Position then
            yoffset = -5 - player.khaos.HUDMoveUp
            realy = 28+(12*(funnyindexer-1))
        else
            yoffset = 0 + player.khaos.HUDMoveUp
        end

        local FLAGZ = value.flags
        if FLAGZ != nil then
            FLAGZ = $|EXTRAFLAG
        end
        if khaosoptions.tkk_HUD_Text_Border and VERSION >= 2 then
            --v.drawString(160, realy-yoffset - 2, value.text, FLAGZ, "thin-center")
            local silly = Fontlib.cachePatchWidth(v, value.text, Font1, 0)
            --border width & height: 11
            local sillyx = 160
            sillyx = $1-silly.linewidth/2
            local skincolorer = value.color or SKINCOLOR_WHITE
            v.draw(sillyx-11, realy-yoffset-3, v.cachePatch("KH_LEFTBORDER"), EXTRAFLAG|value.trans<<V_ALPHASHIFT, v.getColormap(TC_DEFAULT, skincolorer))
            v.draw(sillyx+silly.linewidth, realy-yoffset-3, v.cachePatch("KH_RIGHTBORDER"), EXTRAFLAG|value.trans<<V_ALPHASHIFT, v.getColormap(TC_DEFAULT, skincolorer))
            v.drawFill(sillyx, realy-yoffset-3, silly.linewidth, 11, skincolors[skincolorer].ramp[11]|EXTRAFLAG|value.trans<<V_ALPHASHIFT)
        end

        Fontlib.drawString(v, 160, realy-yoffset - 3, value.text, {font = Font1, alpha = value.trans, extraflags = EXTRAFLAG}, "center")
    end

    if not khaosoptions.tkk_HUD return end -- don't run the rest of the logic from here

    if not v.intialized then
        v.XCenterVirtual = 320/2
        v.intialized = true
    end

    if player.khaos.UniEffectText and player.khaos.UniTextPopUpFade < 10 then
        Fontlib.drawString(v, 160, 54-10, ("\x87" + player.khaos.UniEffectTextBuffer), {font = Font2, alpha = player.khaos.UniTextPopUpFade}, "center")
        Fontlib.drawString(v, 160, 68-10, player.khaos.UniEffectSubTextBuffer, {font = Font1, alpha = player.khaos.UniTextPopUpFade}, "center")
        --v.drawString(160, 59, "\x87" + player.khaos.UniEffectTextBuffer, V_SNAPTOBOTTOM|player.khaos.UniTextPopUpFade<<V_ALPHASHIFT, "center")
        --v.drawString(160, 68, player.khaos.UniEffectSubTextBuffer, V_SNAPTOBOTTOM|player.khaos.UniTextPopUpFade<<V_ALPHASHIFT, "thin-center")
    end

    -- New HUD Logic --
    local TotalEffects = 0
    for key, value in pairs(player.khaoseffects) do
        if value.icon or (not value.icon and value.name == "Roulette") then
            TotalEffects = $ + 1
        end
    end
    TotalEffects = $ + 2

    v.storetable = v.storetable or {} -- use effect.hudnumber
    local sillyindex = 0
    funnyindexer = 0 -- reset the indexer, we're using it again, because i accidentally used the same variable name, and i'm too lazy to fix it

    -- now we move on to the placement logic, so we can move everything around.
    for key, value in pairs(player.khaoseffects) do
        if value.icon or (not value.icon and value.name == "Roulette") then
            local tableplace = indexOfNumberThing(v.storetable, value.hudnumber)
            local fx = KhaosEffectsTable[value.effect] --DO NOT MODIFY THIS
            local gap = 0
            if funnyindexer > 0 then
                gap = 2 * funnyindexer
            end

            if not tableplace then -- we don't exist yet!
                local yset = (fx.name == "Roulette" and 30) or 0
                table.insert(v.storetable, {hudnumber = value.hudnumber, x = (funnyindexer * 20) + gap, gotox = (funnyindexer * 20) + gap, yoffset = yset, removeme = value.removeme})
            end

            if tableplace and (value.removeme < 1) then -- skip over if we don't have tableplace, it shouldn't hurt
                tableplace = v.storetable[tableplace]

                --adjust desired X position

                tableplace.x = (funnyindexer * 20) + gap

                if tableplace.gotox < tableplace.x then
                    tableplace.gotox = $ + 1
                elseif tableplace.gotox > tableplace.x then
                    tableplace.gotox = $ - 1
                end

                funnyindexer = $ + 1
            end
        end
    end

    local TotalLength = (funnyindexer * 20) + ((funnyindexer-1) * 2)
    local screenwidth = 320
    local XCenter = ((screenwidth/2) - (TotalLength/2))

    v.NeoXCenterVirtual = v.NeoXCenterVirtual or XCenter

    if v.NeoXCenterVirtual != XCenter then
        if v.NeoXCenterVirtual < XCenter then
            v.NeoXCenterVirtual = $ + 1
        elseif v.NeoXCenterVirtual > XCenter then
            v.NeoXCenterVirtual = $ - 1
        end
    end

    local theypos = 173
    local markiplier = 1 --i don't even watch him, it's just a funny variable name
    if khaosoptions.tkk_HUD_Position then
        theypos = 8
        markiplier = -1
    end
    -- change if HUD is on the top.

    -- now we render everything out, after doing that centering math
    for key, value in pairs(player.khaoseffects) do
        local tableplace = indexOfNumberThing(v.storetable, value.hudnumber)
        if value.icon or (not value.icon and value.name == "Roulette") then
            if tableplace and (value.removeme < 1) then
                tableplace = v.storetable[tableplace]
                local fx = KhaosEffectsTable[value.effect]
                local border = "NEUTRAL"
                if fx.etype == "good" then
                    border = "GOOD"
                elseif fx.etype == "bad" then
                    border = "BAD"
                elseif fx.etype == "bees" then
                    border = "BEEBORDER"
                end

                local spritz = "KH_PLACEHOLDER"
                if value.icon then
                    spritz = value.icon
                end

                if not fx.noblink and fx.duration > 0 and (value.duration*TICRATE - value.timer < 3*TICRATE and (value.timer % 2 == 0)) then
                    spritz = "KH_NOTHINGSHAKE"
                    if VERSION >= 2 then --randomchance didn't exist in v2.1 blua? wtf?
                        if v.RandomChance(FRACUNIT/2 + FRACUNIT/4) then
                            spritz = "KH_STATICSHAKE1"
                            if v.RandomChance(FRACUNIT/2) then
                                spritz = "KH_STATICSHAKE2"
                            end
                        end
                    end
                    border = "NEUTRALSHAKE"

                    if fx.etype == "good" then
                        border = "GOODSHAKE"
                    elseif fx.etype == "bad" then
                        border = "BADSHAKE"
                    end
                end

                if VERSION >= 2 then
                    border = "KH_" + $
                else
                    border = "CH_" + $
                end

                if tableplace.yoffset > 0 then
                    tableplace.yoffset = $ - 1
                end

                v.draw(v.NeoXCenterVirtual+tableplace.gotox+2, theypos+2+(markiplier*tableplace.yoffset), v.cachePatch(spritz), EXTRAFLAG) -- icon
                v.draw(v.NeoXCenterVirtual+tableplace.gotox, theypos+(markiplier*tableplace.yoffset), v.cachePatch(border), EXTRAFLAG) -- border
                if not value.notimer then v.drawString(v.NeoXCenterVirtual+tableplace.gotox+1, theypos+1, (value.duration*TICRATE - value.timer)/TICRATE + 1, V_30TRANS|EXTRAFLAG, "thin") end -- timer, duh.
            elseif tableplace and value.removeme then
                tableplace = v.storetable[tableplace]
                tableplace.removeme = value.removeme
                local fx = KhaosEffectsTable[value.effect]
                if not tableplace.SetX then -- keep that effect icon in it's place
                    tableplace.gotox = v.NeoXCenterVirtual + tableplace.x
                    tableplace.SetX = true
                end
                local spritz = "KH_PLACEHOLDER"
                if value.icon then
                    spritz = value.icon
                end

                local scaler = min(FRACUNIT, (FRACUNIT/value.removeme)*8)
                local DyingCenter = (16 * scaler)/2 -- wouldn't that be called a morgue
                local Plus = DyingCenter + DyingCenter

                v.drawScaled((tableplace.gotox+2)*FRACUNIT, (theypos+2)*FRACUNIT, scaler, v.cachePatch(spritz), EXTRAFLAG|((value.removeme-1)/4)<<V_ALPHASHIFT) -- icon
            end
        end
    end

    for index, value in ipairs(v.storetable) do
        if value.removeme >= 39 then
            table.remove(v.storetable, index)
        end
    end

    if #player.khaoseffects == 0 then
        v.storetable = {} -- reset this, just for in case we didn't remove everything.
    end

    local textpopupcolor = "\x85"
    if #player.khaosblacklist == 0 then
        textpopupcolor = "\x83"
    elseif #player.khaosblacklist <= 2 then
        textpopupcolor = "\x82"
    end

    if player.khaos.TextPopUpFade < 10 then
        local AdderText = (tonumber(CV_FindVar("tkk_Amplify").value) and ", Amplify Active!") or ""
        local sillything = "thin-center"
        if VERSION < 2 then
            sillything = "center"
        end
        local extraflags = (VERSION < 2 and V_ALLOWLOWERCASE) or 0
        if player.khaos.respawnmeinchief then v.drawString(160, 180, "\x82" + "KHAOS SYSTEM HAS REBOOTED!", extraflags|V_SNAPTOBOTTOM|player.khaos.TextPopUpFade<<V_ALPHASHIFT, sillything) end
        v.drawString(160, 188, textpopupcolor + "Tails' Khaos Kontraption v" + TailsKK.version + AdderText, extraflags|V_SNAPTOBOTTOM|player.khaos.TextPopUpFade<<V_ALPHASHIFT, sillything)
    end
end

local function timerhud(v,player)
    if not player.khaos then return end
    if not tkk_Enabled return end

    local khaosoptions = {
        tkk_HUD_Position = player.khaosoptions.tkk_HUD_Position,
        tkk_HUD = player.khaosoptions.tkk_HUD,
        tkk_HUD_Timer_Bar = player.khaosoptions.tkk_HUD_Timer_Bar,
        tkk_HUD_Timer_Color = player.khaosoptions.tkk_HUD_Timer_Color
    }

    if ((consoleplayer and consoleplayer.spectator) or replayplayback) and tonumber(CV_FindVar("tkk_HUD_Override").value) then
        --override settings with the consoleplayer's settings
        khaosoptions = {
            tkk_HUD_Position = tonumber(CV_FindVar("tkk_HUD_Position").value),
            tkk_HUD = tonumber(CV_FindVar("tkk_HUD").value),
            tkk_HUD_Timer_Bar = tonumber(CV_FindVar("tkk_HUD_Timer_Bar").value),
            tkk_HUD_Timer_Color = tonumber(CV_FindVar("tkk_HUD_Timer_Color").value)
        }
    end

    if not khaosoptions.tkk_HUD or not khaosoptions.tkk_HUD_Timer_Bar then return end
    --if leveltime < 236 or player.exiting then return end  -- PF_FINISHED
    local width = v.width()/v.dupx() --320
    local height = 3
    local x = 0
    local y = 200-height
    local SNAP = V_SNAPTOBOTTOM

    local MaxTime = player.khaos.WaitTime or 10*TICRATE

    if khaosoptions.tkk_HUD_Position then
        y = 0
        SNAP = V_SNAPTOTOP
    end

    if not v.color then
        v.color = 0
    end

    local screenwidth = 320
    local XCenter = ((screenwidth/2) - (width/2))

    -- player.khaos.timer > player.khaos.WaitTime

    local soup = FixedDiv(player.khaos.timer, MaxTime)
    local souper = FixedMul(width, soup)


    if khaosoptions.tkk_HUD_Timer_Color == 1 then
        local tlength = #rainbowcolors
        v.color = $ + 1
        if v.color > tlength then
            v.color = 1
        end
        v.colorset = tonumber(rainbowcolors[v.color])
        v.altcolor = v.colorset + 5
    elseif khaosoptions.tkk_HUD_Timer_Color == 2 or VERSION < 2 then
        v.colorset = 36
        v.altcolor = v.colorset + 5
        if VERSION < 2 then
            v.colorset = 132
            v.altcolor = v.colorset + 5
        end
    else
        --v.colorset = 36
        --v.altcolor = v.colorset + 5
        if VERSION >= 2 then
            v.colorset = skincolors[player.skincolor].ramp[8]
            v.altcolor = skincolors[player.skincolor].ramp[13]
        else
            v.colorset = 132
            v.altcolor = v.colorset + 5
        end
    end

    v.drawFill(XCenter, y, width, height, 31|SNAP)
    v.drawFill(XCenter, y, souper, height, v.altcolor|SNAP) -- filling timer bar, before the two pixel gap
    v.drawFill(XCenter, y, souper-2, height, v.colorset|SNAP) -- the actual color for the timer bar


    if TailsKK.ueTimer != nil and not TailsKK.ueTimerDisabled then
        local soup2 = FixedDiv(TailsKK.ueTimer, TailsKK.ueTimerMax)
        local souper2 = FixedMul(width, soup2)
        local theadditioner = -3
        if khaosoptions.tkk_HUD_Position then
            theadditioner = 4 --idk why it has to be one more
        end
        --85 for srb2kart
        v.colorset2 = 53
        if VERSION < 2 then
            v.colorset2 = 85
        end
        v.drawFill(XCenter, y+theadditioner, width, height-1, 31|SNAP)
        v.drawFill(XCenter, y+theadditioner, souper2, height-1, v.colorset2+5|SNAP) -- filling timer bar, before the two pixel gap
        v.drawFill(XCenter, y+theadditioner, souper2-2, height-1, v.colorset2|SNAP) -- the actual color for the timer bar
    end
end

local function darkvisionhud(v, player)
    if not player.khaos then return end
    if not TailsKK then return end
    if not tkk_Enabled return end
	if v.TransBack == nil
		v.TransBack = 10
	end

	if player.khaos.DarkenedVisionNow then
		if ((leveltime % 2 == 0) and (tonumber(CV_FindVar("tkk_Amplify").value) and v.TransBack > 2)) or (not tonumber(CV_FindVar("tkk_Amplify").value) and v.TransBack > 3) then
			v.TransBack = $ - 1
		end
	else
		if (leveltime % 2 == 0) and v.TransBack < 10 then
			v.TransBack = $ + 1
		end
	end
	v.TransFlags = v.TransBack<<V_ALPHASHIFT

    if v.TransBack < 10 then
	    v.drawScaled(0,200 , FRACUNIT*800, v.cachePatch("KH_DARK"), v.TransFlags|V_SNAPTOLEFT|V_SNAPTOTOP)
    end
end

local function dvdhud(v, player)
    if not player.khaos then return end
    if not player.khaos.DVDHud then v.initialized = false return end
    if not tkk_Enabled return end
    if v.initialized and ((v.gaywidth != v.width()/v.dupx()) or (v.gayheight != v.height()/v.dupy())) then -- someone changed their resolution settings, reset everything because i'm too lazy to do proper math
        v.initialized = false
        return
    end
    if not v.initialized then
        v.direction = "bottomright"
        if VERSION >= 2 then
            v.xpos = v.RandomRange(1, 75)
            v.ypos = v.RandomRange(1, 40)
            if v.RandomChance(FRACUNIT/2) then
                v.direction = "topright"
            end
        else
            v.xpos = 50
            v.ypos = 50
        end
        v.gaywidth = v.width()/v.dupx() -- true width without multipler
        v.gayheight = v.height()/v.dupy() -- true height without multipler

        v.logo = v.cachePatch("KH_DVDLOGO")
        v.dvdwidth = 190
        v.dvdheight = 85

        if player.khaos.HDDVD then -- random chance for HD DVD logo instead
            v.logo = v.cachePatch("KH_HDDVD")
            v.dvdwidth = 213
            v.dvdheight = 52
        end

        v.initialized = true
    end

    local directioneerX = {["topright"] = 1, -- quackulate the math needed, it'll go either postive or negative
    ["topleft"] = -1,
    ["bottomright"] = 1,
    ["bottomleft"] = -1}
    local directioneerY = {["topright"] = -1,
    ["topleft"] = -1,
    ["bottomright"] = 1,
    ["bottomleft"] = 1}

    local invertX = {["topright"] = "topleft",
    ["topleft"] = "topright",
    ["bottomright"] = "bottomleft",
    ["bottomleft"] = "bottomright"}
    local invertY = {["topright"] = "bottomright",
    ["topleft"] = "bottomleft",
    ["bottomright"] = "topright",
    ["bottomleft"] = "topleft"}

    if not player.khaos.Freezer then
        v.xpos = $ + directioneerX[v.direction]
        v.ypos = $ + directioneerY[v.direction]
    end

    if v.xpos + v.dvdwidth - v.gaywidth >= 0 or v.xpos <= 0 then
        v.direction = invertX[v.direction]
    end

    if v.ypos + v.dvdheight - v.gayheight >= 0 or v.ypos <= 0 then
        v.direction = invertY[v.direction]
    end

    v.draw(v.xpos, v.ypos, v.logo, V_SNAPTOTOP|V_SNAPTOLEFT)
end

local function textboxhud(v, player) -- button prompt: 190, 101
    if not TailsKK then return end
    if not player.khaos then return end
    if not tkk_Enabled return end
    if not player.khaos.TextBoxStation then
        v.Page = nil
        return
    end
    if not v.Page then
        v.Page = player.khaos.TextBoxPage
        v.Text2Change = 0
        v.YAdjust = 0
        -- text position, page position
        v.Box = {{1, 1}, {2, 1}, {3, 1}, {4, 1}, {1, 2}}  -- text position, page position
        --v.Box5 = {1, 2}
    end

    if v.Page != player.khaos.TextBoxPage then
        v.YAdjust = $ - 3
        if v.YAdjust < -9 then
            v.Text2Change = $ + 1
            v.TextChangeNow = true
            v.YAdjust = 0
        end
    end

    local YMan = 68
    local Y5Text = 2
    if v.Text2Change < 4 then
        YMan = $ + v.YAdjust
        if v.Page != player.khaos.TextBoxPage then
            Y5Text = 0
        end
    end

    if v.TextChangeNow then
        if v.Text2Change < 5 then
            for key, value in pairs(v.Box) do
                value[1] = $ + 1
                if value[1] > 4 then
                    value[1] = 1
                    value[2] = $ + 1
                end
            end
        else
            v.Page = player.khaos.TextBoxPage
            v.Text2Change = 0
        end
        v.TextChangeNow = false
    end

    local Texter = player.khaos.TextBoxStation

    local Texter1 = TailsKK.TextBoxTable[Texter][v.Box[1][2]][v.Box[1][1]]
    local Texter2 = TailsKK.TextBoxTable[Texter][v.Box[2][2]][v.Box[2][1]]
    local Texter3 = TailsKK.TextBoxTable[Texter][v.Box[3][2]][v.Box[3][1]]
    local Texter4 = TailsKK.TextBoxTable[Texter][v.Box[4][2]][v.Box[4][1]]
    local Texter5 = ""
    if TailsKK.TextBoxTable[Texter][v.Box[5][2]] then
        Texter5 = TailsKK.TextBoxTable[Texter][v.Box[5][2]][v.Box[5][1]]
    end

    local extraflags = (VERSION < 2 and V_ALLOWLOWERCASE) or 0

    v.drawString(121, YMan+(0*9), Texter1, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(1*9), Texter2, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(2*9), Texter3, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(3*9), Texter4, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(4*9)+Y5Text, Texter5, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")

    --[[
    local character, flipped = v.getSprite2Patch(player.mo.skin, Spriter, false, Framer, Rotater)
    local colormap = v.getColormap(player.mo.skin, player.skincolor)
    local flags = nil
    if flipped == true then
        flags = V_FLIP
    end

    v.drawScaled(160*FRACUNIT, (totalyoffset*FRACUNIT) + (70*FRACUNIT), FRACUNIT, character, flags, colormap)]]

    local colormap = v.getColormap("sonic", player.skincolor) -- first value used to be player.mo.skin
    local sillybox = "KHTXA0"
    if VERSION < 2 then
        sillybox = "CHTXA0"
    end
    v.draw(112, 57, v.cachePatch(sillybox), player.khaos.TextBoxFader<<V_ALPHASHIFT, colormap)

    if VERSION >= 2 then
        local buttonspriter = "TLB_N"
        if player.khaos.HoldAccelerate then
            buttonspriter = "TLB_NB"
        end

        v.draw(197, 105, v.cachePatch(buttonspriter), player.khaos.TextBoxFader<<V_ALPHASHIFT) --TODO: REPOSITION ME TO A BETTER LOCATION
    end

end

local ConfettiTable = {
{"CNFBA0", "CNFBB0", "CNFBC0", "CNFBD0", "CNFBE0", "CNFBF0", "CNFBG0", "CNFBH0"},
{"GNFBA0", "GNFBB0", "GNFBC0", "GNFBD0", "GNFBE0", "GNFBF0", "GNFBG0", "GNFBH0"},
{"GNFTA0", "GNFTB0", "GNFTC0", "GNFTD0", "GNFTE0", "GNFTF0", "GNFTG0", "GNFTH0"},
{"GNFTI0", "GNFTJ0", "GNFTK0", "GNFTL0", "GNFTM0", "GNFTN0", "GNFTO0", "GNFTP0"},
{"GNFTQ0", "GNFTR0", "GNFTS0", "GNFTT0", "GNFTU0", "GNFTV0", "GNFTW0", "GNFTX0"},
{"GNFTY0", "GNFTZ0", "GNFT00", "GNFT10", "GNFT20", "GNFT30", "GNFT40", "GNFT50"},
}

local RareConfetti = {"WBSCA0", "WBSCB0", "WBSCC0", "WBSCD0", "WBSCE0", "WBSCF0", "WBSCG0", "WBSCH0", "WBSCI0", "WBSCJ0", "WBSCK0", "WBSCL0", "WBSCM0", "WBSCN0", "WBSCO0", "WBSCP0", "WBSCQ0", "WBSCR0", "WBSCS0", "WBSCT0", "WBSCU0", "WBSCV0", "WBSCW0", "WBSCX0", "WBSCY0", "WBSCZ0", "WBSC00", "WBSC10", "WBSC20", "WBSC30", "WBSC40", "WBSC50", "WBSC60", "WBSC70", "WBSC80", "WBSC90", "WBSCa0", "WBSCb0", "WBSCc0", "WBSCd0", "WBSCe0", "WBSCf0", "WBSCg0", "WBSCh0", "WBSCi0", "WBSCj0", "WBSCk0"}


local function yourewinner(v, player)
    if not player.khaos then v.animator = nil return end
    if not tkk_Enabled v.animator = nil return end

    if not v.animator then
        v.animator = {}
        --v.timer = 0
    end

    v.gaywidth = v.width()/v.dupx() -- true width without multipler
    v.gayheight = v.height()/v.dupy() -- true height without multipler
    --v.timer = $ + 1
    --if y + height surpasses gay height, then delete it from the table

    local divisor = 5
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        divisor = 2
    end

    if player.khaos.yourewinner and (leveltime % divisor) == 0 then
        local snable = {spr = v.RandomRange(1, #ConfettiTable), x = v.RandomRange(1, v.gaywidth), y = v.RandomRange(-32, -64), xoffset = 0, xdir = 1, frame = 1}
        if v.RandomChance(FRACUNIT/399) then
            snable.pichu = true -- :3c
        end
        table.insert(v.animator, snable)
        -- x = v.RandomRange(1, v.gaywidth), y = v.RandomRange(-32, -64)

    end

    for index, value in ipairs(v.animator) do
        local spritertable = ConfettiTable[value.spr]
        if value.pichu then
            spritertable = RareConfetti
        end
        local framer = spritertable[value.frame]


        if (leveltime % 5 == 0) or value.pichu then
            value.frame = $ + 1
        end

        if value.frame > #spritertable then
            value.frame = 1
            value.xdir = -$
        end

        if value.frame == #spritertable / 2 then
            value.xdir = -$
        end

        if value.xdir == 1 then
            value.xoffset = $ + 1
        else
            value.xoffset = $ - 1
        end

        value.y = $ + 1

        v.draw(value.x+value.xoffset, value.y, v.cachePatch(framer))


        if value.y > v.gayheight + 32 then
            table.remove(v.animator, index)
        end
    end

end

local function ipadkid(v, player)
    if not player.khaos then return end
    if not tkk_Enabled return end
    v.Smooth = v.Smooth or 20

    v.gaywidth = v.width()/v.dupx() -- true width without multipler
    v.gayheight = v.height()/v.dupy() -- true height without multipler
    --320, 200
    --384, 216
    v.x = 0
    v.y = 0
    if v.gaywidth != 320 or v.gayheight != 200 then -- different resolution, account for this
        v.x = 320 - v.gaywidth
        v.y = (200 - v.gayheight)/2 -- ??? why though
    end

    if (leveltime % 2) == 0 then -- makes this slightly slower as to be more perceptible. making it too slow just makes it look bad though
        if player.khaos.ipadkid then
            if v.Smooth > 1 then
                v.Smooth = $ - 1
            end
        else
            if v.Smooth < 20 then
                v.Smooth = $ + 1
            end
        end
    end

    if v.Smooth != 20 then
        v.drawFill(v.x, v.y, (v.gaywidth/3)/v.Smooth, v.gayheight)
        v.drawFill(v.gaywidth - (v.gaywidth/3)/v.Smooth, v.y, (v.gaywidth/3)/v.Smooth, v.gayheight) -- there doesn't seem to be any non-horrificily jank way to make this work consistently across aspect ratios. so fuck it, i'm not doing that!
    end
end

-- layer order, top of the list is the back, bottom is the front
hud.add(timerhud, "game")
hud.add(khaos, "game")
hud.add(darkvisionhud, "game")
hud.add(dvdhud, "game")
hud.add(yourewinner, "game")
hud.add(ipadkid, "game")
hud.add(textboxhud, "game")
