local TailsKK = {version = "1.0.0",
            versiontable = {1, 0, 0}} -- main version, sub version, patch version

TailsKK.attributions = {
{"EeveeEuphoria/Ibly", "Creator"},
{"Varren/sprkizard", "l_fontlib.lua for SRB2"},
{"Tatsuru", "BootlegAttract function, from mb.srb2.org/addons/slot-machine.59"},
{"Andy Cuccaro", "Tux 3D Model"},
{"Sonic Team Jr.", "Sprites from Sonic Robo Blast 2"},
{"int10h.org", "Nixdorf 8810 M15 font"},
{"amperbee", "Advice and help from the Kart Krew Dev & SRB2 discord guilds, along with sample code for Black Hole."},
{"nia", "Playtester, and providing transparent sprites for PowerMac G4. \x82Website\x80: nia.dog"},
{"Princess Fluffles", "Playtester"},
{"ChrisFurry", "Logo for this mod. \x82Website\x80: chrisfurry.github.io"},
{"kiophen", "3D Sega Saturn render used for promotional material. \x82Website\x80: mileshouse.neocities.org"}
}

--[[
                 _____      _ _     _
                /__   \__ _(_) |___( )
                  / /\/ _` | | / __|/
                 / / | (_| | | \__ \
                 \/_  \__,_|_|_|___/
              /\ /\ |__   __ _  ___  ___
             / //_/ '_ \ / _` |/ _ \/ __|
            / __ \| | | | (_| | (_) \__ \
            \/  \/|_|_|_|\__,_|\___/|___/_   _
     /\ /\___  _ __ | |_ _ __ __ _ _ __ | |_(_) ___  _ __
    / //_/ _ \| '_ \| __| '__/ _` | '_ \| __| |/ _ \| '_ \
   / __ \ (_) | | | | |_| | | (_| | |_) | |_| | (_) | | | |
   \/  \/\___/|_| |_|\__|_|  \__,_| .__/ \__|_|\___/|_| |_|
                                  |_|

This is a from-the-ground-up rewrite of the chaos script, originally made for SRB2 (SRB2: Chaotic Edition) and SRB2Kart (SRB2Khaos).
I've made this to allow for mod support (see TKK-Mod-Example-lua.txt), and cleaned up a lot of the sloppy code I made from years ago. I've overhauled how effects are applied, the HUD system, and the settings system to be more reliable, readable, and generally more netgame-safe. This is an overall improvement I hope, and should be the basis for my chaos mods for more years to come.
]]

--[[ !! Reusability Notice !!

    - This mod is marked as reusable, meaning you can take this mod and modify it any way you want.
        - However, do consider that this mod is extendable, allowing you to add your own effects! I'd recommend going that avenue first.
    - However, I don't want the mod to be "maintained" unless I am absent.
	- Any elements found in this mod are reusable, assuming credit is given to appropriate authors if it's not my work. This includes the two fonts utilized with this mod.

]]

--[[BUG FIXES TO DO:
    - [ ] The dash panels that take you up on Gravtech Dimension get replaced by Wacky Textures. What textures are those?

    - [ ] Look at replay "khaos v0.8 stuck in portal hell"
        - [ ] Since the respawn system is fucked sometimes, maybe have something that forcibly teleports the player if they're stuck for more than 10 seconds?
            - Have a HUD text notification that tells the player this happened.
            - Could set the player respawn state to RESPAWNST_NONE.
            - Or, force teleport the player to player.respawn.pointx and y and z.

    - [ ] Splitscreen *kinda* works, but needs some refinement.
        - Will fix this after release.
        - [ ] Force the HUD position "top" for the top-screen player, regardless of preferences.
            - Should be easy to do... if I can detect for split-screen in the first place.
        - I think the current players are represented by displayplayer[1] and so on. So... compare those, see which one is which?
            - Maybe just ask for help in the discord...
        - Haven't tested 2P splitscreen, only replay splitscreen.
        - Effects like Darkened Vision are completely fucked.
            - And the DVD logo also acts really weird.
        - Of course both players will have the HUD positioned the exact same, will need to fix that...
            - And >2 splitscreen will definitely get fucky results too.

    - [ ] Check what happens when this is added mid-game, when players are actually playing.
        - If something breaks, split off "PlayerSpawn" and make it it's own thing.

    - [?] Get things to work in reverse gravity
        - (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP)
        - [?] Supposedly Firework was made to work in Chaotic Edition, double check that.
            - Kinda? It immediately flips when your gravity flips. Maybe keep that?
        - [x] "Marked for Death" also needs fixing probably.
        - [x] "the pizza is aggressive" will spawn on the ceiling, so, reverse that.

    - [ ] ULTIMATE SOLUTION TO FIX REPLAYS... I HOPE:
        - Make a netvar table that stores whether players should have everything running, use "ValidityCheck" for this.
        - Everything that currently uses ValidityCheck will reference this.
        - Replays will get the NetVar, and I HOPE this fucking works.
            - Might not fix the broken nature of replays in the first place, but it'll hopefully keep the RNG tables aligned maybe...?
            - If not, say fuck it and use that alternative RNG library someone made, in combination with this.

    - [ ] Insta-Item applies to the... egg prisons???? What the actual fuck?
        - Do they count as players...?

    - [?] Insta-Item sometimes leaves behind item boxes when on a dedicated server.
        - Fixed by putting the fluttertimer logic in playerthink... I hope.

    - [?] If you die with a text box, you just get stuck.
        - Maybe fixed now that I've redone the respawn checks?

    - [ ] Sometimes the pizza doesn't hit the player. Might have something to do with my new code, or it being re-applied?

]]


--[[ Effects to do:
missing from chaotic edition: (marked with [p] means it's in the previous version of this script)
    - No Abilities
        - Import from SRB2Khaos
        - It's just "No Drifting" there
        - Also disable the use of items and rings here
    - Busted Controller
    - PRESS X OR GET HIT
        - Rename this to "Simon Says", because that's just silly. And make the gimmick be see if simon says, y'know.
        - Just make it use a combo of keys the player has access to.
            - Make it Brake, Accelerate, Drift, and Item.
            - Also make the text bigger.
    - Funky Camera?
        - You can directly manipulate camera variables... probably.
        - or not :(

Exclusive Effects:
    - Cement Tires (technically)
    - Hop!
    - Timebomb
    - No Turning
    - Insta-Boost
    - Hey! Listen!
    - Quicksand!
    - Laggy Model
    - Kids These Days
    - Marked For Death

Effects to import and fix:
    - [?] Fix "the ride never ends"
        - This one actually works, but it doesn't tilt the player's sprite. Maybe needs to be done in postthink.
]]


--[[ FX Ideas

    - Baseball
        - A giant baseball rolls across the screen, taking up the screen height. It happens at random intervals.

    - The Helicopter is now avaialble.
        - like that one simpleflips video
        - after a bit, it shows "The Helicopter is no longer available"

    - Make "Bouncy Floors" be "Bouncy" again
        - Use (player.mo.eflags & MFE_JUSTBOUNCEDWALL) for the check.
        - For SRB2, use this: https://mb.srb2.org/addons/wall-check.5085/
            - (this'll also be needed for super explosive 64)

    - Rat Swarm
        - You are swarmed in rats that will protect you.
            - Kinda like super flickies, but Not
        - Use S_FLICKY_12_AIM from SRB2.

    - So Many Colors...
        - Effect that displays multi-color bands on the player's screen.

    - Water Walker
        - does what is says on the tin

    - Wacky Item Roulette
        - Next item roulette the player gets, will have stupid busted items.
        - Have a table with all the possible sets.
        - ...also figure out how the roulette is set up internally.

    - Instantly Use Item
        - Makes you instantly use your item, whether you want to or not.
        - Effect runs for a small amount of time just to do it's stuff.
            - Make a list of items you drag behind yourself.
            - Then, have it randomly do up and down inputs for every item amount you have. (just check for item amount > 0 )
        - Also make it stop item roulettes too.
            - Make it play that sound from SRB2kart when you interrupted the roulette early.

    - Bullet Time
        - This just slows down the player compared to everyone else. All actions are slower.
        - Would be a bitch to do though, I'd need to slow down *all* the animations somehow.
            - Is it possible to update the mobj tics, that reference a state's tics? That'd be enough to do it I think...

    - Press Z to Crunch
        - Press the fast fall button and it squishes the player, causing damage
        - Make a squish animation
        - There's a function that spills rings that's exposed to lua I think, find it and use it

    - Randomized Sounds
        - Re-do this from the ground up
        - Or just look at this again? I used it for MMT, so...
            - https://mb.srb2.org/addons/personal-sounds.2924/
        - Sound functions are local to the player only, avoid trying to base too much code off that.
            - Have it cycle through a list of sounds, if it detects a sound, it just reads the current cycle and replaces that sound.
            - Maybe have the table randomized on start, but other than that, that should work. Other players probably won't hear the same sounds, but oh well

    - The Wheels Of Fate
        - Universal effect that applies to everyone.
        - This spins up 3 slots that will give the player certain minor attributes.
            - This can be giving rings, taking away rings, buffed speed, or certain items.
        - Use the same roulette noises as the one from the Egg Dealer in shadow the hedgehog
            - Noise lasts 89.6 tics, play the loop after that, which lasts 23.5 tics.

    - Scramble
        - Everyone trades items.
        - And khaos effects.

    - Randomize Followers

    - Make Followers make sounds at random
]]

--[[ FEATURES TO ADD:

    - [ ] Revamp the nonconflict checks for effects, and add a similar system for Universal Effects
        - Use a table to compare things, and have there be a few different types of comparisons done.
        - This is to allow people to add their own compatibility checks into their mods.
        - Won't be done for v1.0, maybe for a v1.1 update?

    - [ ] Admin option to disable user blacklists.

    - [ ] Consider using "CV_StealthSet" instead of running an entire console command.
        - Is it netplay safe though? Biggest question.

    - [ ] Re-add command to set effects they can immediately apply to themselves.
        - [ ] But also, have an admin command that disables this. Or rather, enables it, since it's disabled by default.
            - When a player tries to use it, have it print to the console that they can't use it.

    - [ ] Add a textbox that dynamically shows your current character's name.
        - And maybe also your profile name, that'd be funny too.

    - [ ] Don't apply Bleeding when you have the Lightning Shield.
        - Make a parameter for this, "no magnet shield"

    - Option to randomly enable Amplify Mode for a round.

    - Make the replay use random sounds for universal effects.
        - Have it call the random function *before* the checks, that way random numbers don't get out of sync.

    - "tkk_What_Is", a command that tells you about certain effects.
        - Add a description to effects.
        - Also show "sorry nothing :(" if no description exists.

    - Have mods that interface with this require that they specify what mod they are
        - Can do stuff with this later, just make this a requirement.
        - Also, make all internal effects use "base" as the set mod.
            - Stop mods from using "base" as it's mod.

    - Make respawns faster somehow.
        - Setting player.mo.hitlag = 0 every frame makes it so the player instantly respawns from a death.

    - Make the timer bars glow a little bit when they are about to reach the end.
        - It'd be like, the last 80% of the bar.
        - Unable to do this for the rainbow bar, but whatever.

    - Have "Wacky Textures" have a chance to instead swap around all the textures on a course.
        - Would make things more visually interesting.
        - Re-use the code done for position swap

    - Make Nuke be a 1/2 chance to not prevent the hit in amplify mode

    - Restore the player-table roulette system to discard incompatible effects
        - Faster rolls can be done like this.
        - Only store numbers to make sure things stay quick and simple.
        - Fall back on the original table if the player table doesn't currently exist.
            - Alternatively, store the table inside the roulette effect itself.

    - Add text boxes that references 5secondfilms

    - Look through the ghostmobj function to see everything that needs to be copied over for effects that hide the player and replace it with a different object.
        - I don't know what "standingslope" is but it doesn't seem to like being set directly.

    - Change up the SFX for a lot of effects.
        - Make "Moonjump" play a sound when the key combo is pressed.

    - Have "nuke" still affect you if someone else got it at the same time as you.
        - Makes rolling for it in "you get the bees" more chaotic.
        - If you get hit by something that has you as the target, then ignore the damage. Else, continue on with mobjdamage (return false?)

    - Make dodging a hit with "Lucky!" play the Lucky sound from Paper Mario, and use the text from there too.
        - Might be a bit much actually, considering the sound...

    - "the pizza is aggressive" should use mapobjectscale instead of FRACUNIT.

    - [?] Have the text box show the button prompt for accelerate.
        - [ ] Uncomment this and fix the position, maybe change up the text box UI to accomodate for the button.

    - Maybe come up with a different name for "Universal Effects", one that's more fitting when there's just 1 player.
        - Would make it more convienent when I backport all this back into SRB2 Chaotic Edition

    - Have effects that would apply multiple times instead just add to the timer.
        - Include exceptions of course, or do the inverse and make it a "add2timer" variable.
        - In the non-conflict check, make it pass the already exists thing if it plans to add to the timer.
            - And then, on ApplyEffect, check for the conditions, and instead find that effect to apply the additional timer to. Make the HUD say "Extended timer for $EFFECT"

    - [?] Now that everything is stored in a global table variable... allow mods to interface with this. As in, add effects.
        - [?] Have a seperate "addEffect" function, that works to facilitate mods better.
            - Disallow this from adding effects with the same name.
            - Check for valid sounds.
        - Also have a seperate "addUniversalEffect" thing too. And make Universal effects a global table.
        - Get a function that adds incompatibilities to effects.

    - Fix all effects that use pw_powers for flashing, replace it with "player.flashing" instead.

    - Add icon next to the universal effects text, show it actively rolling for effects too, that'd be fun.

]]

            --GT_RACE, GT_BATTLE, GT_SPECIAL, GT_VERSUS, GT_TUTORIAL

rawset(_G, "TailsKK", TailsKK)

local function DebugPrint(player, text)
    if tonumber(CV_FindVar("tkkDebug").value)
        local playertext = (player and "PLYR: " + player.name + ", ") or ""
        print(playertext + "TEXT: " + text)
    end
end

local optionstableofdoom = {
-- tkk_Blacklist_Set isn't here, it's at the bottom of this script
{name = "tkk_Enabled", values = {0, 1}, typer = "number", localonly = true},
{name = "tkk_Amplify", values = {0, 1}, typer = "number", localonly = true},
{name = "tkk_Universal_Timer", values = {10, 100}, typer = "number", localonly = true},
{name = "tkk_Universal_Fx_Enabled", values = {0, 1}, typer = "number", localonly = true},
{name = "tkkDebug", values = {0, 1}, typer = "number", localonly = true},
{name = "tkk_Memory", values = {0, 14}, typer = "number"},
{name = "tkk_Roulette_SFX", values = {0, 1}, typer = "number"},
{name = "tkk_Print_Effect", values = {0, 1}, typer = "number"},
{name = "tkk_Universal_Announcer", values = {0, 1}, typer = "number"},
{name = "tkk_HUD", values = {0, 1}, typer = "number"},
{name = "tkk_HUD_Timer_Bar", values = {0, 1}, typer = "number"},
{name = "tkk_HUD_Position", values = {0, 1}, typer = "number"},
{name = "tkk_HUD_Text_Border", values = {0, 1}, typer = "number"},
{name = "tkk_HUD_Override", values = {0, 1}, typer = "number"},
{name = "tkk_HUD_Timer_Color", values = {0, 2}, typer = "number"}}

local KhaosEffectsTable = {}
rawset(_G, "KhaosEffectsTable", KhaosEffectsTable)
local ueTimer = 0
local ueTimerBuffer = 0
local ueTimerMax = 69 * TICRATE -- DON'T CHANGE THIS!

TailsKK.ueTimer = ueTimer
TailsKK.ueTimerMax = ueTimerMax


local initiateUE = false

local botcount = 0
local playercount = 0
local hasanyonefinished = false

local tkk_Enabled = 1
rawset(_G, "tkk_Enabled", tkk_Enabled)

local function ValidityCheck(player)
    if not player.valid return false end
    if not player.mo return false end
    --if player.bot and gametype != GT_RACE return false end -- no longer needed, keeping commented out just in case
    if player.spectator return false end
    if not player.khaos return false end
    if player.quittime return false end --TODO: check if this actually works. ...does ring racers even use quittime?
    if not tkk_Enabled return false end

    return true
end

local function indexOf(array, value)
    for i, v in ipairs(array) do
        if v == value then
            return i
        end
    end
    return nil
end

local function isPlayerRespawning(player)
    if VERSION >=2 and player.respawn.state then
        return true
    end

    if VERSION < 2 and player.kartstuff[k_respawn] then
        return true
    end

    return false
end

local function keyOf(tbl, value)
    for k, v in pairs(tbl) do
        if v == value then
            return k
        end
    end
    return nil
end

local function indexOfName(array, value) --thanks to amperbee for telling me the obvious that i can just modify this function lol
    for i, v in ipairs(array) do
        if v.name == value then
            return i
        end
    end
    return nil
end

local function indexOfName2(array, value)
    for i, v in ipairs(array) do
        if string.lower(v.name) == string.lower(value) then -- makes this case insensitive
            return i
        end
    end
    return nil
end

local function ShuffleInPlace(t) -- thanks to https://stackoverflow.com/a/68486276 for this, i've only modified it slightly
    for i = #t, 2, -1 do
        local j = P_RandomRange(1, i)
        t[i], t[j] = t[j], t[i]
    end
end

local function rainbowtext(string, offset) -- if you use this, leave this credit for me: Ibly/EeveeEuphoria
    local indexer = 0
    if offset then
        indexer = offset
    end
    local colortable = {"\x85", "\x87", "\x82", "\x83", "\x8B", "\x84", "\x8C", "\x89", "\x81"} -- length is 9
    local rainbowed = ""

    for c in string:gmatch"." do
        if c != " " then
            indexer = $ + 1
            if indexer > #colortable then
                indexer = 1
            end
            c = colortable[indexer] + $
        end
        rainbowed = $ + c
    end
    return rainbowed
end

local function fullcolors(string, offset) -- if you use this, leave this credit for me: Ibly/EeveeEuphoria
    local indexer = 0
    if offset then
        indexer = offset
    end
    local colortable = {"\x80", "\x81", "\x82", "\x83", "\x84", "\x85", "\x86", "\x87", "\x88", "\x89", "\x8A", "\x8B", "\x8C", "\x8D", "\x8E", "\x8F"}
    local rainbowed = ""

    for c in string:gmatch"." do
        if c != " " then
            indexer = $ + 1
            if indexer > #colortable then
                indexer = 1
            end
            c = colortable[indexer] + $
        end
        rainbowed = $ + c
    end
    return rainbowed
end

local function addHUDText(player, string, override, extend, color)
    if not player.khaosoptions.tkk_HUD and not override then return end
    extend = extend or 0 -- can't wait to not remember to fix all my code that doesn't do this
    local tbl = {text = string, trans = 0, timer = 0, expire = ((4 + extend)*TICRATE)- player.khaos.addHUDTextRando, color = color}
    local sendplayer = player

    table.insert(sendplayer.khaostext, tbl)
    sendplayer.khaos.addHUDTextRando = P_RandomRange(5, 10) -- done for text added one after another, to randomize the timer a bit

    DebugPrint(player, player.name + ": " + string)
end

TailsKK.addHUDText = addHUDText

local function SaveSettings(player, silent)
    if VERSION < 2 then return end -- can't use this in SRB2Kart! just abort!
    for key, valuable in pairs(optionstableofdoom) do
        if not valuable.localonly  --TODO: allow admin to save their own local/netvar settings
        and not valuable.dontsave then
            local name = "client/tailskhaoskontraption/" .. valuable.name .. ".dat"
            local savefile = io.openlocal(name, "w")
            if savefile != nil then
                local Saver = CV_FindVar(valuable.name).value
                if player and player.khaosoptions then
                    Saver = player.khaosoptions[valuable.name]
                end
                local TheValue = savefile:write(Saver)
            end
        end
    end
    if player and player.khaos and not silent then
        addHUDText(player, "\199" + "Saved settings!", true, 4)
        S_StartSound(player.mo, sfx_addfil, player)
    else
        CONS_Printf(player, rainbowtext("Saved settings!"))
    end
end

local function LoadSettings(player)
    if player and player.khaos then player.khaos.LoadFailed = false end -- reset this at the start
    if VERSION < 2 then return end -- can't use this in SRB2Kart! just abort!
    local optionsloaded = 0 -- count how many files we load. if it's 0, this is a fresh install!
    for key, value in pairs(optionstableofdoom) do
        if not value.localonly -- TODO: make it so admins can load this, but only once! make a netvar called "AdminLoadedSettings" to prevent other admins auto-loading
        and not value.dontsave then
            local name = "client/tailskhaoskontraption/" .. value.name .. ".dat"
            local loadedfile = io.openlocal(name, "r")
            if loadedfile != nil then
                optionsloaded = $ + 1
                local TheValue = loadedfile:read("*all")
                local TheType = "zkhaosDONOTUSEMEPLEASE1 " -- the space is important, don't forget this
                if value.typer == "string" then
                    TheType = "zkhaosDONOTUSEMEPLEASE2 "
                end
                if player then
                    COM_BufInsertText(player or consoleplayer, TheType + value.name + " " + TheValue)
                else --consoleplayer is loading this
                    COM_BufInsertText(consoleplayer, value.name + " " + TheValue)
                end
            end
        end
    end
    if player and player.khaos then player.khaos.OptionsLoaded = true player.khaos.OptionsLoadAmount = optionsloaded end
end

local function LoadBlacklistSettings(player)
    if VERSION < 2 then if ValidityCheck(player) player.khaos.BLOptionsLoaded = true end return end -- can't use this in SRB2Kart! just abort!
    if ValidityCheck(player) then
        local name = "client/tailskhaoskontraption/" .. "tkkBlackList" .. ".dat"
        local loadedfile = io.openlocal(name, "r")
        local Gayble = {}
        if loadedfile then
            local TheValue = loadedfile:read("*all")
            for s in TheValue:gmatch("[^\r\n]+") do
                table.insert(Gayble, s)
            end
            if loadedfile then
                for key, value in pairs(Gayble) do
                    if value != "" and value != "\n" then -- just to make sure we don't get any blank spaces
                        --tkk_Blacklist_Change
                        COM_BufInsertText(player or consoleplayer, "tkk_Blacklist_Change " + "\"" + value + "\"" + "yes")
                    end
                end
            end
        end
        player.khaos.BLOptionsLoaded = true
    end
end

local function BootlegAttract(mo, target, speed, xoffs, yoffs, zoffs) -- originated from tatsuru's conversion of SRB2 source code
	xoffs = $ or 0
	yoffs = $ or 0
	zoffs = $ or 0

	local newx = target.x + xoffs
	local newy = target.y + yoffs
	local newz = target.z + zoffs
	local dist = R_PointToDist2(0, 0, R_PointToDist2(mo.x, mo.y, newx, newy), newz - mo.z)

	if speed < dist
		mo.momx = FixedMul(FixedDiv(newx - mo.x, dist), speed)
		mo.momy = FixedMul(FixedDiv(newy - mo.y, dist), speed)
		mo.momz = FixedMul(FixedDiv(newz - mo.z, dist), speed)
	elseif speed > dist
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
        local CoolTeleFunction = P_TeleportMove
        if P_SetOrigin then -- new function for interpolation mod; don't use it if it doesn't exist
            CoolTeleFunction = P_SetOrigin
        end
		CoolTeleFunction(mo, newx, newy, newz)
	end
end

local function GivePizza(player)
    player.khaos.PizzaRemoval = nil
    local location = player.mo.ceilingz-(6*mapobjectscale)
    if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
        location = player.mo.floorz+(6*mapobjectscale)
    end
    local thepizzais = P_SpawnMobj(player.mo.x, player.mo.y, location, MT_JIMBO)
    thepizzais.target = player.mo

    local size
    local choosesize = P_RandomRange(1, 4)

    if tonumber(CV_FindVar("tkk_Amplify").value) then
        choosesize = P_RandomRange(2, 5)
    end

    if choosesize == 1 then
        size = "small"
    elseif choosesize == 2 then
        size = "medium"
    elseif choosesize == 3 then
        if P_RandomChance(FRACUNIT/2) then
            size = "large"
        else
            if P_RandomChance(FRACUNIT/2) then
                size = "medium"
            else
                size = "small"
            end
        end
    elseif choosesize == 4 then
        if P_RandomChance(FRACUNIT/99) then -- extrodionarly rare chance!
            size = "extra large"
        else
            if P_RandomChance(FRACUNIT/2 + FRACUNIT/3) then
                size = "medium"
            else
                if P_RandomChance(FRACUNIT/2) then
                    size = "small"
                else
                    size = "large"
                end
            end
        end
    elseif choosesize == 5 then -- only happens in bad mode
        size = "extra large"
    end

    if not size then -- failsafe, just for in case of some really weird situation occuring
        size = "medium"
    end

    if size == "large" or size == "medium" or size == "small" or size == "personal" or size == "xl" or size == "extra large"  or size == "extralarge" then -- REMOVE THIS LATER
        thepizzais.sizeoption = size
    end

    local toppings = "pepperoni"

    if P_RandomChance(FRACUNIT/4) then
        thepizzais.state = S_CHAOTICXPLOSPIZZA
        toppings = "deton"
    elseif P_RandomChance(FRACUNIT/6) then
        thepizzais.state = S_CHAOTICPIZZAFACE
        toppings = "pizza face"
    end

    if not player.khaos.PizzaGivenAlready then
        local StringMan = rainbowtext(player.name) .. "\x80 has ordered a " .. size .. " sized pizza, with " .. toppings .. " toppings to themself."
        print(StringMan)
        if netgame then chatprint(StringMan, true) end
    end
    player.khaos.PizzaSpawned = true
end

local CV_TKKBlackList = {}
local BlackListLength = 0 -- because asking for the tablelength doesn't work for some reason


local KhaosTotal = #KhaosEffectsTable

local function addEffect(tbl)
    -- basic sanity checks
    if tbl.nosrb2kart and VERSION < 2 then --effect can't work on SRB2kart! stopping here!
        return
    end
    if not tbl.name then
        assert(nil, "ERROR: Invalid or no name given to effect!")
    end
    if tbl.chance == nil then
        assert(nil, "ERROR: Invalid or no 'chance' value set!")
    end
    if tbl.duration == nil or type(tbl.duration) != "number" then
        assert(nil, "ERROR: Invalid or no 'duration' value set!")
    end
    -- do NOT error out if no icon/sprite is there, that's something i use and is accounted for
    for key, value in pairs(KhaosEffectsTable) do
        if tbl.name == value.name then
            assert(nil, "ERROR: Effect name is already taken by something else!")
        end
    end
    if not tbl.noprepend and tbl.sprite then
        if VERSION >= 2 then
            tbl.sprite = "KH_" + $
        else
            tbl.sprite = "CH_" + $
        end
    end
    if tbl.kartfunc and VERSION < 2 then
        tbl.func = tbl.kartfunc -- this should be safe i hope
    end
    if tbl.kartendfunc and VERSION < 2 then
        tbl.endfunc = tbl.kartendfunc -- this should be safe i hope
    end
    if tbl.kartstartsfx and VERSION < 2 then
        tbl.startsfx = tbl.kartstartsfx
    end
    if tbl.kartendsfx and VERSION < 2 then
        tbl.endsfx = tbl.kartendsfx
    end
    table.insert(KhaosEffectsTable, tbl)
    if not tbl.dontcountme then
        KhaosTotal = $ + 1
    end
    --table.insert(CV_TKKBlackList, {tbl.name = #CV_TKKBlackList-1})
    if not tbl.noblacklist then
        CV_TKKBlackList[tbl.name] = BlackListLength
        BlackListLength = $ + 1
    end
end

TailsKK.addEffect = addEffect

local function GlobalNonConflict(effectid) -- this is all the stuff that isn't player specific. used mainly for "you get the bees"
    local effecter = KhaosEffectsTable[effectid]

    if effecter.dontrollme then
        DebugPrint(nil, "don't roll this!")
        return false
    end

    if effecter.nobattle and gametype == GT_BATTLE then
        DebugPrint(nil, "we're in battle mode, skip")
        return false
    end

    if effecter.battleonly and gametype != GT_BATTLE then
        DebugPrint(nil, "this isn't battle mode!")
        return false
    end

    if effecter.nospecialstage and gametype == GT_SPECIAL then
        DebugPrint(nil, "we're in a special stage, skip")
        return false
    end

    if effecter.amplifyonly and not tonumber(CV_FindVar("tkk_Amplify").value) then
        DebugPrint(nil, "amplify mode isn't on, not rolling")
        return false
    end

    return true
end

local function CheckNonConflict(player, effectid, ignoreotherincompats, ignoreglobal)
    if not ignoreotherincompats then
        ignoreotherincompats = 0
    end
    local effecter = KhaosEffectsTable[effectid]
    -- check if effect exists first
    DebugPrint(player, "checking nonconflict: " + effecter.name)

    for key, value in pairs(player.khaoseffects) do
        if value.effect == effectid then
            DebugPrint(player, "effect is already applied to player, skip")
            return false
        end
        if KhaosEffectsTable[value.effect].incompatible and ignoreotherincompats <= 1 then -- check pre-existing effects on the player, to see if they're incompatible
            local incompatibleTable = KhaosEffectsTable[value.effect].incompatible
            for key2, value2 in pairs(incompatibleTable) do
                --print(value2)
                if value2 == effecter.name then
                    DebugPrint(player, "incompatible effect found")
                    return false
                end
            end
        end
        if effecter.incompatible and ignoreotherincompats <= 1 then -- now, do the inverse; check this effect's incompatibilities, and see if they exist in the player
            for key2, value2 in pairs(effecter.incompatible) do
                if value2 == KhaosEffectsTable[value.effect].name then
                    DebugPrint(player, "incompatible effect found second-way around")
                    return false
                end
            end
        end
    end

    for key, value in pairs(player.khaosblacklist) do
        if value == effecter.name then
            DebugPrint(player, "effect is blacklisted!")
            return false
        end
    end


    if ignoreotherincompats <= 2 then
        if not ignoreglobal then
            if not GlobalNonConflict(effectid) then
                DebugPrint(player, "effect doesn't pass globalnonconflict")
                return false
            end
        end

        if effecter.nobot and player.bot then
            DebugPrint(player, "player is a bot, ergo invalid")
            return false
        end

        if effecter.fxrequired and #player.khaoseffects < effecter.fxrequired then
            DebugPrint(player, "not enough effects. need: " .. effecter.fxrequired)
            return false
        end

        if effecter.noghost and player.hyudorotimer then
        --TODO for SRB2Kart: check for player.kartstuff[k_hyudorotimer] instead
            DebugPrint(player, "player has been ghosted :(")
            return false
        end

        if VERSION < 2 then
            if effecter.noghost and player.kartstuff[k_hyudorotimer] then
                DebugPrint(player, "player has been ghosted (srb2kart) :(")
                return false
            end
        end
    end


    if not ignoreotherincompats then -- put misc. incompatibilities here
        if effecter.requirerings and VERSION >= 2 and player.rings <= 0 then
            DebugPrint(player, "player doesn't have rings!")
            return false
        end
        if effecter.grounded and not P_IsObjectOnGround(player.mo) then
            DebugPrint(player, "player isn't on the ground!")
            return false
        end
        if player.khaosoptions.tkk_Memory > 0 then
            for key, value in pairs(player.khaosmemory) do
                if value == effectid then -- recently rolled, don't apply this again for a little bit
                    DebugPrint(player, "found in memory: " .. value)
                    return false
                end
            end
        end
    end


    -- all else checks out, let's go
    return true
end

TailsKK.GlobalNonConflict = GlobalNonConflict
TailsKK.CheckNonConflict = CheckNonConflict

local function ApplyEffect(player, effect, extravalues, hudnumber)
    local dex = tonumber(effect) or indexOfName(KhaosEffectsTable, effect) -- dex 2: enter the decko. no but, get the index so we can point to the right table.
    if dex == nil then
        assert(nil, "ERROR: Effect not found!")
    end
    local effecter = KhaosEffectsTable[dex]
    if player.khaosoptions.tkk_HUD or effecter.forcestart then
        if effecter.startsfx then
            if effecter.localsfx then
                S_StartSound(player.mo, effecter.startsfx, player)
            else
                S_StartSound(player.mo, effecter.startsfx)
            end
        end
    end

    local funnyduration = 0

    if effecter.duration > 0 and effecter.range then
        local mintime = max(effecter.duration - (effecter.range/3), effecter.duration/2 + 1) -- done to prevent effect from going under half it's time
        local maxtime = effecter.duration + (effecter.range + 2)


        funnyduration = P_RandomRange(mintime, maxtime)

        if tonumber(CV_FindVar("tkk_Amplify").value) and effecter.addition then -- just for a lil more spice on top of the extended timers
            funnyduration = $ + effecter.addition
        end
    else
        funnyduration = effecter.duration
    end

    DebugPrint(player, effect + ": " + dex)

    local snable = {timer = 0, effect = dex, duration = funnyduration, icon = effecter.sprite, noblink = effecter.noblink, notimer = effecter.notimer, removeme = 0, hudnumber = hudnumber or player.khaosHUDNumber} --hide = effecter.hide

    player.khaosHUDNumber = $ + 1 -- used to assign unique numbers to HUD elements, to keep track of what is what.
    --TODO: this number goes up even if the hudnumber is fed to it from the roulette. is that okay? i think it is?

    if extravalues then
        for key, value in pairs(extravalues) do
            snable[key] = value
        end
    end

    if not effecter.dontrememberme then
        local memsetting = player.khaosoptions.tkk_Memory
        if memsetting > 0 then
            table.insert(player.khaosmemory, dex)
            if #player.khaosmemory > memsetting
                table.remove(player.khaosmemory, 1)
            end
        end
    end

    table.insert(player.khaoseffects, snable)

    if not effecter.nohudtext then
        local prefix = effecter.hudtextprefix or ""
        local color = SKINCOLOR_GREY
        if effecter.etype == "good" then
            color = SKINCOLOR_GREEN
        elseif effecter.etype == "bad" then
            color = SKINCOLOR_RED
        end
        local TheName = effecter.name
        if tonumber(CV_FindVar("tkk_Amplify").value) and effecter.amplifyname then
            TheName = effecter.amplifyname
            DebugPrint(player, "Amplify Name Detected")
        end
        addHUDText(player, prefix + TheName, nil, nil, color)
        if player.khaosoptions.tkk_HUD and player.khaosoptions.tkk_Print_Effect then
            CONS_Printf(player, "*\x83 Applied\x80: " .. effecter.name)
        end
    end

    --[[local snable2 = {timer = 0, effect = dex, position = #player.khaoshud, removeme = 0} --hide = effecter.hide
    table.insert(player.khaoshud, snable2)]]
    --play sound if it exists
end

TailsKK.ApplyEffect = ApplyEffect

local TextBoxTable = { -- there's one more text box stapled to the very end of this lua script, just to count all the current effects lol
{{"Finally caught a",
"Simpleflips stream. He",
"spent 2 hours bouncing",
"on the floor as a"},
{"tree, then he fell",
"asleep live on stream.",
"Great entertainer he is.", ""}},
{{"The path is narrow here.",
"Easy does it! No one is",
"allowed on the top of the",
"mountain!"},
{"And if you know what's",
"good for you, you won't",
"wake anyone who's",
"sleeping!"},
{"Move slowly,",
"tread lightly.","",""}},
{{rainbowtext("it's look who it is"),"","",""}},
{{"You just lost The Game.","","","hah"}},
{{"<<" + "\x87" + "DRRR-CR4CK (LEGIT).exe" + "\x80" + ">>",
"The application isn't respond-",
"ing. The program may respond",
"again if you wait."},
{"Do you want to end",
"this process?",
"              [End] [Cancel]", ""}},
{{"welcom 2 my EPIC",
"minecraf base. DO NOT",
"TAKE MY DIAMONDS. THAT",
"MEANS U, JARED!!!!1!!"}},
{{"I had to change the",
"neon sign outside my",
"house from saying",
"..."},
{"\"I've always",
"had radishes\", to",
"\"I've never had",
"radishes\"."}},
{{"Busted! Y'all ready?",
"\"Rap Rat\" is the name,",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth"},
{"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
rainbowtext("The Video Boab Oyedivuth"), -- just to be silly
"The Video Boab Oyedivuth"},
{"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth"}},
{{"Did you know? You can",
"use \x87\"tkk_What_Is\"\x80 in the",
"console to find out more",
"about certain effects!"}}
}

TailsKK.TextBoxTable = TextBoxTable -- this can make it be modified by mods. that's honestly funny tbh. just don't replace them please that'd be rude :(

  addEffect{name = "i taketh", chance = FRACUNIT/18, duration = 0, sprite = "ITAKETH", etype = "bad", startsfx = sfx_shldls, forcestart = true,
description = "This makes you drop your items, then takes the following: Your drift charge, invincibility and i-frames, 3 rings, and your ring boost.",
func = function(player, selfid, value)
    --P_RemoveShield(player)
    --P_RestoreMusic(player)
    K_DropItems(player)
    player.driftcharge = 0
    player.invincibilitytimer = 0
    player.flashing = 0
    player.ringboost = 0
    P_GivePlayerRings(player, -3)
    value.fxdone = true
end,
kartfunc = function(player, selfid, value)
    player.kartstuff[k_roulettetype] = 0
    player.kartstuff[k_itemroulette] = 0
    player.kartstuff[k_driftcharge] = 0
    player.kartstuff[k_itemtype] = 0
    player.kartstuff[k_itemamount] = 0
    player.kartstuff[k_itemheld] = 0
    value.fxdone = true
end}


  addEffect{name = "Ghost", chance = FRACUNIT/23, duration = 8, range = 4, sprite = "GHOST", etype = "good", -- CEICT0
startsfx = sfx_boo, endsfx = sfx_kc65, forcestart = true,
description = "You died?!?! This gives you the same status as when you get affected by the Hyudoro!",
--incompatible = {"Invisible"},
func = function(player, selfid, value)
    player.hyudorotimer = $ + 15*TICRATE
    value.fxdone = true
end,
kartfunc = function(player, selfid, value)
    player.kartstuff[k_hyudorotimer] = $ + 15*TICRATE
    value.fxdone = true
end
}


  addEffect{name = "Money Bag", chance = FRACUNIT/31, duration = 4, range = 2, etype = "good", sprite = "MONEYBAG", nobattle = true, nosrb2kart = true, -- CEICN0
startsfx = sfx_s3kb3, endsfx = sfx_chchng,
incompatible = {"Bleeding"},
description = "This will give you around 7 rings per second! However they stop being given when you have 20 rings, so you best start spending them!",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        local RANDYC = P_RandomRange(0, TICRATE+(TICRATE)/2) -- approximately 17 tics, or half a second
        value.timer = $ - RANDYC
        value.prevrings = player.rings
    end

    local amount = 1
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        amount = P_RandomRange(1, 2)
    end

    if (value.timer % 5 == 0) then
        P_GivePlayerRings(player, amount)
        if player.khaosoptions.tkk_HUD and value.prevrings != 20 then
            S_StartSound(player.mo, sfx_itemup)
        end
        value.prevrings = player.rings
    end
end}

  addEffect{name = "Super Explosive 64", chance = FRACUNIT/39, duration = 10, range = 4, etype = "bad", sprite = "EXPLODE", nospecialstage = true, noghost = true, drainrespawntimer = true,
startsfx = sfx_kc59, endsfx = sfx_kc5a, localsfx = true,
incompatible = {"Lucky!", "Nuke", "Marked For Death", "Superring", "Ghost"},
description = "\x83\"The all-time classic!\"\x80 Bumping into walls and players will make you explode! Some of the rings and items you collect are also explosive! Don't get juggled!",
func = function(player, selfid, value)
    if not value.started then
        value.prevrings = player.rings
        value.previtemamount = player.itemamount
        value.started = true
    end
    if (player.mo.eflags & MFE_JUSTBOUNCEDWALL) or player.justbumped
    or (VERSION >= 2 and (player.rings > value.prevrings and P_RandomChance(FRACUNIT/9)
    or (player.itemamount > value.previtemamount and P_RandomChance(FRACUNIT/5)))) then
        player.flashing = 0 -- evil
        local Explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
        S_StartSound(Explode, sfx_bkpoof)
        Explode.destscale = 4*player.mo.scale
        Explode.scalespeed = player.mo.scale/6
        P_DamageMobj(player.mo, nil, nil, DMG_WIPEOUT)
    end
    value.prevrings = player.rings
    value.previtemamount = player.itemamount
end}

  addEffect{name = "Effect Storage", chance = 1/FRACUNIT, duration = 0, etype = "bees", dontrollme = true, nobees = true, nohudtext = true, dontcountme = true, notimer = true, noblacklist = true, dontrememberme = true,
description = "When certain events like \"You Get The Bees\" wants to apply an effect, but you have some incompatible effect applied right now, it will be stored in this until it can be given to you.",
func = function(player, selfid, value)
    if not value.icon then
        value.icon = KhaosEffectsTable[value.storeeffect].sprite
    end
    if value.timer > TICRATE and (leveltime % 10) == 0 then
        if CheckNonConflict(player, value.storeeffect, 1, true) then
            value.fxdone = true
        end
    end
end,
endfunc = function(player, selfid, value)
    ApplyEffect(player, KhaosEffectsTable[value.storeeffect].name, nil) -- value.hudnumber used to be placed here, but that seems to be a bit buggy?
end}

  addEffect{name = "Rewind", chance = FRACUNIT/30, duration = 0, etype = "bad", sprite = "REWIND", startsfx = sfx_chrewi, forcestart = true,
description = "Every 3 seconds a new position is recorded down, and when you get rewind, it will send you back there!",
func = function(player, selfid, value)
    P_SetOrigin(player.mo, player.khaos.RewindX, player.khaos.RewindY, player.khaos.RewindZ)
    if not tonumber(CV_FindVar("tkk_Amplify").value) then
        player.mo.angle = player.khaos.RewindAngle
    end
    value.fxdone = true
end}

  addEffect{name = "I WAS FROZEN TODAY!", chance = FRACUNIT/26, duration = 2, range = 1, sprite = "ICE", addition = 1, etype = "bad", drainrespawntimer = true,
startsfx = sfx_s3k80, endsfx = sfx_shattr, forcestart = true, forceend = true,
incompatible = {"Change Color", "Cement Tires", "Change Sprite", "Black Hole", "Laggy Model", "Hey! Listen!", "Insta-Boost"},
description = "Your controls are frozen! Shake wildly to speed up the timer!",
func = function(player, selfid, value)
    if not value.started then
        player.khaos.FrozenNow = true
        player.khaos.FrozenWait = 3
        value.FrozenPrevColor = player.mo.color
        value.started = true
    end

    player.mo.colorized = true
    player.mo.color = SKINCOLOR_JAWZ
    player.skincolor = player.mo.color
    if not player.khaos.FrozenState then
        player.khaos.FrozenState = player.mo.state
        player.khaos.FrozenFrame = player.mo.frame
        if player.followmobj then
            player.khaos.FollowFrozenState = player.followmobj.state
            player.khaos.FollowFrozenFrame = player.followmobj.frame
        end
    end

    if player.bot and P_RandomChance(FRACUNIT/10) then
        player.khaos.FrozenShake = true
    end

    if player.khaos.FrozenShake and player.khaos.FrozenWait == 0 then
        if VERSION >= 2 then
            S_StartSound(player.mo, sfx_iceb)
        else
            S_StartSound(player.mo, sfx_cdfm41)
        end
        local z = (player.mo.z + player.mo.height) + 6*player.mo.scale
        if (player.mo.eflags & MFE_VERTICALFLIP) then
            z = (player.mo.z - player.mo.height) - 6*player.mo.scale
        end
        local piecespawn = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
        piecespawn.number = P_RandomRange(1, 4)
        piecespawn.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
        value.timer = $ + P_RandomRange(3, 6)
        player.khaos.FrozenWait = 4
    end

    if player.khaos.FrozenWait > 0 then
        player.khaos.FrozenWait = $ - 1
        player.mo.spritexoffset = 0
        player.mo.spriteyoffset = 0
    end

    if player.khaos.FrozenWait == 0 then
        player.khaos.FrozenShake = false
    end
end,
endfunc = function(player, selfid, value)
    player.mo.color = value.FrozenPrevColor
    player.skincolor = player.mo.color
    player.mo.colorized = false
    player.khaos.FrozenNow = false
    player.khaos.FrozenShake = false
    player.khaos.FrozenState = nil
    player.khaos.FollowFrozenState = nil
    player.khaos.FrozenFrame = nil
    player.khaos.FollowFrozenFrame = nil
    player.mo.spritexoffset = 0
    player.mo.spriteyoffset = 0

    local z = (player.mo.z + player.mo.height) + 6*player.mo.scale
    if (player.mo.eflags & MFE_VERTICALFLIP) then
        z = (player.mo.z - player.mo.height) - 6*player.mo.scale
    end

    -- stolen from ice springs, forgive me for this sloppy code, i refuse to fix it just yet
    local piece1 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece2 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece3 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece4 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece5 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece6 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece7 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece8 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    piece1.number = 1
    piece2.number = 2
    piece3.number = 3
    piece4.number = 4
    piece1.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece2.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece3.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece4.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))

    piece5.number = 1
    piece6.number = 2
    piece7.number = 3
    piece8.number = 4
    piece5.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece6.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece7.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece8.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
end
}

  addEffect{name = "Giant", chance = FRACUNIT/10, duration = 7, sprite = "GIANT", range = 3, etype = "neutral", restartrespawn = true,
startsfx = sfx_mario3, endsfx = sfx_kc59, forcestart = true, forceend = true,
incompatible = {"Tiny", "HE"},
description = "This makes you giant! This isn't the same thing as the \"Grow\" item, and it won't let you bypass tripwires easily.",
func = function(player, selfid, value)
    if not value.started then
        value.setscale = (mapobjectscale*3)
        player.mo.destscale = value.setscale
        if value.growshrinktimer == nil then value.growshrinktimer = 0 end
        value.started = true
    end
    if VERSION >= 2 then
        if player.growshrinktimer < 0 or player.growshrinktimer > 0 then
            value.growshrinktimer = $ + player.growshrinktimer
            player.growshrinktimer = 0
            player.mo.destscale = value.setscale
        end
    end
end,
endfunc = function(player, selfid, value)
    if value.growshrinktimer < 0 or value.growshrinktimer > 0 then
        player.growshrinktimer = value.growshrinktimer
        if value.growshrinktimer < 0
            player.mo.destscale = FixedMul(mapobjectscale, (FRACUNIT/2))
        else
            player.mo.destscale = FixedMul(mapobjectscale, (2*FRACUNIT))
        end
    else
        player.mo.destscale = mapobjectscale
    end
end}

  addEffect{name = "Tiny", chance = FRACUNIT/13, duration = 6, sprite = "TINY", range = 2, addition = 2, etype = "bad", restartrespawn = true,
startsfx = sfx_mario8, endsfx = sfx_kc5a, forcestart = true, forceend = true,
incompatible = {"Giant"},
description = "This makes you very small! This isn't the same thing as the \"Shrink\" item.",
func = function(player, selfid, value)
    if not value.started then
        value.setscale = (mapobjectscale/4) + (mapobjectscale/8)
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            value.destscale = (mapobjectscale/3)
        end
        player.mo.destscale = value.setscale
        if value.growshrinktimer == nil then value.growshrinktimer = 0 end
        value.started = true
    end
    if VERSION >= 2 then
        if player.growshrinktimer < 0 or player.growshrinktimer > 0 then
            value.growshrinktimer = $ + player.growshrinktimer
            player.growshrinktimer = 0
            player.mo.destscale = value.setscale
        end
    end
end,

endfunc = function(player, selfid, value)
    if value.growshrinktimer < 0 or value.growshrinktimer > 0 then
        player.growshrinktimer = value.growshrinktimer
        if value.growshrinktimer < 0
            player.mo.destscale = FixedMul(mapobjectscale, (FRACUNIT/2))
        else
            player.mo.destscale = FixedMul(mapobjectscale, (2*FRACUNIT))
        end
    else
        player.mo.destscale = mapobjectscale
    end
end}

  addEffect{name = "Gravity Coil", chance = FRACUNIT/16, duration = 15, range = 4, sprite = "GRAVITYCOIL", addition = 3, nonights = true, etype = "neutral", nocart = true,
startsfx = sfx_chgc, endsfx = sfx_kc65, localsfx = true,
incomaptible = {"Super Jump", "Bouncy Floors", "Cement Tires"},
description = "This makes your falls descend a whole lot slower.",
func = function(player, selfid, value)
    if not P_IsObjectOnGround(player.mo) then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if player.mo.momz > 0 then
                player.mo.momz = $ - $ / 25
            elseif player.mo.momz < (9*FRACUNIT * FRACUNIT) then
                player.mo.momz = $ + $ / 2
            end
        else
            if player.mo.momz < 0 then
                player.mo.momz = $ - $ / 25
            elseif player.mo.momz < (9*FRACUNIT * FRACUNIT) then
                player.mo.momz = $ + $ / 2
            end
        end
    end
end}

  addEffect{name = "Sticky Slopes", chance = FRACUNIT/26, duration = 10, range = 5, sprite = "STICKY", addition = 5, etype = "bad", nonights = true, nospecialstage = true, -- CEIDJ0
startsfx = sfx_kc59, endsfx = sfx_kc5a, localsfx = true,
incompatible = {"Pancake", "Butter Physics", "Cement Tires"},
description = "Your kart has a hard time going up hill! And it also doesn't like going down hill!",
func = function(player, selfid, value)
    if P_IsObjectOnGround(player.mo) and player.mo.standingslope then
        player.mo.friction = FRACUNIT - FRACUNIT/10
    else
        if player.khaos.OGFriction then -- srb2kart complained about this when a player was respawning
            player.mo.friction = player.khaos.OGFriction
        end
    end
end,
endfunc = function(player, selfid, value)
    player.mo.friction = player.khaos.OGFriction
end}

addEffect{name = "Drifting", chance = FRACUNIT/22, duration = 10, range = 3, sprite = "DRIFTINGLEFT", addition = 1, etype = "bad", nocart = true, nonights = true, nohudtext = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Invert Controls"},
description = "Simulates Joy-Con(tm) Drift! You will be constantly veering either to the left or right.",
func = function(player, selfid, value)
    --player.cmd.turning -- ranges from -800 to 800, positive is left

    if not value.started then
        value.started = true
        value.adjustvalue = 450
        if P_RandomChance(FRACUNIT/2) then
            value.icon = "KH_DRIFTINGRIGHT"
            if VERSION < 2 then
                value.icon = "CH_DRIFTINGRIGHT"
            end
            value.adjustvalue = -450
            value.adjustangle = -ANG1
            addHUDText(player, "Drifting Right")
        else
            value.adjustangle = ANG1
            addHUDText(player, "Drifting Left")
        end
    end

    player.khaos.BorkedSteering = value.adjustvalue

    if VERSION < 2 then
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            player.mo.angle = (player.cmd.angleturn << FRACBITS) + value.adjustangle + value.adjustangle
        else
            player.mo.angle = (player.cmd.angleturn << FRACBITS) + value.adjustangle
        end
    end
end,

endfunc=function(player, selfid, value)
    player.khaos.BorkedSteering = nil
end}

addEffect{name = "Earthquake", chance = FRACUNIT/16, duration = 10, range = 8, etype = "bad", sprite = "EARTHQUAKE", nobot = true, hudtextprefix = "\202",
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "Causes your screen to shake violently! If you're near anyone else, their screen will also be shaking!",
func = function(player, selfid, value)
    if (leveltime % 10 == 0) then
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            P_StartQuake(13, 25*FRACUNIT, 45*FRACUNIT, player.mo)
        else
            P_StartQuake(9, 15*FRACUNIT, 30*FRACUNIT, player.mo)
        end
    end
end,
kartfunc = function(player, selfid, value)
    if amplifymode == "on" then
        P_StartQuake(25*FRACUNIT, 1, nil, nil)
    else
        P_StartQuake(14*FRACUNIT, 1, nil, nil)
    end
end
}

addEffect{name = "Nuke", chance = FRACUNIT/40, duration = 0, sprite = "NUKE", nonights = true, etype = "good", startsfx = sfx_gshbe, --sfx_gshdd. sfx_gshcd, sfx_gshc5
description = "Sets off a bunch of bombs right around your player, damaging everyone nearby! You'll dodge the hit... unless you're very unlucky.",
func = function(player, selfid, value)
    if not P_RandomChance(FRACUNIT/90) -- >:3c
        player.khaos.DodgeHit = true -- jank ass solution to give the player invincibility frames
    end

    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 5
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x+50*FRACUNIT, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y+50*FRACUNIT, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x-50*FRACUNIT, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y-50*FRACUNIT, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    -- this cause a shit ton of lag. i am not fixing this.
    player.khaos.DodgeHit = false
    value.fxdone = true
end}


  addEffect{name = "Reversed!", chance = FRACUNIT/33, duration = 0, etype = "bad", sprite = "REVERSED", amplifyonly = true, startsfx = sfx_s3kaa,
description = "This instantly turns you around 180 degrees!",
func = function(player, selfid, value)
    player.mo.angle = player.mo.angle + ANGLE_180
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        player.mo.momx = -player.mo.momx
        player.mo.momy = -player.mo.momy
    end
    value.fxdone = true
end}

  addEffect{name = "the pizza is aggressive", chance = FRACUNIT/37, duration = 13, range = 12, sprite = "PIZZA", addition = 3, etype = "bad", noghost = true,
description = "\x83\"Bond with me, Jimmy.\"\x80 You ordered a pizza, but it's aggressive! This will chase you until it hits you, or the timer runs out.",
startsfx = sfx_chapis, endsfx = sfx_kc65, forcestart = true,
incompatible = {"Ghost"},
func = function(player, selfid, value)
    if not player.khaos.PizzaSpawned then
        GivePizza(player)
        player.khaos.PizzaGivenAlready = true
    end
    if player.khaos.PizzaHitTarget then
        if player.khaos.PizzaHitTarget then
            addHUDText(player, "Delivery complete, enjoy your pizza!", true)
            value.timer = 69*TICRATE -- nice
        end
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.PizzaSpawned = false
    player.khaos.PizzaRemoval = true
    player.khaos.PizzaHitTarget = false
    player.khaos.PizzaGivenAlready = false
end}

  addEffect{name = "Insta-Boost", chance = FRACUNIT/17, duration = 0, sprite = "BOOST", etype = "neutral",
description = "\x83\"You got boost power!\"\x80 This instantly applies a sneaker boost to the player.",
func = function(player, selfid, value)
    if VERSION >= 2 then
        player.ringboost = $ + 600
    end
    if P_IsObjectOnGround(player.mo) then
        K_DoSneaker(player, 0)
    else
        K_DoSneaker(player, 2)
    end
    value.fxdone = true
end}

addEffect{name = "No Turning", chance = FRACUNIT/38, etype = "bad", duration = 2, sprite = "NOTURNING", addition = 1, drainrespawntimer = true,
description = "Disables your turning very briefly!",
startsfx = sfx_s3kb2, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Drifting"},
func = function(player, selfid, value)
    if not value.started then
        value.pangle = player.mo.angle
        value.started = true
    end

    player.mo.angle = value.pangle
end}

  addEffect{name = "Hop!", chance = FRACUNIT/10, duration = 0, sprite = "HOP", startsfx = sfx_sprong, kartstartsfx = sfx_kpogos, etype = "neutral", forcestart = true,
description = "Springs you upward with great velocity!",
func = function(player, selfid, value)
    player.mo.momz = 15*FRACUNIT
    value.fxdone = true
end}

  addEffect{name = "Laggy Model", chance = FRACUNIT/31, duration = 12, range = 5, sprite = "LAG", etype = "bad", nosrb2kart = true, --freezeremove = true,
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Invisible", "Change Sprite"},
description = "Causes your player's sprite/model to lag behind.",
func = function(player, selfid, value)
    if not value.started then
        value.thej = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_LAGPLAYER)
        value.thej.gayer = player
        player.khaos.InvisibleNow = true
        player.khaos.InvisibleBegone = false
        value.started = true
        value.divisor = P_RandomRange(5, 10)
    end

    if (leveltime % (TICRATE/value.divisor) == 0) then
        P_RemoveMobj(value.thej)
        value.started = false
    end

    if value.thej and value.thej.valid then
        if (player.mo.renderflags & RF_DONTDRAW) then -- used to get invincibility frames to render
            value.thej.Blinker = true
        else
            value.thej.Blinker = false
        end
    end



end,
endfunc = function(player, selfid, value)
    if value.thej and value.thej.valid then
        P_RemoveMobj(value.thej)
    end
    player.khaos.InvisibleNow = false
    player.khaos.InvisibleBegone = true

    local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
    dust.scale = FRACUNIT*2
    dust.state = S_XPLD1
end}

  addEffect{name = "Change Sprite", chance = FRACUNIT/10, duration = 18, range = 15, sprite = "CHSPRITE", etype = "neutral", nosrb2kart = true,
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Invisible", "Laggy Model"},
description = "Changes your player's sprite/model to be completely different!",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        player.khaos.ChangeSpriteNow = true
        player.khaos.InvisibleNow = true

        local funnystates = {}

        if VERSION >= 2 then
            funnystates = {S_CHAOSMAC, S_CHAOSWIN9X, S_CHAOSTUX, S_PFLW, S_GLDR, S_KART_TIRE2, S_KART_LEFTOVER, S_KART_LEFTOVER_NOTIRES, S_CHAOTICUNKNOWN, S_YELLOWSPRING1, S_YHORIZ1, S_BUSH, S_SOSS_RUN1, S_GFZTREE, S_GARGOYLE, S_COLORRING, S_CHAOTICPIZZA}
        else
            funnystates = {S_BUSH, S_SOSS_RUN1, S_GFZTREE, S_COLORRING, S_CHAOTICPIZZA}
        end
        local SPRITE = funnystates[P_RandomRange(1, #funnystates)]
        -- S_SSHELL_RUN1, doesn't work :(

        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1

        player.khaos.ChangeSpriteMOBJ = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CHANGESPRITE)
        player.khaos.ChangeSpriteMOBJ.gayer = player
        player.khaos.ChangeSpriteMOBJ.state = SPRITE
        --player.khaos.ChangeSpriteMOBJ.flags = $ & ~MF_ENEMY
        player.khaos.ChangeSpriteMOBJ.flags = $ & ~MF_NOTHINK
        player.khaos.ChangeSpriteMOBJ.summonedasstate = SPRITE
    end

    if player.khaos.ChangeSpriteMOBJ and player.khaos.ChangeSpriteMOBJ.valid then
        if (player.mo.renderflags & RF_DONTDRAW) then -- used to get invincibility frames to render
            player.khaos.ChangeSpriteMOBJ.Blinker = true
        else
            player.khaos.ChangeSpriteMOBJ.Blinker = false
        end
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.ChangeSpriteNow = false
    if player.khaos.ChangeSpriteMOBJ and player.khaos.ChangeSpriteMOBJ.valid then
        player.khaos.ChangeSpriteMOBJ.despawn = true
        player.khaos.ChangeSpriteMOBJ = nil
    end
    player.khaos.InvisibleNow = false
    player.khaos.InvisibleBegone = true

    local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
    dust.scale = FRACUNIT*2
    dust.state = S_XPLD1
end}

  addEffect{name = "Hey! Listen!", chance = FRACUNIT/34, duration = 15, sprite = "LISTEN", etype = "bad", nobees = true, nobot = true, immune2remove = true, notimer = true,
startsfx = sfx_chtxst, endsfx = sfx_chtxed, forcestart = true, forceend = true,
incompatible = {"Hop!", "Fling Player", "Rewind", "Bouncy Floors", "Insta-Boost", "Windy Day", "Quicksand!", "I WAS FROZEN TODAY!"},
description = "Pops up an annoying text box. Let go of accelerate and press it again to get through the text!",
func = function(player, selfid, value)
    if not value.started then
        player.khaos.TextBoxStation = P_RandomRange(1, #TextBoxTable)
        player.khaos.TextBoxPage = 1 --#TextBoxTable[TextBoxStation]
        player.khaos.TextBoxFader = 8
        player.khaos.TextBoxAdvancePage = 30
        player.khaos.FadeTextBoxIn = 1
        player.khaos.prevmomx = player.mo.momx
        player.khaos.prevmomy = player.mo.momy
        player.khaos.prevmomz = player.mo.momz
        player.khaos.keepangle = player.mo.angle
        value.started = true
    end

    if player.khaos.TextBoxFlipPage then
        player.khaos.TextBoxFlipPage = false
        if player.khaos.TextBoxPage + 1 > #TextBoxTable[player.khaos.TextBoxStation] then
            player.khaos.FadeTextBoxOut = 1
            value.timer = (value.duration * TICRATE) - (3*TICRATE)
        else
            player.khaos.TextBoxPage = $ + 1
        end
    end

    player.mo.angle = player.khaos.keepangle
    if not isPlayerRespawning(player) then
        player.mo.momx = 0
        player.mo.momy = 0
        player.mo.momz = 0
    end
    player.spinouttype = KSPIN_IFRAMES
    player.flashing = 2

    if player.khaos.FadeTextBoxIn then
        player.khaos.FadeTextBoxIn = $ + 1
        if ((player.khaos.FadeTextBoxIn-2*TICRATE)*2) % 2 == 0 then
            player.khaos.TextBoxFader = $ - 1
        end
        if player.khaos.TextBoxFader == 0 then
            player.khaos.FadeTextBoxIn = 0
        end
    end

    if not player.khaos.FadeTextBoxOut and value.timer == (value.duration * TICRATE) - (1*TICRATE) then -- fade out text box near timer end, to make it look smoother
        player.khaos.FadeTextBoxOut = 1
    end

    if player.khaos.FadeTextBoxOut then
        player.khaos.FadeTextBoxOut = $ + 1
        if ((player.khaos.FadeTextBoxOut-2*TICRATE)*2) % 2 == 0 then
            player.khaos.TextBoxFader = $ + 1
        end
        if player.khaos.TextBoxFader > 9 then
            player.khaos.TextBoxStation = nil
            player.khaos.FadeTextBoxOut = 0
            player.khaos.TextBoxFader = 0
            value.fxdone = true
        end
    end

    if player.khaos.TextBoxAdvancePage > 0 then
        player.khaos.TextBoxAdvancePage = $ - 1
    end

    if (player.cmd.buttons & BT_ACCELERATE)
        if player.khaos.TextBoxStation and not player.khaos.HoldAccelerate and not player.khaos.TextBoxAdvancePage then
            player.khaos.TextBoxAdvancePage = 20
            player.khaos.TextBoxFlipPage = true
            if player.khaos.TextBoxPage + 1 <= #TextBoxTable[player.khaos.TextBoxStation] then
                S_StartSound(player.mo, sfx_chtxad, player)
            end
        end
        player.khaos.HoldAccelerate = true
    else
        player.khaos.HoldAccelerate = false
    end

end,
endfunc = function(player, selfid, value)
    player.mo.momx = player.khaos.prevmomx
    player.mo.momy = player.khaos.prevmomy
    player.mo.momz = player.khaos.prevmomz

    player.khaos.TextBoxStation = nil
    player.khaos.FadeTextBoxOut = 0
    player.khaos.TextBoxFader = 0
end}

  addEffect{name = "Quicksand!", chance = FRACUNIT/50, duration = 2, sprite = "QUICKSAND", etype = "bad", nobees = true, grounded = true, drainrespawntimer = true, nosrb2kart = true, nospecialstage = true,
startsfx = sfx_chslrp, forcestart = true,
incompatible = {"Bouncy Floors", "Windy Day", "Insta-Boost", "Hey! Listen!"},
description = "You got slurped by the ground! You respawn after this effect goes away.",
func = function(player, selfid, value)
    if not value.started then
        value.offsetter = 0
        value.adder = FRACUNIT*2
        player.spinouttype = KSPIN_WIPEOUT
        player.spinouttimer = value.duration*TICRATE
        player.mo.state = S_KART_SPINOUT
        value.started = true
    end

    value.offsetter = $ - value.adder
    value.adder = $ + (FRACUNIT/10)

    player.mo.momx = 0
    player.mo.momy = 0
    player.mo.momz = 0

    -- player.mo.angleroll = $ + ANG1
    player.mo.spriteyoffset = value.offsetter
    player.mo.spritexoffset = 1
end,
endfunc = function(player, selfid, value)
    player.mo.spritexoffset = 0
    player.mo.spriteyoffset = 0
    P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
end}

local InvalidBHObjects = {}

if VERSION >= 2 then
    InvalidBHObjects = {MT_PLAYER, MT_EGGTRAP, MT_STEAM, MT_CHAINPOINT, MT_RANDOMITEM, MT_SNEAKERPANEL, MT_SPRAYCAN}
else
    InvalidBHObjects = {MT_PLAYER}
end

local function ValidBHObject(mobj)
    if (mobj.flags & (MF_SCENERY|MF_SOLID)) == (MF_SCENERY|MF_SOLID) and not (mobj.type != MT_SPIKE and tonumber(CV_FindVar("tkk_Amplify").value)) then
        return false -- exception for stuff like GFZ trees, too annoying to deal with
    elseif (mobj.flags & MF_SPRING) --and not tonumber(CV_FindVar("tkk_Amplify").value) then
        return false
    elseif (mobj.flags & MF_PUSHABLE) then
        return false  -- just because those gargoyles are annoying too
    end
    for key, value in pairs(InvalidBHObjects) do
        if value == mobj.type then
            return false
        end
    end

    return true
end

  addEffect{name = "Black Hole", chance = FRACUNIT/20, duration = 20, range = 5, sprite = "BLACKHOLE", addition = 2, etype = "bad",  -- CEIC50
nobees = true, dontcountme = true, dontrollme = true, drainrespawntimer = true, immune2remove = true, noghost = true, startsfx = sfx_s3k74, endsfx = sfx_kc65,
description = "You were granted the title of 'Most Attractive Player'! Ergo, nearby objects will start flying towards you.",
incompatible = {"Super Explosive 64", "Ghost"},
func = function(player, selfid, value)
    -- thanks to amperbee for providing sample code!
    local m = player.mo --used to be realmo, but ring racers is silly and thinks we shouldn't have realmo!
    local range = 1440*mapobjectscale
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        range = $ + 512 * mapobjectscale
    end
    local range2 = range - (64*FRACUNIT)
    searchBlockmap("objects", function(ref, found)
        if ValidBHObject(found) then
            if R_PointToDist2(m.x, m.y, found.x, found.y) <= range2 then
                if VERSION >= 2 then
                    if found.type == MT_RING or found.type == MT_BLUESPHERE then
                        found.tracer = m
                    end
                end
                -- min = 3 FRACUNIT
                -- max = 22 FRACUNIT
                local dist = R_PointToDist2(m.x, m.y, found.x, found.y)
                if dist < FRACUNIT then
                    dist = FRACUNIT
                end
                local PullForce = range/dist * 3
                if PullForce > 30 then
                    PullForce = 30
                end
                PullForce = $ * FRACUNIT

                BootlegAttract(found, m, PullForce)
            end
        end
    end, m, m.x-range, m.x+range, m.y-range, m.y+range)
end}

  addEffect{name = "HE", chance = FRACUNIT/39, duration = 16, range = 6, sprite = "HE", addition = 3, etype = "neutral", nonights = true, nocart = true, nosrb2kart = true, -- our lord and savior, Lanky "Christ" Kong
startsfx = sfx_chlank, endsfx = sfx_kc65, forcestart = true,
incompatible = {"Pancake", "Giant", "Cement Tires"},
description = "You have no style, you have no grace, t-t-t-this player has unusual speed properties!",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.GOALY = FRACUNIT*4 - FRACUNIT/4
        value.GOALX = FRACUNIT/3 + FRACUNIT/4
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            value.GOALY = FRACUNIT*4 - FRACUNIT/6
            value.GOALX = FRACUNIT/2 + FRACUNIT/4
        end
        player.khaos.RestoreSpriteXScaleUp = nil
        player.khaos.RestoreSpriteYScaleUp = nil
        player.khaos.RestoreSpriteXScaleDown = nil
        player.khaos.RestoreSpriteYScaleDown = nil
    end

    if player.mo.spritexscale != value.GOALX then
        if player.mo.spritexscale < value.GOALX then
            player.mo.spritexscale = $ + FRACUNIT/2
        elseif player.mo.spritexscale > value.GOALX then
            player.mo.spritexscale = value.GOALX
        end
    end
    if player.mo.spriteyscale != value.GOALY then
        if player.mo.spriteyscale < value.GOALY then
            player.mo.spriteyscale = $ + FRACUNIT/2
        elseif player.mo.spriteyscale > value.GOALY then
            player.mo.spriteyscale = value.GOALY
        end
    end

    --[[if tonumber(CV_FindVar("tkk_Amplify").value)  then
        player.normalspeed = skins[player.mo.skin].normalspeed * 3
        player.runspeed = skins[player.mo.skin].runspeed * 3
        player.actionspd = skins[player.mo.skin].actionspd * 3
        player.thrustfactor = skins[player.mo.skin].thrustfactor * 3
        player.mindash = FRACUNIT * 80
        player.maxdash = skins[player.mo.skin].maxdash * 2
    else
        player.normalspeed = (skins[player.mo.skin].normalspeed * 2) + (skins[player.mo.skin].normalspeed / 4)
        player.runspeed = (skins[player.mo.skin].runspeed * 2) + (skins[player.mo.skin].runspeed / 3)
        player.actionspd = skins[player.mo.skin].actionspd * 2
        player.thrustfactor = (skins[player.mo.skin].thrustfactor * 2) + (skins[player.mo.skin].thrustfactor / 3)
    end]]

    if tonumber(CV_FindVar("tkk_Amplify").value) then
        player.kartspeed = value.Defaultkartspeed * 4
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 3
    else
        player.kartspeed = value.Defaultkartspeed * 3 - (value.Defaultkartspeed / 2)
        --player.kartweight = value.Defaultkartweight -- weight is unaffected
    end
end,
endfunc = function(player, selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    player.khaos.RestoreSpriteXScaleDown = true
    player.khaos.RestoreSpriteYScaleDown = true
    --player.height = skins[player.mo.skin].height
    --player.mo.spriteyscale = FRACUNIT
end}

  addEffect{name = "Remove Random Effect", chance = FRACUNIT/21, duration = 0, sprite = "TRASH", etype = "neutral", fxrequired = 2, nobees = true,
description = "Does what it says on the tin.",
func = function(player, selfid, value)
    local RANDNUMB = P_RandomRange(1, #player.khaoseffects)

    for index2, value2 in ipairs(player.khaoseffects) do
        local TheNamer = KhaosEffectsTable[value2.effect]
        if index2 != selfid and index2 == RANDNUMB and not TheNamer.immune2remove and TheNamer.duration > 0 and TheNamer.name != "Roulette" and TheNamer.name != "Remove Random Effect" then
            value2.timer = value2.duration*TICRATE + 5
            value.fxdone = true
            break
        end
    end
end}

  addEffect{name = "Invert Controls", chance = FRACUNIT/35, duration = 8, range = 5, sprite = "INVERT", etype = "bad", amplifyonly = true, nosrb2kart = true,
description = "This does what it says on the tin. Have fun getting used to the normal controls after it goes away!",
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"I WAS FROZEN TODAY!", "Drifting"},
func = function(player, sselfid, value)
    player.khaos.InvertControlsNow = true
end,
endfunc= function(player, sselfid, value)
    player.khaos.InvertControlsNow = false
end}

  addEffect{name = "Moonjump", chance = FRACUNIT/15, etype = "neutral", duration = 9, range = 4, sprite = "MOON", addition = 2, nobot = true,
startsfx = sfx_kc5a, endsfx = sfx_kc65, localsfx = true,
description = "Hold the button combo to raise yourself in the air!",
incompatible = {"Cement Tires", "Zero Gravity", "Pancake"},
func = function(player, sselfid, value)
    if not value.started then
        value.started = true
        addHUDText(player, "Hold \"Use Item\" & \"Brake\" to levitate!", true)
    end

    if player.cmd.buttons & BT_ATTACK and player.cmd.buttons & BT_BRAKE then
        player.mo.momz = 5*FRACUNIT
    end
end}

-- include super duper rare chance of brak eggman spawning

local ObjectsTable = {} -- used for "Spawn Object" effect

local function addObject(tbl)
	table.insert(ObjectsTable, tbl)
end

TailsKK.addObject = addObject

--addObject{id = MT_EGGTRAP, name = "Eggtrap"} -- doesn't work :(

addObject{id = MT_KHAOSTURRET, name = "Turret"}
addObject{id = MT_REDSPRING, name = "Red Spring", flagremover = MF_NOGRAVITY}
addObject{id = MT_BLUESPRING, name = "Blue Spring", flagremover = MF_NOGRAVITY}
addObject{id = MT_BANANA, name = "Banana"}
addObject{id = MT_SINK, name = "Kitchen Sink", velocity = 40}
addObject{id = MT_SSMINE, name = "Proximity Mine"}

if VERSION >= 2 then
    addObject{id = MT_LANDMINE, name = "Land Mine"}
    addObject{id = MT_TNTBARREL, name = "TNT Barrel"}
end

if VERSION < 2 then --srb2 kart gets all teh cool stuff :(
    addObject{id = MT_BLUECRAWLA, name = "Blue Crawla"}
    addObject{id = MT_GOLDBUZZ, name = "Gold Buzz"}
    addObject{id = MT_JETTBOMBER, name = "Jetty-Syn Bomber"}
    addObject{id = MT_DETON, name = "Deton"}
    --addObject{id = MT_FACESTABBER, name = "Lance-a-Bot"}
    addObject{id = MT_EGGMOBILE, name = "Eggman"}
    addObject{id = MT_GOOMBA, name = "Goomba"}
    addObject{id = MT_REDSPRING, name = "Red Spring"}
    addObject{id = MT_BLUESPRING, name = "Blue Spring"}
    addObject{id = MT_SHARP, name = "Spincushion"}
end

-- addObject{id = MT_EGGMOBILE2, name = "Egg Slimer"}
-- addObject{id = MT_RING_BOX, name = "Super Ring Monitor"}
-- addObject{id = MT_BLUECRAWLA, name = "Blue Crawla"}
-- addObject{id = MT_GOLDBUZZ, name = "Gold Buzz"}
-- addObject{id = MT_JETTBOMBER, name = "Jetty-Syn Bomber"}
-- addObject{id = MT_DETON, name = "Deton"}
-- addObject{id = MT_SPINCUSHION, name = "Spincushion"}
-- addObject{id = MT_FACESTABBER, name = "Lance-a-Bot"}
-- addObject{id = MT_BLUECRAWLA, name = "Blue Crawla"}
-- addObject{id = MT_EGGMOBILE, name = "Eggman"}
-- addObject{id = MT_GOOMBA, name = "Goomba"}
-- addObject{id = MT_PYREFLY, name = "Pyre Fly"}
-- addObject{id = MT_PENGUINATOR, name = "Penguinator"}
-- addObject{id = MT_ROBOHOOD, name = "Robo-Hood"}
-- addObject{id = MT_PITY_BOX, name = "Pity Shield Box"}
-- addObject{id = MT_MINUS, name = "Minus"}
-- addObject{id = MT_YELLOWSHELL, name = "Yellow Spring Shell"}
-- addObject{id = MT_FLAMEAURA_BOX, name = "Flame Shield Monitor"}
-- addObject{id = MT_BUBBLEWRAP_BOX, name = "Bubble Shield Monitor"}
-- addObject{id = MT_THUNDERCOIN_BOX, name = "Lightning Shield Monitor"}

  addEffect{name = "Spawn Object", chance = FRACUNIT/18, duration = 0, sprite = "PORTAL", nohudtext = true, etype = "neutral", nospecialstage = true, --TODO: have seperate table for special stages, as to prevent the kitchen sink from fucking killing you
incompatible = {"I WAS FROZEN TODAY!"},
description = "Spawns an object above your head! It'll randomly be thrown forward, backwards, or just drop right down where you are/were.",
func = function(player, selfid, value)
S_StartSound(player.mo, sfx_s3kcas)
    local RANDY1 = P_RandomRange(1, #ObjectsTable)

    local theobj = ObjectsTable[RANDY1].id
    local name = ObjectsTable[RANDY1].name
    local tic


    local thej = player.mo.z + (player.mo.height + (32 * player.mo.scale))
    if ObjectsTable[RANDY1].onground then
        thej = player.mo.floorz
    end

    local Obj = P_SpawnMobj(player.mo.x, player.mo.y, thej, theobj)
    local RANDY2 = P_RandomRange(1, 3)
    if ObjectsTable[RANDY1].flagremover then
        Obj.flags = $ & ~ObjectsTable[RANDY1].flagremover
    end
    Obj.target = player.mo
    --Obj.tracer = player.mo
    Obj.angle = player.mo.angle
    if tic then
        Obj.fuse = tic
    end


    if Obj.ceilingrover and Obj.ceilingrover.valid then
        if Obj.z > Obj.ceilingrover.bottomheight then
            Obj.z = Obj.ceilingrover.bottomheight - Obj.height - 4*FRACUNIT
        end
    else
        if Obj.z > Obj.subsector.sector.ceilingheight then
            Obj.z = Obj.subsector.sector.ceilingheight - Obj.height - 4*FRACUNIT
        end
    end
    if Obj and Obj.valid then -- thanks game for being a bitch about this
        local Velocity = ObjectsTable[RANDY1].velocity and ObjectsTable[RANDY1].velocity*mapobjectscale or 22*mapobjectscale
        if not ObjectsTable[RANDY1].nothrust then
            if RANDY2 == 1 then
                P_InstaThrust(Obj, Obj.angle, Velocity)
                Obj.angle = $ + ANGLE_180
            elseif RANDY2 == 3 then
                P_InstaThrust(Obj, Obj.angle, -Velocity)
            end
        end
    end

    addHUDText(player, "\x87" + "Spawned" + "\x80: " .. name)

    value.fxdone = true
end
}

  addEffect{name = "Firework", chance = FRACUNIT/24, etype = "bad", duration = 1, sprite = "FIREWORK", addition = 1, nocart = true, nospawn = true, requirerings = true, nospecialstage = true,
startsfx = sfx_chadet, forcestart = true,
incompatible = {"Cement Tires", "Zero Gravity"},
description = "Shoots you really far into the sky! There's a chance the fireworks will be explosive.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.explosive = false
        local amnt = FRACUNIT/2-FRACUNIT/5
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            amnt = FRACUNIT/2+FRACUNIT/3
        end
        --[[if IsMatchMode() then
            amnt = $ / 2
        end]]
        if VERSION >= 2 and P_RandomChance(amnt) then -- TODO: fix this for srb2kart, tnt barrel doesn't exist
            value.explosive = true
        end
    end

    local additioner = FRACUNIT + (FRACUNIT/2) + (FRACUNIT/4)

    --[[if (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) then
        additioner = $ * 20
    end]]

    if not isPlayerRespawning(player) then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            player.mo.momz = $ - additioner
        else
            player.mo.momz = $ + additioner
        end
    end

    local function SpawnSpark(x, y, z, state)
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, MT_SIGNSPARKLE)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 10
        if state then
            Sperk.state = state
            Sperk.scale = $ / 2
        end
    end

    for i=6,1,-1 do
        SpawnSpark(P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
        if value.explosive and VERSION >= 2 then --TODO: fix object type for srb2kart
            SpawnSpark(P_RandomFixed(), P_RandomFixed(), P_RandomFixed(), S_SPINDUST_FIRE1)
        end
    end
end,
endfunc = function(player, selfid, value)
    --S_StartSound(player.mo, sfx_kc65, player)

    local function SpawnSpark(x, y, z, state) --gotta do this twice now :pensive:
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, MT_SIGNSPARKLE)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 10
        if state then
            Sperk.state = state
            Sperk.scale = $ / 2
        end
    end

    for i=69,1,-1 do -- nice
        SpawnSpark(P_RandomFixed()*4, P_RandomFixed()*5, P_RandomFixed()*6)
    end

    if value.explosive then
        local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TNTBARREL)
        explode.state = S_TNTBARREL_EXPL1
    end
end
}

  addEffect{name = "Bouncy Floors", chance = FRACUNIT/37, duration = 4, range = 2, etype = "bad", sprite = "BOUNCE", addition = 2, nospecialstage = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Gravity Coil", "Cement Tires", "Butter Physics", "Zero Gravity"},
description = "The floors don't like you, and keep bouncing you back up! Don't fast fall during this, otherwise you'll get even less control.",
func = function(player, selfid, value)
    if not value.started then
        player.mo.momz = 3*FRACUNIT
        player.mo.z = $ + 7*FRACUNIT
        value.LastMomZ = player.mo.momz
        value.started = true
    end

    if player.mo.momz/FRACUNIT == 0 then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if value.LastMomZ > 0 then
                value.BounceTime = true
            end
        else
            if value.LastMomZ < 0 then
                value.BounceTime = true
            end
        end
    else
        value.LastMomZ = player.mo.momz
    end

    if value.LastMomZ < FRACUNIT and P_IsObjectOnGround(player.mo) then
        value.LastMomZ = $ + 7*FRACUNIT
    end

    value.BounceTime = true

    if value.BounceTime then
        if P_IsObjectOnGround(player.mo) then
            player.mo.momz = abs(value.LastMomZ)
            if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
                player.mo.momz = -$
            end
            S_StartSoundAtVolume(player.mo, sfx_kc52, 150)
            value.BounceTime = false
        end
    end
end}

  addEffect{name = "Bleeding", chance = FRACUNIT/18, duration = 12, range = 5, sprite = "BLEED", addition = 7, etype = "bad", requirerings = true, nosrb2kart = true, nobattle = true, -- CEIDK0
startsfx = sfx_kc59, endsfx = sfx_kc5a, localsfx = true,
incompatible = {"Money Bag"},
description = "You're bleeding rings! You will frequently drop the rings you have collected, if you're above 0 rings.",
func = function(player, selfid, value)
    local function SetTime()
        if tonumber(CV_FindVar("tkk_Amplify").value)  then
            value.timeseed = P_RandomRange(TICRATE/4, TICRATE-TICRATE/5)
        else
            value.timeseed = P_RandomRange(TICRATE/2, TICRATE+(TICRATE/5))
        end
    end
    if not value.started then
        value.started = true
        SetTime()
    end

    -- every second, player is drained one ring, goes invicible for a split second, and a ring pops out of them

    local function Bleed(silent)
        if player.rings > 0 then
            --[[if player.powers[pw_flashing] == 0 then
                player.powers[pw_flashing] = TICRATE/3 + 3
            end]]
            local z = (player.mo.z + player.mo.height) + 16*FRACUNIT
            if (player.mo.eflags & MFE_VERTICALFLIP) then
                z = (player.mo.z - player.mo.height) - 16*FRACUNIT
            end
            local ring = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_FLINGRING)
            ring.fuse = 5*TICRATE
            ring.target = player.mo
            ring.destscale = player.mo.destscale
            ring.scale = player.mo.scale
            ring.angle = player.mo.angle

            P_GivePlayerRings(player, -1)
            if not silent then
                S_StartSound(player.mo, sfx_antiri)
                if P_RandomChance(FRACUNIT/4) then
                    SetTime()
                end
            end

            if (player.mo.eflags & MFE_VERTICALFLIP) then
                ring.momz = player.mo.momz - player.mo.scale*10
            else
                ring.momz = player.mo.momz + player.mo.scale*10
            end

            ring.momx = player.mo.momx - (P_RandomRange(-8, 8)*player.mo.scale)
            ring.momy = player.mo.momy - (P_RandomRange(-8, 8)*player.mo.scale)
        end
    end

    if leveltime % value.timeseed == 0 then
        Bleed()
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            Bleed(true)
        end
    end
end}


  addEffect{name = "Windy Day", chance = FRACUNIT/26, duration = 6, range = 3, sprite = "WIND", addition = 3, etype = "bad", drainrespawntimer = true, nospecialstage = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "A mighty gust is blowing you every which way! You're blown in a certain direction, which changes every now and then to blow you a different way.",
func = function(player, selfid, value)
    if not value.started then
        S_StartSound(player.mo, sfx_s3kcel, player)
        value.angle = player.mo.angle-ANGLE_180
        value.changeang = 0
        value.thrust = FRACUNIT/2 - FRACUNIT/8
        value.posneg = false -- honestly i have no fucking clue what this does. what drugs were you on, 2020-or-so jasmine?
        value.started = true
    end


    if value.changeang > 0 then
        if value.posneg then
            value.angle = $ - (ANG2 + ANG1)
        else
            value.angle = $ + ANG2 + ANG1
        end
        value.changeang = $ - 1
        value.thrust = P_RandomRange(FRACUNIT/2 - FRACUNIT/8, FRACUNIT/2 - FRACUNIT/4) + P_RandomFixed()/4
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            value.thrust = $ + P_RandomFixed()/2
        end
        if VERSION < 2 then
            value.thrust = $ * 2
        end
    else
        value.changeang = 0
        value.posneg = not value.posneg
        if P_RandomChance(FRACUNIT/5) then
            value.changeang = P_RandomRange(5, 25)
            if tonumber(CV_FindVar("tkk_Amplify").value) then
                value.changeang = $ + 2
            end
            --DebugPrint(player, "Changing Angle!")
        end
    end

    P_Thrust(player.mo, value.angle, value.thrust)
end}

  addEffect{name = "Zero Gravity", chance = FRACUNIT/26, etype = "bad", duration = 5, range = 2, sprite = "ZEROGRAV", addition = 3, resetvalues = true,
startsfx = sfx_s3k9c, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Cement Tires", "Moonjump", "Bouncy Floors"},
description = "Your gravity has been turned off! Often results in you being catapulted to the sky.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.laststoredmom = player.mo.momz
    end

    if not isPlayerRespawning(player) then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if value.laststoredmom < player.mo.momz then
                player.mo.momz = value.laststoredmom
            end
        else
            if value.laststoredmom > player.mo.momz then
                player.mo.momz = value.laststoredmom
            end
        end
    end

    value.laststoredmom = player.mo.momz
end}

addEffect{name = "Timebomb", chance = FRACUNIT/31, duration = 3, addition = -1, sprite = "BOMB", etype = "bad", drainrespawntimer = true, noghost = true,
startsfx = sfx_s3k5c,
incompatible = {"Ghost"},
description = "\x83\"Somebody set us up the bomb!\"\x80 You have a few seconds to react to the fact you're gonna explode! Applies the same explosion as falling for a Proximity Mine.",
func = function(player, selfid, value)
    if not value.started then
        value.repeatsound = 1
        value.subtracttime = 8
        value.sublimetime = 3
        value.defaulttimer = value.duration*TICRATE - value.timer
        value.started = true
    end

    local function SpawnSplode(x, y, z)
        local theobj = MT_SONIC3KBOSSEXPLODE
        if P_RandomChance(FRACUNIT/5) then
            theobj = MT_BOSSEXPLODE
        end
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, theobj)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 5
    end

    local function Blinker()
        if not value.back then
            player.mo.colorized = true
            value.prevcolor = player.mo.color
            player.mo.color = SKINCOLOR_RED
            value.back = true
        else
            player.mo.colorized = false
            player.mo.color = value.prevcolor
            value.back = false
        end
    end

    SpawnSplode(P_RandomFixed()*2, P_RandomFixed()*3, P_RandomFixed()*2)

    if value.defaulttimer > (value.duration*TICRATE - value.timer) - value.repeatsound then -- beeping
        value.repeatsound = $ - value.subtracttime
        value.sublimetime = $ - 1
        if value.sublimetime <= 0 then
            value.sublimetime = 3
            value.subtracttime = $ - 1
        end
        S_StartSound(player.mo, sfx_deton) --sfx_kc2a
        Blinker()
    end

    if value.duration*TICRATE - value.timer == TICRATE/2 + TICRATE/3 then
        S_StartSound(player.mo, sfx_s3k86)
    end
end,
endfunc = function(player,selfid, value)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    S_StartSound(player.mo, sfx_s3k4e)
    player.mo.color = value.prevcolor
end}

  addEffect{name = "the ride never ends", chance = FRACUNIT/20, duration = 15, range = 8, sprite = "THERIDE", addition = 4, etype = "bad", nosrb2kart = true, --nospawn = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "\x83\"I want to get off TAILS WILD RIDE\"\x80 Your screen's perspective gets angled! It gets worse in Amplify Mode.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        local RANDYSPIN = P_RandomChance(FRACUNIT/2)
        if not RANDYSPIN then
            player.khaos.SpinOtherWay = true
        else
            player.khaos.SpinOtherWay = false
        end
        value.angler = (ANG30 + ANG15)
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            value.angler = (ANG30 + ANG30)
        end
    end
    if not player.khaos.SpinOtherWay then
        if player.viewrollangle < value.angler then
            player.viewrollangle = $ + (ANG1/5)
            player.mo.rollangle = $ - (ANG1/5)
        end
    else
        if player.viewrollangle > -value.angler then
            player.viewrollangle = $ - (ANG1/5)
            player.mo.rollangle = $ + (ANG1/5)
        end
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.RestoreViewAngle = true
end}

  addEffect{name = "Pancake", chance = FRACUNIT/10, duration = 8, range = 5, sprite = "PANCAKE", addition = 7, etype = "bad", nosrb2kart = true,
startsfx = sfx_chcake, endsfx = sfx_kc65, forcestart = true,
description = "You get squashed like a pancake, and your max speed gets halved. This is more common than Cement Shoes, and less incompatible with other effects.",
incompatible = {"Cement Tires", "Sticky Slopes", "Moonjump", "HE"},
func=function(player, selfid, value)
    if not value.started then
        value.started = true
        value.GOALY = FRACUNIT/4 + FRACUNIT/20
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            value.GOALY = FRACUNIT/6 + FRACUNIT/9 -- nice
        end
        player.khaos.RestoreSpriteXScaleUp = nil
        player.khaos.RestoreSpriteYScaleUp = nil
        player.khaos.RestoreSpriteXScaleDown = nil
        player.khaos.RestoreSpriteYScaleDown = nil
    end

    player.mo.spritexscale = FRACUNIT + FRACUNIT

    if player.mo.spriteyscale != value.GOALY then
        if player.mo.spriteyscale > value.GOALY then
            player.mo.spriteyscale = $ - FRACUNIT/2
        elseif player.mo.spriteyscale < value.GOALY then
            player.mo.spriteyscale = value.GOALY
        end
    end

    if tonumber(CV_FindVar("tkk_Amplify").value) then
        player.kartspeed = value.Defaultkartspeed / 2 - value.Defaultkartspeed / 6 --  33%
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 4
    else
        player.kartspeed = value.Defaultkartspeed / 2 --50%
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 8
    end
end,
endfunc=function(player, selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    player.khaos.RestoreSpriteYScaleUp = true
    player.mo.spritexscale = FRACUNIT
end}

  addEffect{name = "Give Good Stuff", chance = FRACUNIT/24, duration = -1, notimer = true, etype = "good", sprite = "GOODSTUFF", startsfx = sfx_chchng, forcestart = true, localsfx = true, nohudtext = true,
description = "Gives the player a few good things. It can give the player invincibility or a pogo spring, or 50 rings and some i-frames.",
func = function(player, selfid, value)
    local GivenGoodStuff = false

    if player.itemamount == 0 and P_RandomChance(FRACUNIT/15) then
        player.itemtype = KITEM_INVINCIBILITY
        player.itemamount = 1
        S_StartSound(player.mo, sfx_itrolf, player)
        addHUDText(player, "Given Invincibility Item")
        GivenGoodStuff = true
    end

    if player.itemamount == 0 and P_RandomChance(FRACUNIT/25) then
        player.itemtype = KITEM_POGOSPRING
        player.itemamount = 1
        S_StartSound(player.mo, sfx_itrolf, player)
        addHUDText(player, "Given Pogo Spring Item")
        GivenGoodStuff = true
    end

    if P_RandomChance(FRACUNIT/4) then
        player.superring = $ + 50
        player.spinouttype = KSPIN_IFRAMES
        player.flashing = 76
        addHUDText(player, "Given 50 rings and i-frames")
        GivenGoodStuff = true
    end

    value.fxdone = GivenGoodStuff
end,
kartfunc = function(player, selfid, value)
    if P_RandomChance(FRACUNIT/2) and not (player.kartstuff[k_itemtype] or player.kartstuff[k_itemheld]) then
        player.kartstuff[k_itemroulette] = 1
        addHUDText(player, "Given an item roulette")
        value.GivenNiceStuff = true
    end

    if P_RandomChance(FRACUNIT/6) or (tonumber(CV_FindVar("tkk_Amplify").value) and P_RandomChance(FRACUNIT/8)) then
        player.kartstuff[k_curshield] = 1
        addHUDText(player, "Given a shield")
        value.GivenNiceStuff = true
    end

    -- k_invincibilitytimer

    if P_RandomChance(FRACUNIT/99) or (tonumber(CV_FindVar("tkk_Amplify").value) and P_RandomChance(FRACUNIT/70)) then
        player.kartstuff[k_itemroulette] = 1
        player.kartstuff[k_roulettetype] = 1
        addHUDText(player, "Given a Good item roulette")
        value.GivenNiceStuff = true
    end

    if not value.GivenNiceStuff and not (player.kartstuff[k_itemtype] or player.kartstuff[k_itemheld]) then
        player.kartstuff[k_itemroulette] = 1
        K_DoSneaker(player, 0)
        addHUDText(player, "Given a boost, and item roulette")
    end

    value.fxdone = value.GivenNiceStuff
end
}


  addEffect{name = "Cement Tires", chance = FRACUNIT/21, duration = 7, range = 4, sprite = "CEMENTTIRE", addition = 1, nocart = true, etype = "bad", nospecialstage = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "Your tires have been filled with cement! Your max speed gets reduced by 80%.",
incompatible = {"HE", "Pancake", "Sticky Slopes", "I WAS FROZEN TODAY!", "Change Color", "Butter Physics", "Bouncy Floors", "Gravity Coil", "Moonjump", "Zero Gravity"}, -- so many items
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        --value.CementPrevColor = player.mo.color
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
    end
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        player.kartspeed = value.Defaultkartspeed / 5 -- 20%
        player.kartweight = value.Defaultkartweight * 4
    else
        player.kartspeed = value.Defaultkartspeed / 4 -- 25%
        player.kartweight = value.Defaultkartweight * 3
    end

    -- P_SetObjectMomZ(player.mo, -gravity, true)

    if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
        if player.mo.momz > 0 then
            player.mo.momz = $ + $ / 10
        else
            player.mo.momz = $ - $ / 8
        end
    else
        if player.mo.momz > 0 then
            player.mo.momz = $ - $ / 10
        else
            player.mo.momz = $ + $ / 8
        end
    end

    if not P_IsObjectOnGround(player.mo) then
        player.khaos.CementShoesSfx = true
        if player.mo.momz < -(3*FRACUNIT) and not player.khaos.CementShoesFallSfx then
            S_StartSound(player.mo, sfx_s3k51, player)
            player.khaos.CementShoesFallSfx = true
        end
    else
        if player.khaos.CementShoesSfx then
            S_StartSound(player.mo, sfx_s3k5f) --previously sfx_pstop, and before that, sfx_doord2
            if VERSION >= 2 then
                P_StartQuake(15, 10*FRACUNIT, 10*FRACUNIT, player.mo)
            else
                P_StartQuake(10*FRACUNIT, 5, nil, nil)
            end
            player.khaos.CementShoesSfx = false
        end
        player.khaos.CementShoesFallSfx = false

        value.angle = player.mo.angle - ANGLE_180
        value.thrust = player.speed / 50

        P_Thrust(player.mo, value.angle, value.thrust)
    end
end,
endfunc = function(player,selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    --player.kartstuff[k_boostpower] = 0
    --player.mo.color = value.CementPrevColor
    --player.mo.colorized = false
end}

  addEffect{name = "Butter Physics", chance = FRACUNIT/28, duration = 8, range = 6, sprite = "BUTTER", addition = 2, etype = "neutral", nospecialstage = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Cement Tires", "Sticky Slopes"},
description = "Forget ice physics, your tires have been slathered with butter. You are completely unstoppable. You might go zooming across the entire track... or keep falling into pits. Or both.",
func = function(player, selfid, value)
    if not player.khaos.OGFriction then player.khaos.OGFriction = player.mo.friction end
    player.mo.friction = FRACUNIT + (FRACUNIT/80)
end,
endfunc = function(player,selfid, value)
    player.mo.friction = player.khaos.OGFriction
end}

  addEffect{name = "Fling Player", chance = FRACUNIT/10, duration = 0, sprite = "CANNON", nohudtext = true, etype = "bad", nospecialstage = true,
incompatible = {"I WAS FROZEN TODAY!"},
description = "You get tossed around, either forward or backwards. If you get slapped or yeeted, you also spin out!",
func=function(player, selfid, value)
    local RANDYSLAP
    local RANDYYEET = P_RandomChance(FRACUNIT/20) -- 5%
    local Angler = player.mo.angle + (P_RandomRange(0, 4) * ANGLE_90)
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        P_InstaThrust(player.mo, Angler, 170*FRACUNIT)
        if P_IsObjectOnGround(player.mo) then RANDYSLAP = P_RandomChance(FRACUNIT/3) end -- 33.3%, reduced chances since spinout causes you to lose control
    else
        P_InstaThrust(player.mo, Angler, 80*FRACUNIT)
        if P_IsObjectOnGround(player.mo) then RANDYSLAP = P_RandomChance(FRACUNIT/2 + FRACUNIT/6) end -- 66.6%
    end
    if RANDYSLAP or RANDYYEET then
        if RANDYYEET then
            addHUDText(player, "YEET", true)
            local yeetsfx = sfx_chyee2
            if P_RandomChance(FRACUNIT/2) then
                yeetsfx = sfx_chyeet
            end
            S_StartSound(player.mo, yeetsfx)
            S_StartSound(player.mo, sfx_kc5b, player)
        else
            addHUDText(player, "Slapped!")
            S_StartSound(player.mo, sfx_slappy)
        end
        --[[player.spinouttype = KSPIN_WIPEOUT
        player.spinouttimer = TICRATE
        player.mo.state = S_KART_SPINOUT]]
        if VERSION >= 2 then
            K_TumblePlayer(player)
        else
            player.mo.state = S_KART_SPIN
            player.powers[pw_flashing] = TICRATE
        end
        --player.powers[pw_flashing] = TICRATE
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            player.mo.momz = $ + 12*FRACUNIT
        else
            player.mo.momz = $ + 5*FRACUNIT
        end
    else
        addHUDText(player, "Fling Player")
        S_StartSound(player.mo, sfx_s3k81)
        player.mo.momz = $ + 2*FRACUNIT
    end
    value.fxdone = true
end
}

local eatmydust

if VERSION >= 2 then
    eatmydust = MT_DUST
else
    eatmydust = MT_BOOSTSMOKE
end

  addEffect{name = "Change Character", chance = FRACUNIT/29, duration = 3, range = 2, sprite = "CHARS", etype = "neutral", endsfx = sfx_kc65, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Change Color"},
description = "Changes your current character repeatedly until the effect expires. This can't pick any characters you haven't unlocked yet!",
func = function(player, selfid, value)
    if not value.started then
        local RANDYC = P_RandomRange(-5, TICRATE-(TICRATE)/2) -- approximately 17 tics, or half a second
        value.timer = $ - RANDYC
        value.skinzor = skins[1].name --iniitialize it to something so we don't get an error
        value.started = true
    end
    if (leveltime % 5 == 0) then
        S_StartSoundAtVolume(player.mo, sfx_kc56, 136)
        repeat
            value.skinzor = skins[P_RandomRange(1, #skins-1)].name
        until value.skinzor and (VERSION < 2 or (VERSION >= 2 and R_SkinUsable(player, value.skinzor))) -- have to check skinzor is unlocked by the player
        R_SetPlayerSkin(player, value.skinzor)
    end
end,
endfunc = function(player, selfid, value)
    if not value.freeze then
        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, eatmydust)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1
        addHUDText(player, "Character changed to: " .. skins[player.mo.skin].realname)
        --[[if player.bot then
            player.name = skins[player.mo.skin].realname -- doesn't work :(
        end]]
    end
end
}

  addEffect{name = "Change Color", chance = FRACUNIT/13, duration = 3, range = 2, sprite = "COLORS", etype = "neutral", nomatch = true, endsfx = sfx_kc65, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Cement Tires", "Change Character"},
description = "This changes your character's color until the timer expires.",
func = function(player, selfid, value)
    if (leveltime % 4 == 0) then
        local funnytablelength = 0
        if VERSION >= 2 then
            funnytablelength = #skincolors
        else
            funnytablelength = MAXSKINCOLORS
        end
        player.mo.color = P_RandomRange(1, funnytablelength-1)
        S_StartSoundAtVolume(player.mo, sfx_kc56, 136)
        player.skincolor = player.mo.color
    end
end,
endfunc = function(player,selfid, value)
    if not value.freeze then
        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, eatmydust)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1
        if VERSION >= 2 then
            addHUDText(player, "Color changed to: " .. R_GetNameByColor(player.mo.color))
        end
        player.skincolor = player.mo.color -- one last time, just to be sure
    end
end
}

  addEffect{name = "Lucky!", chance = FRACUNIT/16, etype = "good", duration = 15, range = 8, sprite = "LUCK", addition = 1,
startsfx = sfx_s1c9, endsfx = sfx_kc65, localsfx = true,
incompatible = {"PANIC", "Marked For Death"},
description = "This makes it so most of the time you take a hit, you instead dodge it! You're also more likely to roll good effects than bad. Finally, the time between effects is increased a bit.",
func=function(player, selfid, value)
    player.khaos.IsLucky = true
    if player.khaos.timer > 0 and tonumber(CV_FindVar("tkk_Amplify").value) or P_RandomChance(FRACUNIT/4) then -- reduce da timer just a bit
        player.khaos.timer = $ - 1
    end
end,
endfunc = function(player)
    player.khaos.IsLucky = false
end
}

  addEffect{name = "PANIC", chance = FRACUNIT/30, etype = "bad", duration = 14, range = 6, sprite = "PANIC", addition = 3,
startsfx = sfx_alarm, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Lucky!"},
description = "Effects get applied to you alarmingly quick! You're also more likely to roll bad effects!",
func=function(player, selfid, value)
    player.khaos.timer = $ + 1
    player.khaos.IsPanicking = true
    if tonumber(CV_FindVar("tkk_Amplify").value) or P_RandomChance(FRACUNIT/14) then -- do it even m o r e
        player.khaos.timer = $ + 2
    end
end,
endfunc = function(player)
    player.khaos.IsPanicking = false
end
}

  addEffect{name = "Kids These Days", chance = FRACUNIT/34, duration = 11, range = 4, sprite = "IPADKID", etype = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Darkened Vision", "DVD Screensaver"},
description = "\x83\"Back in my day...\"\x80 The sides of your screen are obscured!",
func=function(player,selfid,value)
    player.khaos.ipadkid = true
end,

endfunc=function(player,selfid,value)
   player.khaos.ipadkid = false
end}

  addEffect{name = "Darkened Vision", chance = FRACUNIT/23, duration = 15, range = 5, sprite = "DARKV", etype = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Kids These Days"},
description="\x83\"Ya bring a light? No!\"\x80 Your vision is significantly darkened!",
func=function(player,selfid,value)
    player.khaos.DarkenedVisionNow = true
end,

endfunc=function(player,selfid,value)
    player.khaos.DarkenedVisionNow = false
end}

  addEffect{name = "YOU'RE WINNER", chance = FRACUNIT/18, duration = 18, range = 7, sprite = "WINNER", etype = "bad", addition = 5, nobot = true, nosrb2kart = true,
startsfx = sfx_ideya, endsfx = sfx_kc65, localsfx = true, --sfx_xideya?
incompatible={"Kids These Days"},
description="You win! Congratulations! Wait, you didn't? Well, you'll get showered in confetti anyways.",
func=function(player,selfid,value)
    player.khaos.yourewinner = true
end,

endfunc=function(player,selfid,value)
    player.khaos.yourewinner = false
end}

  addEffect{name = "Marked For Death", chance = FRACUNIT/36, duration = 25, range = 5, sprite = "MARKED", etype = "bad", addition = 5, nospecialstage = true, nosrb2kart = true,
startsfx = sfx_chmark, endsfx = sfx_kc65, localsfx = true,
incompatible={"Super Explosive 64", "Lucky!", "Nuke"},
description  = "Every hit you take will make you tumble instead! There's also a chance you just get stunlocked for a little bit, watch out!",
func = function(player, selfid, value)
    if not value.started then
        player.khaos.Marked4Death = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+105*(player.mo.scale/2), MT_MARKED4DEATH)
        player.khaos.Marked4Death.gayer = player
        value.started = true
    end

    player.khaos.ImDyingSquirtle = true
    if (leveltime % 6) == 0 then
        player.khaos.Tumbler = $ - 1
    end
end,
endfunc=function(player,selfid,value)
    player.khaos.ImDyingSquirtle = false
    player.khaos.Tumbler = 0
    if player.khaos.Marked4Death and player.khaos.Marked4Death.valid then
        P_KillMobj(player.khaos.Marked4Death)
    end
    player.khaos.Marked4Death = nil
end}

  addEffect{name = "Invisible", chance = FRACUNIT/26, etype = "neutral", duration = 10, range = 5, sprite = "NOTHING", addition = 3, resetvalues = true, nosrb2kart = true, --invisibleblink = true,
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true,
incompatible = {"Ghost", "Change Sprite", "Laggy Model"},
description="\x83\"I'm the invisible man.\"\x80 You can't see yourself, but also, neither can anyone else.",
func=function(player,selfid,value)
    player.khaos.InvisibleNow = true
end,

endfunc=function(player,selfid,value)
    player.khaos.InvisibleNow = false
end}

  addEffect{name = "DVD Screensaver", chance = FRACUNIT/27, duration = 12, range = 8, sprite = "DVD", etype = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Kids These Days"}, -- how fitting
description="Your screen has the DVD logo bouncing around! This hinders vision a lot.",
func=function(player,selfid,value)
    if not value.started then
        value.started = true
        local RANDY = P_RandomChance(FRACUNIT/8) -- pretty rare chance, just like how rare HD DVDs are to come across in the real world
        if RANDY then
            player.khaos.HDDVD = true
        end
    end

    player.khaos.DVDHud = true
end,

endfunc=function(player,selfid,value)
    player.khaos.DVDHud = false
    player.khaos.HDDVD = false
end}


  addEffect{name = "Always Watching.", chance = FRACUNIT/18, duration = 18, range = 15, sprite = "EYE", etype = "neutral", nosrb2kart = true,
startsfx = sfx_s3k8a, endsfx = sfx_kc65,
incompatible = {"I WAS FROZEN TODAY!", "Invisible"},
description="Your character is turned around 180 degrees, to face you. They know what you did last night.",
func=function(player,selfid, value)
    player.drawangle = player.mo.angle + ANGLE_180
end}

addEffect{name = "Superring", chance = FRACUNIT/15, duration = 0, etype = "good", sprite = "RING", startsfx = sfx_itemup, nobattle = true, nosrb2kart = true,
description="Gives you 10 rings! 20 rings in Amplify Mode.",
func=function(player,selfid, value)
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        --P_GivePlayerRings(player, 20)
        player.superring = $ + 20
    else
        --P_GivePlayerRings(player, 10)
        player.superring = $ + 10
    end
    value.fxdone = true
end}

addEffect{name = "Double Items", dontrollme = true, chance = 1, nohudtext = true, duration = -1, etype = "good", nobees = true, immune2remove = true, dontcountme = true, noblacklist = true,
description="This is an invisible effect that gets stored after Universal Effect grants everyone Double Items. This will make it so the next item you pick up gives you, well, double items! It's quadruple items in Amplify Mode.",
func=function(player,selfid, value) -- shut up this technically works
    if player.itemamount > 0 then
        player.itemamount = $ * 2
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            player.itemamount = $ * 2 -- quadruple
        end
        value.fxdone = true
    else
        value.timer = 0
    end
end,
kartfunc=function(player, selfid, value)
    if player.kartstuff[k_itemamount] > 0 then
        player.kartstuff[k_itemamount] = $ * 2
        if tonumber(CV_FindVar("tkk_Amplify").value) then
            player.kartstuff[k_itemamount] = $ * 2 -- quadruple
        end
        value.fxdone = true
    else
        value.timer = 0
    end
end
}

addEffect{name = "Anti-Superring", chance = FRACUNIT/18, duration = 0, etype = "bad", sprite = "ANTIRING", nosrb2kart = true, startsfx = sfx_antiri, nobattle = true, requirerings = true,
description="Takes away 10 rings! It takes away 20 rings in Amplify Mode, instantly putting you into ring debt.",
func=function(player,selfid, value)
    if tonumber(CV_FindVar("tkk_Amplify").value) then
        P_GivePlayerRings(player, -20) -- devastating
    else
        P_GivePlayerRings(player, -10)
    end
    value.fxdone = true
end}

  addEffect{name = "2x Rings", amplifyname = "4x Rings", chance = FRACUNIT/14, duration = 10, sprite = "2XRING", addition = 5, range = 3, etype = "good", nosrb2kart = true, nobot = true, nobattle = true, -- CEIDH0
description="Every ring you are given is worth twice the amount! In Amplify Mode, this becomes 4x the amount!",
startsfx = sfx_kc5a, endsfx = sfx_kc65, localsfx = true,
--incompatible = {"Negative Rings"},
func = function(player,selfid,value)
    if not value.started then
        value.started = true
        value.previousrings = player.rings

        --[[if tonumber(CV_FindVar("tkk_Amplify").value)then
            addHUDText(player, "4x Rings")
        else
            addHUDText(player, "2x Rings")
        end]]
    end

    if player.rings > value.previousrings then
        local soup = player.rings - value.previousrings
        if tonumber(CV_FindVar("tkk_Amplify").value)  then
            soup = ($ * 3)
        end
        P_GivePlayerRings(player, soup)
    end

    value.previousrings = player.rings
end}

  addEffect{name = "COMBO TIME!", chance = FRACUNIT/18, duration = 0, etype = "neutral", sprite = "PANIC", notimer = true,
description="This applies two roulettes at the same time!",
startsfx = sfx_kc48,
func=function(player, selfid, value)
    ApplyEffect(player, "Roulette")
    ApplyEffect(player, "Roulette")
    value.fxdone = true
end}

  addEffect{name = "Roulette", chance = 1, duration = -1, sprite = "PLACEHOLDER", nohudtext = true, notimer = true, dontrollme = true, noblink = true, dontcountme = true, noblacklist = true, removeimmediately = true, dontrememberme = true,
description = "This is the Khaos Roulette, the most evil creation that Tails has made. This rolls for effects, and depending on the chance to roll the effect, it will apply said effect to the current driver. Various conditions will stop effects from being applied however, just to tone back the chaos a smidge bit.",
func=function(player, selfid, value)
    if not value.started then
        value.VRoller = P_RandomRange(1, #KhaosEffectsTable-1)
        value.started = true
    end

    value.VRoller = $ + 1

    if value.VRoller > #KhaosEffectsTable then
        value.VRoller = 1
    end

    local evalue = KhaosEffectsTable[value.VRoller]

    if player.khaosoptions.tkk_Roulette_SFX and player.khaosoptions.tkk_HUD then
        S_StartSoundAtVolume(player.mo, sfx_cdfm46, 80, player) -- tink sound that plays when rolling an effect
    end
    value.icon = evalue.sprite
    if not evalue.sprite then
        value.icon = "KH_NOTHING"
    end
    local ChanceTime = evalue.chance
    if player.khaos.IsLucky then
        if evalue.etype == "bad" then
            ChanceTime = $ - ($/4)
        elseif evalue.etype == "good" then
            ChanceTime = $ + ($/3)
        end
    elseif player.khaos.IsPanicking then
        if evalue.etype == "bad" then
            ChanceTime = $ + ($/5)
        elseif evalue.etype == "good" then
           ChanceTime = $ - ($/5)
        end
    end

    if value.timer > TICRATE and not value.freeze and not evalue.dontrollme and P_RandomChance(ChanceTime) and CheckNonConflict(player, value.VRoller) then
        ApplyEffect(player, evalue.name, nil, value.hudnumber)
        value.fxdone = true
    end
end
}

addHook("PlayerSpawn", function(player)
    if not player.khaos then
        player.khaos = {}
        player.khaosmemory = {}
        player.khaoseffects = {}
        player.khaostext = {}
        player.khaoshud = {}
        player.khaosHUDNumber = 1 -- seperate value, as to not get reset by anything hopefully
    end

    if not player.khaosoptions then -- keep seperate to not have this reset on map change
        player.khaosoptions = {}
        player.khaosblacklist = {}
        player.khaos.OptionDelay = 3*TICRATE
        for key, value in pairs(optionstableofdoom) do
            if not value.localonly then
                local TheGame = value.name --you lost it
                local TheMame = CV_FindVar(TheGame).defaultvalue
                if value.typer == "number" then
                    TheMame = tonumber($)
                end
                player.khaosoptions[TheGame] = TheMame
            end
        end
    else
        player.khaos.OptionDelay = -1
        player.khaos.OptionsTextConfirm = true
        player.khaos.OptionsLoaded = true
    end

    if #player.khaosblacklist == 0 then -- for some reason i can't understand, the blacklist gets reset on map change. so fuck it, this is my solution.
        LoadBlacklistSettings(player)
    end

    player.khaos.timer = 0
    player.khaos.WaitTime = 0
    player.khaos.failsafetimer = 0
    player.khaos.addHUDTextRando = 0
    player.khaos.HUDMoveUp = 0
    player.khaos.TextPopUpTimer = 0
    player.khaos.TextPopUpFade = 0
    if not tkk_Enabled then
        player.khaos.TextPopUpTimer = 6969
        player.khaos.TextPopUpFade = 6969
    end
    player.khaos.UniPopUpTimer = 0
    player.khaos.UniEffectSubTextBuffer = ""
    player.khaos.UniEffectTextBuffer = ""
    player.khaos.UniEffecTextBufferNumber = 1
    player.khaos.UniTextPopUpFade = 0
    player.khaos.TextBoxAdvancePage = 0
    player.khaos.TextBoxFader = 0
    player.khaos.Tumbler = 0

    if VERSION >= 2 --why the fuck doesn't srb2kart know what MO is
        player.khaos.RewindX = player.mo.x
        player.khaos.RewindY = player.mo.y
        player.khaos.RewindZ = player.mo.z
        player.khaos.RewindAngle = player.mo.angle
        if not player.khaos.OGFriction then
            player.khaos.OGFriction = player.mo.friction
        end
    end

    player.khaos.InvertControlsNow = nil
    player.khaos.BorkedSteering = nil

end)

--[[addHook("ThinkFrame", function()
    if (leveltime % TICRATE == 0) then
        --print("hi")
        --print(KhaosEffectsTable[1])
        --print(KhaosEffectsTable[1].name)
    end
end)]]

if VERSION >= 2 then
    addHook("PlayerCmd", function(player, ticcmd)
        if not player.khaos then return end
        if player.khaos.BorkedSteering then
            ticcmd.turning = $ + player.khaos.BorkedSteering
        end
        if player.khaos.InvertControlsNow then
            ticcmd.turning = -$
        end
    end)
end

addHook("PreThinkFrame", function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if player.khaos.FrozenNow then
                if VERSION >= 2 then
                    if (tonumber(player.khaos.postturning) != tonumber(player.cmd.turning))
                    and player.khaos.FrozenWait == 0 then
                        player.khaos.FrozenShake = true -- isn't that just a slushie?
                    end
                    player.khaos.postturning = player.cmd.turning
                else
                    if ((tonumber(player.khaos.postfowardmove) != tonumber(player.cmd.forwardmove)) or
                    (tonumber(player.khaos.postsidemove) != tonumber(player.cmd.sidemove)))
                    and player.khaos.FrozenWait == 0 then
                        player.khaos.FrozenShake = true
                    end
                    player.khaos.postfowardmove = player.cmd.forwardmove
                    player.khaos.postsidemove = player.cmd.sidemove
                end
            end
        end
    end
end)

addHook("PostThinkFrame", function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if player.khaos.GhostNow then  -- thanks to Faye on the SRB2 discord for discovering how to get MF2_SHADOW working
                player.mo.renderflags = $ | RF_SHADOWDRAW
            end
            if player.khaos.GhostBegone then
                player.mo.renderflags = $ & ~RF_SHADOWDRAW
                player.khaos.GhostBegone = false
            end

            if player.khaos.InvisibleNow then
                player.mo.renderflags = $ | RF_DONTDRAW
            end

            if player.khaos.InvisibleBegone then
                player.mo.renderflags = $ & ~RF_DONTDRAW
                player.khaos.InvisibleBegone = false
            end

            if player.khaos.FrozenNow and not player.khaos.ChangeSpriteNow and player.khaos.FrozenState and not isPlayerRespawning(player) then
                player.mo.state = player.khaos.FrozenState
                player.mo.frame = player.khaos.FrozenFrame
                player.nocontrol = 1
                if VERSION < 2 then
                    player.powers[pw_nocontrol] = 1
                end
                if player.followmobj
                and player.khaos.FollowFrozenState and player.khaos.FollowFrozenFrame then -- redundancy beacuse script errord during testing for some unknown reason
                    player.followmobj.state = player.khaos.FollowFrozenState
                    player.followmobj.frame = player.khaos.FollowFrozenFrame
                end
            end

            if player.khaos.FrozenShake and player.khaos.FrozenWait > 2 then
                player.mo.spritexoffset = P_RandomRange(-5, 5) * FRACUNIT
                player.mo.spriteyoffset = P_RandomRange(-5, 5) * FRACUNIT
            end
        end

        if player.khaos.GhostNow then  -- thanks to Faye on the SRB2 discord for discovering how to get MF2_SHADOW working
            player.mo.renderflags = $ | RF_SHADOWDRAW
        end
        if player.khaos.GhostBegone then
            player.mo.renderflags = $ & ~RF_SHADOWDRAW
            player.khaos.GhostBegone = false
        end

        if player.khaos.InvisibleNow then
            player.mo.renderflags = $ | RF_DONTDRAW
        end

        if player.khaos.InvisibleBegone then
            player.mo.renderflags = $ & ~RF_DONTDRAW
            player.khaos.InvisibleBegone = false
        end
    end
end)

addHook("PlayerThink", function(player)
    if not ValidityCheck(player) return end -- if turning playerthink into a thinkframe hook, be sure to change this around too
    --print(player.camera)

    if tonumber(player.khaos.FlutterTimer) then
        player.khaos.FlutterTimer = $ + 1
        if player.khaos.FlutterTimer >= 2 then
            if player.khaos.ItsFreakingFluttershy and player.khaos.ItsFreakingFluttershy.valid then
                P_KillMobj(player.khaos.ItsFreakingFluttershy)
            end
            player.khaos.ItsFreakingFluttershy = nil
            player.khaos.FlutterTimer = nil
        end
    end

    if player.khaos.OptionDelay > -9 then
        player.khaos.OptionDelay = $ - 1
    end

    if player.khaos.OptionDelay <= 0 and not player.khaos.OptionsLoaded then
        if not player.bot or VERSION < 2 then
            LoadSettings(player)
        else -- player is bot, or we're in srb2kart, don't try to load anything
            player.khaos.OptionsLoaded = true
            player.khaos.OptionsLoadAmount = 1
        end
    end

    --[[if player.khaos.OptionDelay <= -4 and not player.khaos.BLOptionsLoaded then
        if not player.bot or VERSION < 2 then
            LoadBlacklistSettings(player)
        else -- player is bot, or we're in srb2kart, don't try to load anything
            player.khaos.BLOptionsLoaded = true
        end
    end]]

    if player.khaos.OptionsLoaded and not player.khaos.OptionsTextConfirm and player.khaos.OptionDelay <= -8 then -- need to wait just a little bit for the slow-ass command to actually change the load failed value
        if player.khaos.LoadFailed then
            addHUDText(player, "\x85" + "Error loading options! Check the console & luafiles folder.", true, 4)
            S_StartSound(player.mo, sfx_adderr, player)
        else
            if player.khaos.OptionsLoadAmount > 0 then
                addHUDText(player, "\199" + "Loaded options!", true)
                S_StartSound(player.mo, sfx_gshc4, player) --sfx_tmxsuc
                S_StartSound(player.mo, sfx_gshc4, player)
                S_StartSound(player.mo, sfx_gshc4, player)
            else --newbie, try to tell them to look at the tkk_Help command. sucks to be a controller user i guess
                addHUDText(player, "\201" + "Welcome!" + "\200 \x80" + "Use '" + "\199" + "tkk_Help" + "\x80' in your console for options!", true, 8)
                addHUDText(player, "And use '" + "\199" + "tkk_Save_Settings" + "\x80' to stop this popping up!", true, 8)
                --TODO: if they fix addon settings to work everywhere else, replace this text!
                S_StartSound(player.mo, sfx_addfil, player) --sfx_tmxsuc
                S_StartSound(player.mo, sfx_addfil, player)
                --S_StartSound(player.mo, sfx_gshc4, player)
                --S_StartSound(player.mo, sfx_gshc4, player)
            end
        end
        player.khaos.OptionsTextConfirm = true
    end

    local Freezer = false

    --TODO: investigate if leveltime >= starttime works
    if leveltime < 6*TICRATE or player.exiting or player.playerstate == PST_DEAD or player.laps > numlaps then -- freeze all effects if the level is finished, or if the player Fucking Dies
        Freezer = true
    end

    player.khaos.Freezer = Freezer

    if player.khaos.WaitTime == 0 then
        player.khaos.WaitTime = P_RandomRange(TICRATE*3, TICRATE*10) -- TODO: replace with "minwait" and "maxwait" settings
        if player.khaos.IsLucky then
            player.khaos.WaitTime = $ + P_RandomRange(0, TICRATE) -- adds an extra second if lucky
        end
    end

    if not Freezer then
        player.khaos.timer = $ + 1
    end

    if (player.khaos.timer > player.khaos.WaitTime) then --activate roulette
        ApplyEffect(player, "Roulette")
        player.khaos.timer = 0
        player.khaos.WaitTime = 0
    end

    --[[if CV_FindVar("tkkDebug").value then --TODO: comment out this debug tool before playtest!
        if (player.cmd.buttons & BT_LUAA) then
            --K_SpinPlayer(player, nil, nil, KSPIN_THRUST)
            --K_DoInstashield(player)
            --K_TumblePlayer(player)
            --P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
            --DMG_DEATHPIT
            --P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
            --P_KillMobj(player.mo)
            --P_DamageMobj(player.mo, nil, nil, 1)
            if not player.khaos.holdabutton then
                player.hyudorotimer = $ + 10*TICRATE
                player.spinouttype = KSPIN_IFRAMES
                player.flashing = 76
                player.superring = $ + 10
            end
            player.khaos.holdabutton = true
        else
            player.khaos.holdabutton = false
        end

        if (player.cmd.buttons & BT_LUAB) then
            local Gay = "Change Sprite"
            COM_BufAddText(player, "TESTER")
            if not player.khaos.holddebugbutton and CheckNonConflict(player, indexOfName(KhaosEffectsTable, Gay), 3) then
                ApplyEffect(player, Gay)
            end
            player.khaos.holddebugbutton = true
        else
            player.khaos.holddebugbutton = false
        end


        if (player.cmd.buttons & BT_LUAC) then
            local Gay = "Change Color"
            if not player.khaos.hold3rdbutton then
                for p2 in players.iterate do
                    if ValidityCheck(player) then
                        ApplyEffect(p2, Gay)
                    end
                    --DebugPrint(player, "playerstate: " .. player.playerstate)
                end
            end
            player.khaos.hold3rdbutton = true
        else
            player.khaos.hold3rdbutton = false
        end
    end]]

    --[[if player.cmd.buttons & BT_DRIFT and player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and player.cmd.buttons & BT_ATTACK
        print(players[0].khaosoptions.tkk_Memory)
    end]]

    if isPlayerRespawning(player) then
        player.khaos.failsafetimer = $ + 1
    else
        player.khaos.failsafetimer = 0
    end

    -- [[ -- Effect Logic -- ]] --
    for index, value in ipairs(player.khaoseffects) do
        local effecter = KhaosEffectsTable[value.effect]

        if effecter.func and not Freezer and not value.removeme then
            effecter.func(player, index, value)

            if effecter.drainrespawntimer or (not isPlayerRespawning(player) or player.khaos.failsafetimer > 5*TICRATE) then -- don't decrease timer during respawn, unless the player's been respawning for > 5 seconds
                value.timer = $ + 1
            end
            if player.khaos.failsafetimer > 9*TICRATE then -- player seems to be taking awfully long to respawn, double the timer speeds to get rid of effects quick
                value.timer = $ + 1
            end
        end

        if isPlayerRespawning(player) and effecter.restartrespawn then
            value.started = false
        end

        if not value.removeme and ((value.duration > 0 and (value.timer > value.duration*TICRATE)) or value.fxdone or player.laps > numlaps) then
            DebugPrint(player, "MARKING 4 REMOVAL: " + effecter.name)
            if effecter.endfunc then
                effecter.endfunc(player, index, value)
            end
            if player.khaosoptions.tkk_HUD or effecter.forceend and (player.laps <= numlaps) then -- last one is to prevent all the effect end sounds from playing at the same time
                if effecter.endsfx then
                    if value.localsfx then
                        S_StartSound(player.mo, effecter.endsfx, player)
                    else
                        S_StartSound(player.mo, effecter.endsfx)
                    end
                end
            end
            --table.remove(player.khaoseffects, index)
            player.khaoseffects[index].removeme = 1 -- timer that counts up to 35, then it gets removed completely
            --table.remove(player.khaoshud, index)
        end

        if value.removeme then
            value.removeme = $ + 1
            if value.removeme > 40 or effecter.removeimmediately then
                DebugPrint(player, "NOW REMOVING: " + effecter.name)
                table.remove(player.khaoseffects, index)
            end
        end

    end

    -- i think the best way to go about this is w/ predicted length, find the current x coordinates of absolutely everything, and add it all up.
    -- that's how we center it all.

    --[[for index, value in ipairs(player.khaoshud) do
        -- screen width: 320
        -- icon size: 20
        -- icon gap: 3?
        -- y position: 175, and for top... idk lol

    end]]

    -- Rewind --
    if (leveltime % (3*TICRATE)) == 0 then --every 2 seconds is a lot more generous
        --print("set new position")
        player.khaos.RewindX = player.mo.x
        player.khaos.RewindY = player.mo.y
        player.khaos.RewindZ = player.mo.z
        player.khaos.RewindAngle = player.mo.angle
    end

    -- Restore angle'd view --
    if player.khaos.RestoreViewAngle then
        if player.khaos.SpinOtherWay then
            if player.viewrollangle < 0
                player.viewrollangle = $ + (ANG10/4)
                player.mo.rollangle = $ - (ANG10/4)
            else
                player.viewrollangle = 0
                player.mo.rollangle = 0
                player.khaos.RestoreViewAngle = false
                player.khaos.SpinOtherWay = false
            end
        else
            if player.viewrollangle > 0 then
                player.viewrollangle = $ - (ANG10/4)
                player.mo.rollangle = $ + (ANG10/4)
            else
                player.viewrollangle = 0
                player.mo.rollangle = 0
                player.khaos.RestoreViewAngle = false
            end
        end
    end

    -- Restore Sprite Stuff --
    if player.khaos.RestoreSpriteYScaleUp then
        if player.mo.spriteyscale < FRACUNIT then
            player.mo.spriteyscale = $ + FRACUNIT/10
        elseif player.mo.spriteyscale >= FRACUNIT then
            player.mo.spriteyscale = FRACUNIT
            player.khaos.RestoreSpriteYScaleUp = false
        end
    end

    if player.khaos.RestoreSpriteXScaleDown then
        if player.mo.spritexscale > FRACUNIT then
            player.mo.spritexscale = $ - FRACUNIT/10
        elseif player.mo.spritexscale <= FRACUNIT then
            player.mo.spritexscale = FRACUNIT
            player.khaos.RestoreSpriteXScaleDown = false
        end
    end

    if player.khaos.RestoreSpriteYScaleDown then
        if player.mo.spriteyscale > FRACUNIT then
            player.mo.spriteyscale = $ - FRACUNIT/10
        elseif player.mo.spriteyscale <= FRACUNIT then
            player.mo.spriteyscale = FRACUNIT
            player.khaos.RestoreSpriteYScaleDown = false
        end
    end

    -- [[ -- HUD Logic -- ]] --

    player.khaos.TextPopUpTimer = $ + 1
    if (player.khaos.TextPopUpTimer > 5*TICRATE and (((player.khaos.TextPopUpTimer-2*TICRATE)*2) % 5 == 0)) then
        player.khaos.TextPopUpFade = $ + 1
    end

    if player.khaos.TextPopUpTimer > 10*TICRATE
        player.khaos.respawnmeinchief = true
    end

    if player.khaos.HUDMoveUp > 0 then
        player.khaos.HUDMoveUp = $ - 2
    end

    if player.khaos.HUDMoveUp < 0 or #player.khaostext == 0 then -- the latter shouldn't happen, but who knows if the screen gets flooded with text
        player.khaos.HUDMoveUp = 0
    end

    if player.khaos.addHUDTextRando > 0 then
        player.khaos.addHUDTextRando = $ - 1
    end

    for index, value in ipairs(player.khaostext) do
        -- starting position, then add 10 for each value
        value.timer = $ + 1

        if (value.expire - value.timer) > 1*TICRATE then
            value.flags = 0
        else
            if (((value.timer-2*TICRATE)*2) % 5 == 0) then
                value.trans = $ + 1
            end
            value.flags = value.trans<<V_ALPHASHIFT
        end

        if value.timer > value.expire then
            table.remove(player.khaostext, index)
            player.khaos.HUDMoveUp = $ + 9
        end
    end

    -- [[ -- Universal Effect Player HUD Logic -- ]] --

    player.khaos.ueTimer = ueTimer -- for the hud
    player.khaos.ueTimerMax = ueTimerMax
    if initiateUE then
        player.khaos.ueTimer = 0 -- just to make it look smooth when an effect is being rolled
    end

    if player.khaos.UniEffectText
        local MaxLength = #player.khaos.UniEffectText
        local SubMaxLength = 0
        if player.khaos.UniEffectSubText then
            SubMaxLength = #player.khaos.UniEffectSubText
        end

        if player.khaos.UniPopUpTimer % 1 == 0 then -- every one tic. used to be two but i'm leaving this here so it's easier to revert this if i want to
            player.khaos.UniEffecTextBufferNumber = $ + 1
        end

        player.khaos.UniEffectTextBuffer = string.sub(player.khaos.UniEffectText, 1, min(player.khaos.UniEffecTextBufferNumber, MaxLength))
        if player.khaos.UniEffectSubText then
            player.khaos.UniEffectSubTextBuffer = string.sub(player.khaos.UniEffectSubText, 1, min(player.khaos.UniEffecTextBufferNumber, SubMaxLength))
        end

        player.khaos.UniPopUpTimer = $ + 1
        if (player.khaos.UniPopUpTimer > 5*TICRATE and (((player.khaos.UniPopUpTimer-2*TICRATE)*2) % 5 == 0)) then
            player.khaos.UniTextPopUpFade = $ + 1
        end

        if player.khaos.UniPopUpTimer > 8*TICRATE
            player.khaos.UniPopUpTimer = 0
            player.khaos.UniTextPopUpFade = 0
            player.khaos.UniEffecTextBufferNumber = 1
            player.khaos.UniEffectText = nil
            player.khaos.UniEffectSubText = nil
            player.khaos.UniEffectSubTextBuffer = ""
            player.khaos.UniEffectTextBuffer = ""
        end
    end
end)


local UniversalEffectsTable = {}
rawset(_G, "UniversalEffectsTable", UniversalEffectsTable)
local PreviousUniversalEffect = "" -- done to prevent the same effect from being applied again
TailsKK.PreviousUniversalEffect = PreviousUniversalEffect

local function addUniversalEffect(tbl)
    if VERSION < 2 and tbl.nosrb2kart then
        return
    end
    table.insert(UniversalEffectsTable, tbl)
end

TailsKK.addUniversalEffect = addUniversalEffect -- this is probably a bad idea since this hasn't been tested at all, but whatever

-- addEffect{name = "TEST!", chance = FRACUNIT/99, effect = "good", duration = 10, sprite = "PLACEHOLDER", addition = 1, func = TestFunc}

local RunFunc = nil

function TailsKK.NilRunFunc()
    RunFunc = nil
end

addUniversalEffect{name = "Supersonic Racing", subtext = {"Try to keep your tires right on the ground!", "There's no time to look around!", "Come on, let the fire burn!"}, hudtextprefix = "\199\201",
sounds = {sfx_cssrac, sfx_cssra2}, microsounds = {sfx_mssrac, sfx_mssra2}, chance = FRACUNIT/32,
func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if VERSION >= 2 then
                player.invincibilitytimer = $ + 8*TICRATE
                local TwilightSparkle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INVULNFLASH)
                TwilightSparkle.target = player.mo
                TwilightSparkle.destscale = player.mo.scale
                P_SetScale(TwilightSparkle, player.mo.scale)
            else
                player.kartstuff[k_invincibilitytimer] = $ + 8*TICRATE
            end
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "The Most Attractive Racer", subtext = {"Finding player..."}, hudtextprefix = "\201",
sounds = {sfx_cattra, sfx_cattr2}, microsounds = {sfx_mattra, sfx_mattr2}, chance = FRACUNIT/46,
func = function()
    local TheName = ""
    local RanEffect = false
    local bhid = indexOfName(KhaosEffectsTable, "Black Hole")
    local pretext = " is"

    for player in players.iterate do
        if not RanEffect and ValidityCheck(player) and P_RandomChance(FRACUNIT/10) then -- small random chance just to keep it rolling a little bit, to heighten the tension
            if CheckNonConflict(player, bhid, 1, true) then
                ApplyEffect(player, "Black Hole")
            else
                ApplyEffect(player, "Effect Storage", {storeeffect = bhid})
                pretext = " will be"
            end
            TheName = player.name
            RanEffect = true
        end
    end

    if RanEffect then
        for player in players.iterate do
            if ValidityCheck(player) then
                player.khaos.UniEffectSubText = "\x82" + TheName + "\x80" + pretext + " the most attractive player!"
                player.khaos.UniEffecTextBufferNumber = 0
            end
        end
        RunFunc = nil
    end
end
}

addUniversalEffect{name = "Position Swap", subtext = {"Why was someone this far behind?", "not 8th again :("}, requiredplayers = 2,
sounds = {sfx_cposwa, sfx_cposw2}, microsounds = {sfx_mposwa, sfx_mposw2}, chance = FRACUNIT/69,
func = function()
    local PlayerPositions = {}
    -- playercount
    for player in players.iterate do
        if ValidityCheck(player) then
            table.insert(PlayerPositions, {player.mo.x, player.mo.y, player.mo.z, player.mo.momx, player.mo.momy, player.mo.momz, player.mo.angle, player.position})
            -- would really be nice to be able to swap player's current waypoints... but they specifically don't expose that currentwaypoint and nextwaypoint. why :(
        end
    end

    ShuffleInPlace(PlayerPositions)
    ShuffleInPlace(PlayerPositions)
    ShuffleInPlace(PlayerPositions)
    ShuffleInPlace(PlayerPositions) -- do it a few times to hopefully guarante everything's shuffled

    local index = 1 -- make it 1 to follow the table
    for player in players.iterate do
        if ValidityCheck(player) then
            P_SetOrigin(player.mo, PlayerPositions[index][1], PlayerPositions[index][2], PlayerPositions[index][3])
            player.mo.momx,
            player.mo.momy,
            player.mo.momz,
            player.mo.angle,
            player.position = PlayerPositions[index][4], PlayerPositions[index][5], PlayerPositions[index][6], PlayerPositions[index][7], PlayerPositions[index][8]
            player.lastpickupdistance = 0 -- in v2.3 of ring racers, this doesn't do anything. this should hopefully be fixed by an MR i made though!
            index = $ + 1
        end
    end
    S_StartSoundAtVolume(nil, sfx_s3k73, 255)
    S_StartSoundAtVolume(nil, sfx_s3k73, 255)
    S_StartSoundAtVolume(nil, sfx_s3k73, 255)

    RunFunc = nil
end
}
--sfx_mixup

local TrapTable = {}

if VERSION >= 2 then
    TrapTable = {MT_BANANA, MT_LANDMINE, MT_ORBINAUT, MT_DROPTARGET, MT_GACHABOM, MT_SSMINE}
else
    TrapTable = {MT_BANANA, MT_ORBINAUT}
end

addUniversalEffect{name = "Trap Rain", subtext = {"Ohhhhh Banana!", "Why is it THERE?"}, nobattle = true,
nosrb2kart = true, --TODO: fix for srb2kart. does it have a waypoint system? if so, what the fuck is the waypoint object called
sounds = {sfx_ctrain, sfx_ctrai2}, microsounds = {sfx_mtrain, sfx_mtrai2}, chance = FRACUNIT/52,
func = function()
    for mapthing in mapthings.iterate do
        if mapthing.type == mobjinfo[MT_WAYPOINT].doomednum and mapthing.mobj and mapthing.mobj.valid and (tonumber(CV_FindVar("tkk_Amplify").value) or P_RandomChance(FRACUNIT/3)) then
            local TheSlobject = TrapTable[P_RandomRange(1, #TrapTable)]
            if P_RandomChance(FRACUNIT/99) then
                TheSlobject = MT_SINK
            end
            local TheGlobject = P_SpawnMobj(mapthing.mobj.x + P_RandomRange(-32, 32)*FRACUNIT, mapthing.mobj.y + P_RandomRange(-32, 32)*FRACUNIT, mapthing.mobj.ceilingz-mobjinfo[MT_WAYPOINT].height, TheSlobject)
            P_InstaThrust(TheGlobject, FixedAngle(P_RandomRange(1, 359)*FRACUNIT), 5*mapobjectscale)
            if P_RandomChance(FRACUNIT/10) then
                TheGlobject.scale = $ * 2
            end
        end
    end
    RunFunc = nil
end
}

-- mercury: 0.378, (defaultgravity/4) + (defaultgravity/8)
-- venus: 0.907, (defaultgravity/2) + (defaultgravity/5) + (defaultgravity/5)
-- earth: 1 (duh)
-- moon: 0.166, (defaultgravity/10) + (defaultgravity/15)
-- mars: 0.377, (defaultgravity/5) + (defaultgravity/6)
-- jupiter: 2.36, (defaultgravity*2) + (defaultgravity/3)
-- saturn: 0.916, (defaultgravity/2) + (defaultgravity/6) + (defaultgravity/4)
-- uranus: 0.889, (defaultgravity/3) + (defaultgravity/3) + (defaultgravity/5)
-- neptune: 1.12, defaultgravity + defaultgravity/9
-- pluto: 0.071, (defaultgravity/14)

  addUniversalEffect{name = "Out Of This World", subtext = {"Oops, you shouldn't be seeing this text!"},
nosrb2kart = true,
sounds = {sfx_coutwo, sfx_coutw2}, microsounds = {sfx_moutwo, sfx_moutw2}, chance = FRACUNIT/32,
func = function()
    local defaultgravity = FRACUNIT/2 + FRACUNIT/5 + FRACUNIT/10 -- should equal 0.8, which we will then use this as the basis for our gravity calculations
    -- mapheaderinfo[gamemap].gravity
    local GravityTable = {
    {"Mercury", (defaultgravity/4) + (defaultgravity/8)},
    {"Venus", (defaultgravity/2) + (defaultgravity/5) + (defaultgravity/5)},
    {"Earth's Moon", (defaultgravity/10) + (defaultgravity/15)},
    {"Mars", (defaultgravity/5) + (defaultgravity/6)},
    --{"Saturn", (defaultgravity/2) + (defaultgravity/6) + (defaultgravity/4)},
    {"Uranus",  (defaultgravity/3) + (defaultgravity/3) + (defaultgravity/5)},
    {"Neptune", defaultgravity + (defaultgravity/9)},
    }

    if P_RandomChance(FRACUNIT/3) then -- make this far less likely, since it can break some maps
        table.insert(GravityTable, {"Jupiter", (defaultgravity*2) + (defaultgravity/3)})
    end

    if tonumber(CV_FindVar("tkk_Amplify").value) then
        table.insert(GravityTable, {"Pluto", (defaultgravity/14)}) -- hell
    end

    if gravity != defaultgravity then
        table.insert(GravityTable, {"Earth?", (defaultgravity)})
    end

    local TheOne = P_RandomRange(1, #GravityTable) --haha, ha, one
    local TheName = GravityTable[TheOne][1]
    gravity = GravityTable[TheOne][2]

    for player in players.iterate do
        if ValidityCheck(player) then
            player.khaos.UniEffectSubText = "\x86\201" + "Planetary Gravity" + "\x80\200 has been set to "+ ": " + TheName
            player.khaos.UniEffecTextBufferNumber = 0
        end
    end
    RunFunc = nil
end
}

  addUniversalEffect{name = "Extra Life", subtext = {"You've been given an extra life!"}, gamemodeneedslives = true,
nosrb2kart = true,
sounds = {sfx_cexlif, sfx_cexli2}, microsounds = {sfx_mexlif, sfx_mexli2}, chance = FRACUNIT/150,
func = function()
    for player in players.iterate do -- i think in multi-player, everyone has their own life count. if not, well fuck it, you get more lives for having friends
        player.lives = $ + 1
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "Insta-item", subtext = {"FOR FREE?", "It's free real estate.", "But what if I already have an item :(", "Please don't give me BAR again."}, --TODO: give player a hidden khaos effect for this instead.
sounds = {sfx_cinsit, sfx_cinsi2}, microsounds = {sfx_minsit, sfx_minsi2}, chance = FRACUNIT/18,
func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if not player.khaos.ItsFreakingFluttershy then
                player.lastpickupdistance = 0 -- in v2.3 of ring racers, this doesn't do anything. this should hopefully be fixed by an MR i made though!
                player.khaos.ItsFreakingFluttershy = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RANDOMITEM) -- might as well continue the MLP:FiM reference. it's freaking fluttershy
                player.khaos.ItsFreakingFluttershy.flags2 = $ | MF2_DONTRESPAWN -- just double insurance to make sure it doesn't respawn, or if it deleting somehow fails, that after pickup it goes away
                player.khaos.ItsFreakingFluttershy.target = player.mo
                if VERSION >= 2 and gametype != GT_BATTLE and P_RandomChance(FRACUNIT - FRACUNIT/4) then -- 75% chance for item, 25% chance for rings
                    player.khaos.ItsFreakingFluttershy.state = S_RANDOMITEM1
                    --[[if gametype == GT_BATTLE then -- i don't think this works for some reason, so it's disabled for the playtest. TODO: fix this after playtest lol
                        player.khaos.ItsFreakingFluttershy.state = S_SPHEREBOX1
                    end]]
                end
                player.khaos.FlutterTimer = 0
            end
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "You Get The Bees", subtext = {"Rolling effect..."},
sounds = {sfx_cbees, sfx_cbees2}, microsounds = {sfx_mbees, sfx_mbees2}, chance = FRACUNIT/13,
func = function()
    local RanEffect = false
    local StatusEffect = nil
    local StatusRand = 1
    repeat
        StatusRand = P_RandomRange(1, #KhaosEffectsTable)
        StatusEffect = KhaosEffectsTable[StatusRand]
        if P_RandomChance(StatusEffect.chance) and not StatusEffect.nobees and GlobalNonConflict(StatusRand)
        and ((not StatusEffect.nobot) or (StatusEffect.nobot and botcount-1 < playercount/2)) -- don't roll nobot effects if half the server is bots.
        then
            RanEffect = true
        else
            return
        end
    until RanEffect

    if RanEffect then -- just for in case the loop somehow breaks early
        for player in players.iterate do
            if ValidityCheck(player) then
                if CheckNonConflict(player, StatusRand, 1) and not player.khaos.Freezer then
                    ApplyEffect(player, StatusEffect.name)
                else
                    ApplyEffect(player, "Effect Storage", {storeeffect = StatusRand, icon = StatusEffect.sprite})
                end
                local TheName = StatusEffect.name
                if tonumber(CV_FindVar("tkk_Amplify").value) and StatusEffect.amplifyname then
                    TheName = StatusEffect.amplifyname
                end
                player.khaos.UniEffectSubText = "\x82" + "Bees give everyone"+ "\x80:" + TheName
                player.khaos.UniEffecTextBufferNumber = 0
            end
        end
        RunFunc = nil
    end
end
}


addUniversalEffect{name = "Double Items", amplifyname = "Quadruple Items", subtext = {"Don't got one? Don't worry, it'll apply next time.", "Gee Bill, how come mom let's you get TWO items?"},
amplifysubtext = {"Don't got one? Don't worry, it'll apply next time.", "Gee Bill, how come mom let's you get FOUR items?"},
sounds = {sfx_cditem, sfx_cdite2}, amplifysounds = {sfx_cquadi, sfx_cquad2}, microsounds = {sfx_mditem, sfx_mdite2}, microamplifysounds = {sfx_mquadi, sfx_mquad2}, -- the price of having silly ideas
chance = FRACUNIT/19, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            ApplyEffect(player, "Double Items")
        end
    end
    RunFunc = nil
end
}

local TheExceptions = {"F_SKY%d",
"CHRGN%d%d", "CHRGN%d%ds",
"BOST%u%d%d",
"BOST%u%d%dS",
"BOST%u%d%dX",
"BOST%uD",
"DP_%d_M%u%d",
"SPRING%u%d",
"TRIPWIRE", "TWIRE%d%d", "VRIPWIRE", "VWIRE%d%d", "4RIPWIRE", "4WIRE%d%d",
"SPP32F%d", "SPP64F%d", "SPPING%u", "SPPING%uS",
"PITOFF", "SNOWOFF", --idk what these do, but they sound like they respawn the player, so... better safe than sorry?
"RINDRA%d%d", --i don't think this is actually used in any maps. but, maybe it is in custom maps.
}

local function Check4Exception(pic) -- slightly expensive operation, but this only runs on 1 tic so it should be fine.
    if P_RandomChance(FRACUNIT/69) then -- just to be a bit silly
        return false
    end
    for key, value in pairs(TheExceptions) do
        if string.find(pic, value) then
            return false
        end
    end
    return true
end

  addUniversalEffect{name = "Wacky Textures", subtext = {"why are the walls screaming?", "Using AI, you too can make maps this beautiful!", "You forgot to install Counter-Strike: Source.", "i will force you to touch grass"}, --"i made you a sneaker panel, but i eated it"
nosrb2kart = true,
sounds = {sfx_cwacky, sfx_cwack2}, microsounds = {sfx_mwacky, sfx_mwack2}, chance = FRACUNIT/101, func = function()
    local TheTables = {{"KH_BUP", "DEV_GA1", "BLUFLAT", "FINISH_W", "~113", "RINDRA00", "BPZFLD01", "BPZFLD04", "FFZGRSS2", "DVBR1C", "JPPI01", "SPWALG1"},
    {"KH_BUP"},
    --{"FINISH_W"}
    }

    local ListOfWacky = TheTables[P_RandomRange(1, #TheTables)]

    for sector in sectors.iterate do
        if Check4Exception(sector.floorpic) then
            sector.floorpic = ListOfWacky[P_RandomRange(1, #ListOfWacky)]
        end
        if Check4Exception(sector.ceilingpic) then
            sector.ceilingpic = ListOfWacky[P_RandomRange(1, #ListOfWacky)]
        end
    end

    for line in lines.iterate do
        if line.frontside and line.frontside.toptexture
        and Check4Exception(line.frontside.toptexture) then
            line.frontside.toptexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.frontside and line.frontside.midtexture
        and Check4Exception(line.frontside.midtexture) then
            line.frontside.midtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.frontside and line.frontside.bottomtexture
        and Check4Exception(line.frontside.bottomtexture) then
            line.frontside.bottomtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end

        if line.backside and line.backside.toptexture
        and Check4Exception(line.backside.toptexture) then
            line.backside.toptexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.backside and line.backside.midtexture
        and Check4Exception(line.backside.midtexture) then
            line.backside.midtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.backside and line.backside.bottomtexture
        and Check4Exception(line.backside.bottomtexture) then
            line.backside.bottomtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "Ka-boom!", subtext = {"\x85" + "CRITICAL SYSTEM ERROR 0x074115", "None of you are free from sin.", "Why did you sneeze that loud?", "kart hurting juice :(", "*Blood Explosion Spell*"}, hudtextprefix = "\202",
sounds = {sfx_ckabom, sfx_ckabo2}, microsounds = {sfx_mkabom, sfx_mkabo2}, chance = FRACUNIT/74, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            player.khaos.UniEffecTextBufferNumber = 9001 -- forcefully sets the text buffer to the end so the text actually shows up
            if VERSION < 2 then
                local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SSMINE)
                JankSplosion.target = player.mo
                P_KillMobj(JankSplosion)
                S_StartSound(player.mo, sfx_s3k4e)
            end
            P_KillMobj(player.mo)
        end
    end
    RunFunc = nil
end
}

addHook("MapChange", function() -- done solely because replays are fucking broken and it requires this
    ueTimer = 0
    ueTimerBuffer = 0
    ueTimerMax = tonumber(CV_FindVar("tkk_Universal_Timer").value) * TICRATE
    tkk_Enabled = tonumber(CV_FindVar("tkk_Enabled").value)
    initiateUE = false
    RunFunc = nil
    PreviousUniversalEffect = ""
    for player in players.iterate do
        player.khaos = nil
        player.khaosmemory = nil
        player.khaoseffects = nil
        player.khaostext = nil
    end
end)


-- gametype == GT_BATTLE

local prevtkk_Amplify = 0
local prevtkk_Enabled = 1

local function UEChecker(index)
    local StatusEffect = UniversalEffectsTable[index]

    if StatusEffect.requiredplayers and playercount < StatusEffect.requiredplayers then
        return false
    end

    if StatusEffect.gamemodeneedslives and not G_GametypeUsesLives() then
        return false
    end

    if StatusEffect.nobattle and gametype == GT_BATTLE then
        return false
    end


    return true
end

addHook("ThinkFrame", function()
    if (leveltime % TICRATE == 0) then -- don't spam it, it might cause unnessecary lag to check every tic
        ueTimerMax = tonumber(CV_FindVar("tkk_Universal_Timer").value) * TICRATE
        if prevtkk_Amplify != tonumber(CV_FindVar("tkk_Amplify").value) then
            prevtkk_Amplify = tonumber(CV_FindVar("tkk_Amplify").value)
            local Texter = "\x85" + "Amplify Mode" + "\x80" + " is now "
            local Sounder = sfx_tmxsuc
            if prevtkk_Amplify == 0 then
                Texter = $ + "\x82" + "deactivated."
            else
                Texter = "\202" + $ + "\x82" + "activated!!!"
                Sounder = sfx_gshd9
            end
            for player in players.iterate do
                if ValidityCheck(player) then
                    addHUDText(player, Texter, true)
                    S_StartSound(player.mo, Sounder, player)
                end
            end
        end
        if prevtkk_Enabled != tonumber(CV_FindVar("tkk_Enabled").value) then
            prevtkk_Enabled = tonumber(CV_FindVar("tkk_Enabled").value)
            local Texter = "\x82" + "Tails' Khaos Kontraption" + "\x80" + " will be "
            local Sounder = sfx_tmxsuc
            if prevtkk_Enabled == 0 then
                Texter = $ + "\x85" + "deactivated "
            else
                Texter = $ + "\x83" + "activated "
            end
            Texter = $ + "\x80" + "next round."
            chatprint("* " + Texter)
            for player in players.iterate do
                CONS_Printf(player, Texter)
                S_StartSound(player.mo, Sounder, player)
                if ValidityCheck(player) then
                    addHUDText(player, Texter, true)
                end
            end
        end
        botcount = 0
        playercount = 0
        hasanyonefinished = false
        for player in players.iterate do
            playercount = $ + 1
            if player.bot then
                botcount = $ + 1
            end
            if player.laps > numlaps or player.exiting then
                --print("SOMEONE FINISHED")
                hasanyonefinished = true
            end
        end
    end

    if not playercount then return end -- no players exist! assume this is the title screen.

    -- Universal Effects --
    if not tonumber(CV_FindVar("tkk_Universal_Fx_Enabled").value) or hasanyonefinished then TailsKK.ueTimerDisabled = true return end -- don't run if the option is disabled!
    ueTimer = $ + 1
    TailsKK.ueTimerDisabled = false

    if ueTimer > ueTimerMax and not initiateUE and not RunFunc then -- don't run if RunFunc is still going! hopefully the script didn't break
        if VERSION >= 2 then
            S_StartSoundAtVolume(nil, sfx_gshd2, 255) -- sfx_kc33, sfx_kc4b, sfx_kc5e, sfx_mbv85, sfx_kc47
            S_StartSoundAtVolume(nil, sfx_gshd2, 255) -- sfx_kc33, sfx_kc4b, sfx_kc5e, sfx_mbv85, sfx_kc47
        else
            S_StartSoundAtVolume(nil, sfx_kc47, 255)
        end
        for player in players.iterate do
            if ValidityCheck(player)
                if player.laps <= numlaps then
                    player.khaos.UniEffectText = "Rolling Universal Effect..."
                    -- reset everything just to make sure that the text actually shows up if the timer is set to be way too short somehow
                    player.khaos.UniPopUpTimer = 0
                    player.khaos.UniTextPopUpFade = 0
                    player.khaos.UniEffecTextBufferNumber = 1
                    player.khaos.UniEffectSubText = nil
                    player.khaos.UniEffectSubTextBuffer = ""
                end
            end
        end
        initiateUE = true
        ueTimer = 0
    end

    if initiateUE then
        local StatusRand = P_RandomRange(1, #UniversalEffectsTable)
        local StatusEffect = UniversalEffectsTable[StatusRand]
        ueTimer = 0 -- keep timer at 0, for in case it's taking extrodionarly long to roll an effect due to bad RNG

        if StatusEffect then -- sfx_s3kd2s
            if ueTimerBuffer > TICRATE then -- only apply after a second passes, should give enough time to plonk in the text
                if P_RandomChance(StatusEffect.chance) and StatusEffect.name != PreviousUniversalEffect and UEChecker(StatusRand) then
                    initiateUE = false
                    RunFunc = StatusRand

                    for player in players.iterate do
                        if ValidityCheck(player) then
                            local TheSnable = StatusEffect.sounds
                            if player.khaosoptions.tkk_Universal_Announcer then
                                TheSnable = StatusEffect.microsounds
                            end
                            if tonumber(CV_FindVar("tkk_Amplify").value) and StatusEffect.amplifysounds then
                                TheSnable = StatusEffect.amplifysounds
                                if player.khaosoptions.tkk_Universal_Announcer then
                                    TheSnable = StatusEffect.microamplifysounds
                                end
                            end
                            local TheSound = TheSnable[1]
                            if #TheSnable > 1 then
                                TheSound = TheSnable[P_RandomRange(1, #TheSnable)]
                            end

                            S_StartSoundAtVolume(nil, TheSound, 255, player) -- do it 4 times because sounds are quiet for no good reason
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                            if VERSION >= 2 then -- but only do it twice for ring racers, because SRB2Kart was sensible about it's sounds
                                S_StartSoundAtVolume(nil, TheSound, 255, player)
                                S_StartSoundAtVolume(nil, TheSound, 255, player)
                            end

                            player.khaos.UniEffectText = StatusEffect.name

                            if tonumber(CV_FindVar("tkk_Amplify").value) and StatusEffect.amplifyname then
                                player.khaos.UniEffectText = StatusEffect.amplifyname
                            end
                            if player.khaosoptions.tkk_HUD and player.khaosoptions.tkk_Print_Effect then
                                CONS_Printf(player, "*\x87 Universal Effect\x80: " .. player.khaos.UniEffectText)
                            end

                            if StatusEffect.hudtextprefix then
                                player.khaos.UniEffectText = StatusEffect.hudtextprefix + $
                            end

                            if StatusEffect.subtext then
                                local TheGlable = StatusEffect.subtext
                                if tonumber(CV_FindVar("tkk_Amplify").value) and StatusEffect.amplifysubtext then
                                    TheGlable = StatusEffect.amplifysubtext
                                end
                                player.khaos.UniEffectSubText = TheGlable[1]
                                if #TheGlable > 1 then
                                    local TheChosenOne = P_RandomRange(1, #TheGlable)
                                    player.khaos.UniEffectSubText = TheGlable[TheChosenOne]
                                end
                            else -- force clear
                                player.khaos.UniEffectSubText = ""
                            end
                            player.khaos.UniPopUpTimer = 0
                            player.khaos.UniTextPopUpFade = 0
                            player.khaos.UniEffecTextBufferNumber = 1
                        end

                        if player.spectator and VERSION >= 2 then
                            local TheSnable = StatusEffect.sounds
                            if tonumber(CV_FindVar("tkk_Universal_Announcer").value) then
                                TheSnable = StatusEffect.microsounds
                            end
                            local TheSound = TheSnable[1]
                            S_StartSoundAtVolume(nil, TheSound, 255, player) -- do it 4 times because sounds are quiet for no good reason
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                        end
                    end
                    if (replayplayback) and VERSION >= 2 then -- people watching replays can't hear the universal announcer sound. ...unless you're on srb2kart. wtf did y'all do to break this?
                        local TheSnable = StatusEffect.sounds
                        if tonumber(CV_FindVar("tkk_Universal_Announcer").value) then
                            TheSnable = StatusEffect.microsounds
                        end
                        local TheSound = TheSnable[1]
                        S_StartSoundAtVolume(nil, TheSound, 255) -- do it 4 times because sounds are quiet for no good reason
                        S_StartSoundAtVolume(nil, TheSound, 255)
                        S_StartSoundAtVolume(nil, TheSound, 255)
                        S_StartSoundAtVolume(nil, TheSound, 255)
                    end
                    PreviousUniversalEffect = StatusEffect.name
                    ueTimerBuffer = 0
                end
            else
                ueTimerBuffer = $ + 1
                ueTimer = 0 -- reset timer, just to be sure.
                return -- not sure what this is doing here actually. i think it's to stop runfunc from going ahead?
            end
        end
    end

    if RunFunc then
        UniversalEffectsTable[RunFunc].func()
    end

    TailsKK.ueTimer = ueTimer
    TailsKK.ueTimerMax = ueTimerMax
    TailsKK.PreviousUniversalEffect = PreviousUniversalEffect
end)

addHook("MobjThinker", function(aggressive) -- this code is directly lifted from my MMT script, i have no shame
    if aggressive.valid and aggressive.target and aggressive.target.valid then
        if not aggressive.initializedtime then
            aggressive.shadowscale = 3*mapobjectscale
            if aggressive.sizeoption == "large" then
                aggressive.speed = 140*mapobjectscale
                aggressive.scale = mapobjectscale + mapobjectscale*(2/4)
            elseif aggressive.sizeoption == "medium" then
                aggressive.speed = 180*mapobjectscale
                aggressive.scale = mapobjectscale
            elseif (aggressive.sizeoption == "small" or aggressive.sizeoption == "personal") then
                aggressive.speed = 250*mapobjectscale
                aggressive.scale = mapobjectscale/2
            elseif (aggressive.sizeoption == "xl" or aggressive.sizeoption == "extra large" or aggressive.sizeoption == "extralarge") then
                aggressive.speed = 140*mapobjectscale
                aggressive.scale = mapobjectscale*2
            else
                aggressive.speed = 280*mapobjectscale
                aggressive.scale = mapobjectscale/2
            end
            aggressive.ogspeed = aggressive.speed
            aggressive.initializedtime = true
        end
        if not aggressive.rollanglesprite then
            aggressive.rollanglesprite = 0
        end
        aggressive.rollanglesprite = $ + ANG15

        if aggressive.state != S_CHAOTICPIZZAFACE then
            aggressive.rollangle = aggressive.rollanglesprite
        end

        if isPlayerRespawning(aggressive.target.player) or aggressive.target.player.playerstate != PST_LIVE then --slow down if the player is respawning or dead
            aggressive.speed = aggressive.ogspeed / 10
        else
            aggressive.speed = aggressive.ogspeed
        end

        if (R_PointToDist2(aggressive.target.x, aggressive.target.y, aggressive.x, aggressive.y))/mapobjectscale < 35 and
        (abs((aggressive.target.z - aggressive.z)/mapobjectscale) < 25) and (aggressive.target.player and aggressive.target.player.playerstate == PST_LIVE)
        and not aggressive.Remove
        and not isPlayerRespawning(aggressive.target.player) then
            P_DamageMobj(aggressive.target, aggressive, aggressive, DMG_NORMAL)

            S_StartSound(aggressive.target, sfx_chapki)
            if aggressive.state == S_CHAOTICXPLOSPIZZA then
                local Explode = P_SpawnMobj(aggressive.target.x, aggressive.target.y, aggressive.target.z, MT_BOSSEXPLODE)
                S_StartSound(Explode, sfx_bkpoof) -- only just now realizing this didn't fucking play the sound because i typo'd the variable name. 3 years this typo existed! 3 years!!!
                Explode.destscale = 5*mapobjectscale
                Explode.scalespeed = FRACUNIT/7
            end
            aggressive.target.player.khaos.PizzaHitTarget = true
            aggressive.Remove = true
        end

        if aggressive.target and not aggressive.target.player.khaos.PizzaRemoval then
            A_HomingChase(aggressive, aggressive.speed, 0)
        else
            P_RemoveMobj(aggressive)
        end
    else
        P_RemoveMobj(aggressive)
    end
end, MT_JIMBO)

addHook("MobjThinker", function(cs)
    if cs.despawn then P_RemoveMobj(cs) return end
    if not cs.gayer then P_RemoveMobj(cs) return end
    if not cs.gayer.valid then P_RemoveMobj(cs) return end
    if cs.gayer.RemoveChangeSprite then P_RemoveMobj(cs) return end
    local player = cs.gayer

    -- replicate a lot of player stuff here
    P_MoveOrigin(cs, player.mo.x, player.mo.y, player.mo.z)
    cs.shadowscale = player.mo.shadowscale
    if cs.summonedasstate != S_CHAOSMAC then
        cs.scale = player.mo.scale
    else
        cs.scale = player.mo.scale/2
        cs.shadowscale = player.mo.shadowscale*4
    end
    if cs.summonedasstate != S_CHAOSWIN9X
        cs.color = player.mo.color
    end
    cs.spritexoffset = player.mo.spritexoffset
    cs.spriteyoffset = player.mo.spriteyoffset
    cs.spritexscale = player.mo.spritexscale
    cs.spriteyscale = player.mo.spriteyscale
    cs.angle = player.drawangle or player.mo.angle
    --cs.rollangle = player.mo.rollangle -- doesn't work?
    --cs.flags = player.mo.flags
    cs.flags2 = player.mo.flags2 & MF2_OBJECTFLIP
    cs.eflags = player.mo.eflags & MFE_VERTICALFLIP
    cs.renderflags = player.mo.renderflags & RF_SHADOWDRAW
    --cs.eflags = player.mo.eflags
    if cs.Blinker then
        cs.renderflags = $ | RF_DONTDRAW
    else
        cs.renderflags = $ & ~RF_DONTDRAW
    end

    if cs.summonedasstate == S_CHAOTICPIZZA then
        cs.rollangle = $ + ANG15
    end

    if cs.summonedasstate == S_SOSS_RUN1 then -- summoned ass tate
        if player.speed/FRACUNIT == 0 then
            cs.tics = -1
        else
            if cs.tics == -1 then
                cs.tics = 1
            end
            if player.speed-2*FRACUNIT >= 10*FRACUNIT and cs.tics == 3 then
                cs.tics = 2
            end
        end
    elseif (cs.summonedasstate == S_YHORIZ1 or cs.summonedasstate == S_YELLOWSPRING1) then
        if abs(player.mo.momz) > 0 and not cs.sprung then
            if cs.summonedasstate == S_YHORIZ1 then
                cs.state = S_YHORIZ2
            else
                cs.state = S_YELLOWSPRING2
            end
            cs.sprung = true
        end
    end

    if P_IsObjectOnGround(player.mo) then
        cs.sprung = false
    end

end, MT_CHANGESPRITE)

addHook("MobjThinker", function(mo)
    if mo.despawn then P_RemoveMobj(cs) return end
    if not mo.gayer then P_RemoveMobj(cs) return end
    if not mo.gayer.valid then P_RemoveMobj(cs) return end

    local player = mo.gayer
    if not mo.initialized then
        --P_MoveOrigin(mo, player.mo.x, player.mo.y, player.mo.z)
        mo.skin = player.mo.skin
        mo.state = player.mo.state
        mo.sprite2 = player.mo.sprite2
        --mo.sprite = player.mo.sprite
        mo.color = player.mo.color
        mo.angle = player.mo.angle
        mo.scale = player.mo.scale
        mo.spritexoffset = player.mo.spritexoffset
        mo.spriteyoffset = player.mo.spriteyoffset
        mo.colorized = player.mo.colorized
        --mo.flags = player.mo.flags
        --mo.flags2 = player.mo.flags2
        mo.eflags = player.mo.eflags
        mo.rollangle = player.mo.rollangle
        mo.initialized = true
    end

end, MT_LAGPLAYER)

addHook("MobjThinker", function(mo)
    if mo.despawn then P_RemoveMobj(mo) return end
    if not mo.gayer then P_RemoveMobj(mo) return end
    if not mo.gayer.valid then P_RemoveMobj(mo) return end

    local player = mo.gayer

    mo.angle = player.mo.angle
    mo.scale = player.mo.scale/2
    mo.spritexoffset = player.mo.spritexoffset
    mo.spriteyoffset = player.mo.spriteyoffset
    mo.eflags = player.mo.eflags
    mo.rollangle = player.mo.rollangle

    local zoffset = 105*mo.scale
    if (mo.flags2 & MF2_OBJECTFLIP) or (mo.eflags & MFE_VERTICALFLIP) then
        zoffset = $ * -1
    end

    P_MoveOrigin(mo, player.mo.x, player.mo.y, player.mo.z+zoffset)

end, MT_MARKED4DEATH)

addHook("MobjThinker", function(mo)
    if mo.despawn then P_RemoveMobj(mo) return end
    if not mo.gayer then P_RemoveMobj(mo) return end
    if not mo.gayer.valid then P_RemoveMobj(mo) return end

    local player = mo.gayer

    if not mo.timer then
        mo.scale = player.mo.scale
        mo.scaleresizer = player.mo.scale
        mo.timer = 0
        mo.funnyoffset = 0
    end

    mo.timer = $ + 1

    local themultiplier = 1

    if (mo.flags2 & MF2_OBJECTFLIP) or (mo.eflags & MFE_VERTICALFLIP) then
        themultiplier = -1
    end

    if mo.timer < (TICRATE)-4 then
        mo.scale = $ - mo.scaleresizer/37
    else
        mo.funnyoffset = $ + (16*mo.scale *themultiplier)
    end


    P_MoveOrigin(mo, player.mo.x, player.mo.y, player.mo.z+mo.funnyoffset)

    if mo.timer > 4*TICRATE then
        P_RemoveMobj(mo)
    end

end, MT_KHAOSMINICRIT)


addHook("MobjDamage", function(mo)
    local player = mo.player
    if not player then return end
    if not player.khaos then return end -- just in case
    if (not player.flashing or player.khaos.DodgeHit) and ((player.khaos.IsLucky and P_RandomChance(FRACUNIT/2 + FRACUNIT/8)) or player.khaos.DodgeHit) then -- not P_PlayerInPain(player) and
        player.spinouttype = KSPIN_IFRAMES -- required to have player.flashing not get immediately reset to 0
        player.flashing = 76
        if not player.khaos.DodgeHit and player.khaos.IsLucky then
            S_StartSound(player.mo, sfx_s3k7a)
            addHUDText(player, "Dodged a hit, lucky!", true)
        end
        return true -- by returning, we override the rest of mobjdamage's functions, ergo no damage
    end
    if player.khaos.ImDyingSquirtle then
        player.khaos.Tumbler = $ + 2
        if player.khaos.Tumbler < 15 -- stops the player from being whacked too much... hopefully.
            local thing = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+32*player.mo.scale, MT_KHAOSMINICRIT)
            thing.gayer = player
            S_StartSound(player.mo, sfx_chmini)
            K_TumblePlayer(player)
        end
    end
end, MT_PLAYER)

local function SanityCheck(var1, var2) -- this is here to prevent players from loading invalid settings
    local var1place = false
    for index, value in ipairs(optionstableofdoom) do
        if var1 == value.name then
            var1place = index
        end
    end

    if var1place then
        local snable = optionstableofdoom[var1place]
        if snable.localonly then return false end -- don't load local variables. TODO: allow this to be loaded by admins?
        if (snable.typer == "number" and tonumber(var2) != nil) and (tonumber(var2) >= snable.values[1] and tonumber(var2) <= snable.values[2]) then
            return true
        end
        if snable.typer == "string" then
            local var2exists = false
            for key, value in pairs(snable.values) do
                if value == var2 then
                    var2exists = true
                end
            end
            return var2exists
        end
    end

    return false
end

local function numbercunktion(player, var1, var2)
    if var1 == nil or var2 == nil or not SanityCheck(var1, var2) then
        CONS_Printf(player, "\x85" + "* INVALID SETTINGS: \x80" .. tostring(var1) .. ", " .. tostring(var2))
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    if player and player.khaosoptions then player.khaosoptions[var1] = tonumber(var2) end
end

local function stringcunktion(player, var1, var2)
    if var1 == nil or var2 == nil or not SanityCheck(var1, var2) then
        CONS_Printf(player, "\x85" + "* INVALID SETTINGS: \x80" .. tostring(var1) .. ", " .. tostring(var2))
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    if player and player.khaosoptions then player.khaosoptions[var1] = tostring(var2) end
end

local commandfunny = nil

if VERSION >= 2 then
    COM_AddCommand("zkhaosDONOTUSEMEPLEASE1", numbercunktion, COM_NOSHOWHELP)
    COM_AddCommand("zkhaosDONOTUSEMEPLEASE2", stringcunktion, COM_NOSHOWHELP)
else
    COM_AddCommand("zkhaosDONOTUSEMEPLEASE1", numbercunktion)
    COM_AddCommand("zkhaosDONOTUSEMEPLEASE2", stringcunktion)
end


if VERSION >= 2 then
    COM_AddCommand("tkk_Load_Settings", LoadSettings)
    COM_AddCommand("tkk_Save_Settings", SaveSettings)
end

COM_AddCommand("tkk_Attributions", function(player)
    for key, value in pairs(TailsKK.attributions) do
        CONS_Printf(player, "* \x82"+value[1]+"\x80: "+value[2])
    end
end)

local function TheNumberFeeder(var)
    if consoleplayer then -- stops this thing from bitching in the logs
        COM_BufInsertText(consoleplayer, "zkhaosDONOTUSEMEPLEASE1 " + var.name + " " + var.value)
        --CONS_Printf(consoleplayer, "zkhaosDONOTUSEMEPLEASE1 " + var.name + " " + var.value)
    end
end

local function TheStringFeeder(var)
    if consoleplayer then
        COM_BufInsertText(consoleplayer, "zkhaosDONOTUSEMEPLEASE2 " + var.name + " " + var.value)
        --CONS_Printf(consoleplayer, "zkhaosDONOTUSEMEPLEASE2 " + var.name + " " + var.value)
    end
end

COM_AddCommand("tkk_Blacklist_Change", function(player, var1, silent)
    local effecter = (var1 and indexOfName2(KhaosEffectsTable, var1))
    --[[if not effecter then
        CONS_Printf(player, "* \x85"+"Invalid effect name!\x80" + "Be sure to use \"quotation marks\"! Use \"tkk_List_Effects\" to show all effect names.")
        return
    else
        effecter = KhaosEffectsTable[effecter]
    end]]
    if var1 then
        effecter = KhaosEffectsTable[effecter]
    else
        local silly = tonumber(CV_FindVar("tkk_Blacklist_Set").value)
        for key, value in pairs(CV_TKKBlackList) do
            if value == silly then
                silly = key
            end
        end
        effecter = KhaosEffectsTable[indexOfName2(KhaosEffectsTable, silly)]
    end

    if not effecter then
        CONS_Printf(player, "* \x85"+"Invalid effect name: \x80\"\x82" + var1 + "\x80\" Be sure to use \"quotation marks\"! Use \"tkk_List_Effects\" to show all effect names.") -- this assumes var1 exists. if it doesn't, then i fucked up big time
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    --print(effecter.name)
    --print(indexOfName2(KhaosEffectsTable, TheName))

    local TheName = effecter.name

    if effecter.noblacklist then
        CONS_Printf(player, "* \x85"+"ERROR:\x80" + " You can't set this effect to be blacklisted.")
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    if not ValidityCheck(player) then
        CONS_Printf(player, "* \x85"+"ERROR:\x80" + " You must be in-game for this to be changed.")
        return
    end

    local alreadyexists = false

    for idx, value in ipairs(player.khaosblacklist) do
        if value == TheName then
            table.remove(player.khaosblacklist, idx)
            alreadyexists = true
        end
    end

    if alreadyexists then
        if not silent then CONS_Printf(player, "* \x84"+"Removed: \x80 " + effecter.name) end
    else
        table.insert(player.khaosblacklist, TheName)
        if not silent then CONS_Printf(player, "* \x84"+"Added: \x80 " + effecter.name) end
    end

    if not silent then
        local name = "client/tailskhaoskontraption/" .. "tkkBlackList" .. ".dat"
        local savefile = io.openlocal(name, "w")
        if savefile != nil then
            for key, value in pairs(player.khaosblacklist) do
                savefile:write(value)
                savefile:write("\n")
            end
        end

        --CONS_Printf(player, "* \x83"+"\x80" + "Saved blacklist options!")
    end
end)

COM_AddCommand("tkk_Blacklist_Show", function(player)
    if not ValidityCheck(player) then
        CONS_Printf(player, "* \x85"+"ERROR:\x80" + " You must be in-game to use this.")
        return
    end

    for idx, value in ipairs(player.khaosblacklist) do
        CONS_Printf(player, "* \x83" + value)
    end
end)

COM_AddCommand("tkk_List_Effects", function(player) --if it exceeds 70 characters, line break
    local TableMan = {}
    local StringLength = 0
    local TableInd = 1
    for index, value in ipairs(KhaosEffectsTable) do
        local comma = "\x80, "
        if index == 1 then
           comma = ""
        end
        local Phrase = "\x82" + value.name + comma
        local ThisLength = string.len(Phrase)
        if StringLength + ThisLength > 70 then
            StringLength = 0
            TableInd = $ + 1
        end
        TableMan[TableInd] = (TableMan[TableInd] and Phrase + $) or (Phrase)
        StringLength = $ + ThisLength
    end
    CONS_Printf(player, "* \x83" + "List of Khaos Effects:")
    for i = #TableMan, 1, -1 do
        CONS_Printf(player, "\x81" + TableMan[i])
    end
end)

COM_AddCommand("tkk_What_Is", function(player, var1)
    local effecter = var1 and indexOfName2(KhaosEffectsTable, var1)
    if not effecter then
        CONS_Printf(player, "* \x85"+"Invalid effect name!\x80" + "Be sure to use \"quotation marks\"! Use \"tkk_List_Effects\" to show all effect names.")
        return
    else
        effecter = KhaosEffectsTable[effecter]
    end
    local description = ""

    if effecter.description then
        description = effecter.description
    else
        description = "Sorry, this effect doesn't have a description yet!"
    end

    local Color = "\x86"
    if effecter.etype == "good" then
        Color = "\x83"
    elseif effecter.etype == "bad" then
        Color = "\x85"
    end

    CONS_Printf(player, "*\x81 Name" + "\x80: " + Color + effecter.name)
    if effecter.amplifyname then
        CONS_Printf(player, "*\x81 Amplify Name" + "\x80: " + Color + effecter.amplifyname)
    end
    CONS_Printf(player, "*\x81 Description" + "\x80: " + description)

    local Duration = (effecter.duration < 0 and "Infinite")
    or (effecter.duration == 1 and tostring(effecter.duration) + " second")
    or (effecter.duration > 1 and tostring(effecter.duration) + " seconds")
    or "Instant"

    if effecter.duration > 0 and effecter.range then
        local mintime = max(effecter.duration - (effecter.range/3), effecter.duration/2 + 1) -- done to prevent effect from going under half it's time
        local maxtime = effecter.duration + (effecter.range + 2)
        Duration = mintime + "-" + maxtime + " seconds"
    end
    CONS_Printf(player, "*\x81 Duration" + "\x80: " + Duration)


    if effecter.incompatible then
        local incompat = ""
        for index, value in ipairs(effecter.incompatible) do
            incompat = $ + value
            if index != #effecter.incompatible then
                incompat = $ + ", "
            end
        end
        CONS_Printf(player, "*\x81 Incompatible Effects" + "\x80: " + incompat)
    end

    local Attributes = {}

    if effecter.addition then
        local secondman = " second"
        local lengthener = " more"
        if abs(effecter.addition) > 1 then
            secondman = " seconds"
        end
        if effecter.addition < 0 then
            lengthener = " less"
        end
        table.insert(Attributes, " * Lasts " + abs(effecter.addition) + secondman + lengthener + " in Amplify Mode.")
    end

    local AttributeCompareTable =
    {
    amplifyonly = " * Amplify Mode exclusive effect.",
    drainrespawntimer = " * Timer goes down during respawn.",
    noblacklist = " * Can't be blacklisted.",
    dontrollme = " * Can't be rolled for by the Roulette.",
    nobees = " * Can't be rolled for by \"You Get The Bees\".",
    grounded = " * Player needs to be on ground for this to apply.",
    immune2remove = " * Can't be removed by \"Remove Random Effect\"",
    --beyond this point is only nessecary for ring racers, but idk any non-jank way to stop this from appearing in srb2kart
    noghost = " * Player can't have been affected by a Hyudoro.",
    requirerings = " * Requires >1 ring to apply.",
    nospecialstage = " * Doesn't apply in special stages.",
    nobattle = " * Doesn't apply in battle mode.",
    battleonly = " * Battle mode exclusive effect.",
    nobot = " * Can't be applied to bots.",
    }

    for key, value in pairs(AttributeCompareTable) do
        if effecter[key] then
            table.insert(Attributes, value)
        end
    end

    if #Attributes > 0 then
        CONS_Printf(player, "*\x81 Attributes" + "\x80:")
        for index, value in ipairs(Attributes) do
            CONS_Printf(player, value)
        end
    end
end)

--NOTICE: When adding/modifying options, be sure to put it in "optionstableofdoom", otherwise it won't work.

CV_RegisterVar({name = "tkk_Enabled", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "If disabled, the chaos mod will be turned off on the next map."})
CV_RegisterVar({name = "tkk_Amplify", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "Makes most effects more intense, often worse."})
CV_RegisterVar({name = "tkk_Universal_Timer", defaultvalue = 45, PossibleValue = {MIN = 10, MAX = 100}, flags = CV_NETVAR, description = "Sets the timer for when Universal Effects are rolled for."})
CV_RegisterVar({name = "tkk_Universal_Fx_Enabled", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "If disabled, Universal Effects will be disabled."})
CV_RegisterVar({name = "tkkDebug", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "Enables debugging features like printing."})

CV_RegisterVar({name = "tkk_Memory", defaultvalue = 9, PossibleValue = {MIN = 0, MAX = 14}, func = TheNumberFeeder, flags = CV_CALL, description = "Sets how many effects are remembered to not roll for."})
CV_RegisterVar({name = "tkk_Universal_Announcer", defaultvalue = 0, PossibleValue = {original = 0, micro = 1}, func = TheNumberFeeder, flags = CV_CALL, description = "Changes the voice of the announcer for Universal Effects."})
CV_RegisterVar({name = "tkk_Print_Effect", defaultvalue = 1, PossibleValue = CV_OnOff, func = TheNumberFeeder, flags = CV_CALL, description = "Prints to the console when you get an effect applied to you."})
CV_RegisterVar({name = "tkk_Roulette_SFX", defaultvalue = 1, PossibleValue = CV_OnOff, func = TheNumberFeeder, flags = CV_CALL, description = "Plays little sounds when the roulette is active."})
CV_RegisterVar({name = "tkk_HUD", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "If changed, the HUD will be disabled, and most sounds won't play."})

CV_RegisterVar({name = "tkk_Blacklist_Set", defaultvalue = 0, PossibleValue = CV_TKKBlackList, flags = CV_CALL, func = TheNumberFeeder, description = "Use 'tkk_Blacklist_Change' to add/remove this effect from your blacklist."})

CV_RegisterVar({name = "tkk_HUD_Timer_Bar", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "If changed, the visual timer between effects will be disabled."})
CV_RegisterVar({name = "tkk_HUD_Position", defaultvalue = 0, PossibleValue = {bottom = 0 , top = 1}, flags = CV_CALL, func = TheNumberFeeder, description = "Changes the position of the effects and timerbar."})
CV_RegisterVar({name = "tkk_HUD_Text_Border", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "Enables a border around the text on the HUD."})
CV_RegisterVar({name = "tkk_HUD_Override", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "When spectating/viewing replays, your HUD settings will take priority."})
CV_RegisterVar({name = "tkk_HUD_Timer_Color", defaultvalue = 0, PossibleValue = {player = 0, rainbow = 1, classic = 2}, flags = CV_CALL, func = TheNumberFeeder, description = "Changes the colors of the timer bar."})

addHook("NetVars", function(net) -- DO NOT TRY TO USE NETVARS TO SYNC FUNCTIONS. THIS WILL FAIL.
    PreviousUniversalEffect = net(PreviousUniversalEffect)
    RunFunc = net(RunFunc)
    ueTimer = net(ueTimer)
    ueTimerBuffer = net(ueTimerBuffer)
    ueTimerMax = net(ueTimerMax)
    initiateUE = net(initiateUE)
    botcount = net(botcount)
    playercount = net(playercount)
    hasanyonefinished = net(hasanyonefinished)
    tkk_Enabled = net(tkk_Enabled)

    --KhaosEffectsTable = net(KhaosEffectsTable) -- < NOTICE: DO NOT DO THIS UNDER ANY FUCKING CIRCUMSTANCES.
end)

table.insert(TextBoxTable, -- at the bottom just so we get an accurate count of all effects
{{"Did you know? You are",
"playing " + "\x87" + "Tails' Khaos",
"\x87"+ "Kontraption " + "\x81" + TailsKK.version + "\x80" + ",",
"with \x85" + KhaosTotal + "\x80 effects!"},
{"This was rewritten from",
"the ground up in a few",
"weeks! Now you know!",""}}
)

table.insert(optionstableofdoom, {name = "tkk_Blacklist_Set", values = {0, BlackListLength}, typer = "number", dontsave = true})

COM_AddCommand("tkk_Help", function(player, var1)
    CONS_Printf(player, "\x83 Specify 1 or 2 for pages!")

    if not var1 or tonumber(var1) == 1 then
        CONS_Printf(player, "List of commands: ")
        CONS_Printf(player, "* " + "tkk_Attributions")
        CONS_Printf(player, "* " + "tkk_Blacklist_Change")
        CONS_Printf(player, "* " + "tkk_Blacklist_Show")
        CONS_Printf(player, "* " + "tkk_List_Effects")
        CONS_Printf(player, "* " + "tkk_What_Is")
        CONS_Printf(player, "* " + "tkk_Save_Settings")
        CONS_Printf(player, "* " + "tkk_Load_Settings")
    end

    if tonumber(var1) == 2 then
        CONS_Printf(player, "List of convars: ")
        for key, value in pairs(optionstableofdoom) do
            CONS_Printf(player, "* " + value.name)
        end
    end

    CONS_Printf(player, "Tails' Khaos Kontraption v" .. TailsKK.version ..", effects count: " .. KhaosTotal .. ", & universal effects: " .. #UniversalEffectsTable)
end)



LoadSettings() -- force load the cvars

print("Tails' Khaos Kontraption v" .. TailsKK.version .." loaded! Total number of effects: " .. KhaosTotal .. ", and universal effects: " .. #UniversalEffectsTable)


-- DEBUG TOOL USED TO SEE IF THERE'S ANY INCOMPATIBLE EFFECTS THAT DON'T ACTUALLY EXIST
--[[local FunnyFumber = 0

repeat
    FunnyFumber = $ + 1
    local Gexfect = KhaosEffectsTable[FunnyFumber]
    if Gexfect.incompatible then
        for key, value in pairs(Gexfect.incompatible) do
            local ThePlacer = indexOfName(KhaosEffectsTable, value)
            if not ThePlacer then
                print("INVALID INCOMPATIBLE EFFECT: " + value, ", FOR: " + Gexfect.name)
            end
        end
    end

until FunnyFumber == #KhaosEffectsTable]]
